-- INNODB is required for FOREIGN KEY CONSTRAINTS and AUTO_INCREMENT.
SET storage_engine=INNODB;

DELIMITER $$

CREATE PROCEDURE cleanup_report_table_constraints ()
BEGIN
    DECLARE table_count INT;

    -- followed by any primary key, auto_increment, unique constraints or indexes
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imreport6' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        ALTER TABLE imreport6 MODIFY imr_reportid INT NOT NULL;
        ALTER TABLE imreport6 DROP PRIMARY KEY;
        DROP INDEX imreport6_index_1 ON imreport6;
        DROP INDEX imreport6_index_2 ON imreport6;
        DROP INDEX imreport6_index_3 ON imreport6;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrrole6' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        ALTER TABLE imrrole6 DROP PRIMARY KEY;
        DROP INDEX imrrole6_index_1 ON imrrole6;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrrolerule6' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        ALTER TABLE imrrolerule6 DROP PRIMARY KEY;
        DROP INDEX imrrolerule6_index_1 ON imrrolerule6;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrrolescoperule6' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        ALTER TABLE imrrolescoperule6 DROP PRIMARY KEY;
        DROP INDEX imrrolescoperule6_index_1 ON imrrolescoperule6;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrroletask6' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        ALTER TABLE imrroletask6 DROP PRIMARY KEY;
        DROP INDEX imrroletask6_index_1 ON imrroletask6;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrrolemember6' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        DROP INDEX imrrolemember6_index_1 ON imrrolemember6;
        DROP INDEX imrrolemember6_index_2 ON imrrolemember6;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrroleadmin6' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        DROP INDEX imrroleadmin6_index_1 ON imrroleadmin6;
        DROP INDEX imrroleadmin6_index_2 ON imrroleadmin6;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrroleowner6' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        DROP INDEX imrroleowner6_index_1 ON imrroleowner6;
        DROP INDEX imrroleowner6_index_2 ON imrroleowner6;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrorg6' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        DROP INDEX imrorg6_index_1 ON imrorg6;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrorgattr6' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        DROP INDEX imrorgattr6_index_2 ON imrorgattr6;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrgroup6' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        DROP INDEX imrgroup6_index_1 ON imrgroup6;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrgroupattr6' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        DROP INDEX imrgroupattr6_index_2 ON imrgroupattr6;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrgroupmember6' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        DROP INDEX imrgroupmember6_index_2 ON imrgroupmember6;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrgroupadmin6' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        DROP INDEX imrgroupadmin6_index_2 ON imrgroupadmin6;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imruser6' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        DROP INDEX imruser6_index_1 ON imruser6;
        DROP INDEX imruser6_index_2 ON imruser6;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrptsnapshots12' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        DROP INDEX imrptsnapshots12_index_1 ON imrptsnapshots12;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrtask6' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        ALTER TABLE imrtask6 DROP PRIMARY KEY;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imridentitypolicy6' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        ALTER TABLE imridentitypolicy6 DROP PRIMARY KEY;
        DROP INDEX imridentitypolicy6_index_1 ON imridentitypolicy6;
        DROP INDEX imridentitypolicy6_index_2 ON imridentitypolicy6;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imridentitypolicyset6' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        ALTER TABLE imridentitypolicyset6 DROP PRIMARY KEY;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imridentitypolicyactions6' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        ALTER TABLE imridentitypolicyactions6 DROP PRIMARY KEY;
        DROP INDEX imrpolicyactions6_index_1 ON imridentitypolicyactions6;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imridentitypolicyusersync6' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        ALTER TABLE imridentitypolicyusersync6 DROP PRIMARY KEY;
        DROP INDEX imrpolicyusersync6_index_1 ON imridentitypolicyusersync6;
        DROP INDEX imrpolicyusersync6_index_2 ON imridentitypolicyusersync6;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrpolicyxpress125' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        ALTER TABLE imrpolicyxpress125 DROP PRIMARY KEY;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrreversesyncmodifyaccount125' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        ALTER TABLE imrreversesyncmodifyaccount125 DROP PRIMARY KEY;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrreversesyncnewaccount125' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        ALTER TABLE imrreversesyncnewaccount125 DROP PRIMARY KEY;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imremailmanagement125' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        ALTER TABLE imremailmanagement125 DROP PRIMARY KEY;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrbulktasks125' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        ALTER TABLE imrbulktasks125 DROP PRIMARY KEY;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrattribute' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        DROP INDEX imrattribute_index_1 ON imrattribute;
        DROP INDEX imrattribute_index_2 ON imrattribute;
        DROP INDEX imrattribute_index_3 ON imrattribute;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrAttributeInfo' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        ALTER TABLE imrAttributeInfo MODIFY imr_attrinfoid INT NOT NULL;
        ALTER TABLE imrAttributeInfo DROP PRIMARY KEY;
        DROP INDEX imrattributeinfo_index_1 ON imrattributeinfo;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrobjectcategory' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        DROP INDEX imrobjectcategory_index_1 ON imrobjectcategory;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrProvRolesRelationship' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        DROP INDEX imrprovrolesrel_index_1 ON imrProvRolesRelationship;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrprovroletemplrelationship' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        DROP INDEX imrprovroletemplrel_index_1 ON imrprovroletemplrelationship;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imruseraccountrelationship' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        DROP INDEX imruseraccountrel_index_1 ON imruseraccountrelationship;
        DROP INDEX imruseraccountrel_index_2 ON imruseraccountrelationship;
        DROP INDEX imruseraccountrel_index_3 ON imruseraccountrelationship;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrtemplendpointrelationship' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        DROP INDEX imrtemplendpointrel_index_1 ON imrtemplendpointrelationship;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrAccountTemplateRel' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        DROP INDEX imrAccountTemplateRel_index_1 ON imrAccountTemplateRel;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrcapabilityattrrel' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        DROP INDEX imrcapabilityattrrel_index_1 ON imrcapabilityattrrel;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrroleattr12' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        DROP INDEX imrroleattr12_index_1 ON imrroleattr12;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrNonStandardAccts' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        DROP INDEX imrNonStandardAccts_index_1 ON imrNonStandardAccts;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrObject' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        ALTER TABLE imrObject MODIFY imr_objectid INT NOT NULL;
        ALTER TABLE imrObject DROP PRIMARY KEY;
        DROP INDEX imrobject_index_1 ON imrobject;
        DROP INDEX imrobject_index_2 ON imrobject;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'imrObjectInfo' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        ALTER TABLE imrObjectInfo MODIFY imr_objectid INT NOT NULL;
        ALTER TABLE imrObjectInfo DROP PRIMARY KEY;
        DROP INDEX imrobjectinfo_index_1 ON imrobjectinfo;
    END IF;
END$$

DELIMITER ;

-- Call it...
CALL cleanup_report_table_constraints();

-- ...then drop it.
DROP PROCEDURE IF EXISTS cleanup_report_table_constraints;

-- drop views
DROP VIEW IF EXISTS imrroleinfo6;
DROP VIEW IF EXISTS imruseraccounts6;
DROP VIEW IF EXISTS imraccountattrs6;
DROP VIEW IF EXISTS endpointaccountattrs6;
DROP VIEW IF EXISTS endpointuseraccounts6;
DROP VIEW IF EXISTS endPointAttributes;
DROP VIEW IF EXISTS accttmplattribute;
DROP VIEW IF EXISTS endpointaccount;
DROP VIEW IF EXISTS endpointview;
DROP VIEW IF EXISTS provrolesrelationshipview;
DROP VIEW IF EXISTS accttemplEndpointRelView;
DROP VIEW IF EXISTS capabilityattrsview;
DROP VIEW IF EXISTS provroleaccttmplendptrelview;
DROP VIEW IF EXISTS exceptionaccountsview;
DROP VIEW IF EXISTS endpointexceptionuseraccounts6;
DROP VIEW IF EXISTS totalExceptionAccounts;


-- drop tables
DROP TABLE IF EXISTS imreport_version;
DROP TABLE IF EXISTS imreport6;
DROP TABLE IF EXISTS imrrole6;
DROP TABLE IF EXISTS imrrolerule6;
DROP TABLE IF EXISTS imrrolescoperule6;
DROP TABLE IF EXISTS imrroletask6;
DROP TABLE IF EXISTS imrtask6;
DROP TABLE IF EXISTS imrrolemember6;
DROP TABLE IF EXISTS imrroleadmin6;
DROP TABLE IF EXISTS imrroleowner6;
DROP TABLE IF EXISTS imrorg6;
DROP TABLE IF EXISTS imrorgattr6;
DROP TABLE IF EXISTS imrgroup6;
DROP TABLE IF EXISTS imrgroupattr6;
DROP TABLE IF EXISTS imrgroupmember6;
DROP TABLE IF EXISTS imrgroupadmin6;
DROP TABLE IF EXISTS imruser6;
DROP TABLE IF EXISTS imruserattr6;
DROP TABLE IF EXISTS imridentitypolicy6;
DROP TABLE IF EXISTS imridentitypolicyset6;
DROP TABLE IF EXISTS imridentitypolicyactions6;
DROP TABLE IF EXISTS imridentitypolicyusersync6;
DROP TABLE IF EXISTS imrptsnapshots12;
DROP TABLE IF EXISTS imrAttribute;
DROP TABLE IF EXISTS imrAttributeInfo;
DROP TABLE IF EXISTS imrObject;
DROP TABLE IF EXISTS imrObjectCategory;
DROP TABLE IF EXISTS imrObjectInfo;
DROP TABLE IF EXISTS imrProvRolesRelationship;
DROP TABLE IF EXISTS imrProvRoleTemplRelationship;
DROP TABLE IF EXISTS imrUserAccountRelationship;
DROP TABLE IF EXISTS imrTemplEndpointRelationship;
DROP TABLE IF EXISTS imrAccountTemplateRel;
DROP TABLE IF EXISTS imrCapabilityAttrRel;
DROP TABLE IF EXISTS imrroleattr12;
DROP TABLE IF EXISTS imrpolicyxpress125;
DROP TABLE IF EXISTS imrreversesyncmodifyaccount125;
DROP TABLE IF EXISTS imrreversesyncnewaccount125;
DROP TABLE IF EXISTS imremailmanagement125;
DROP TABLE IF EXISTS imrbulktasks125;
DROP TABLE IF EXISTS imrNonStandardAccts;
