-- Copyright (C) 2002, Netegrity, Inc. All rights reserved.
--
-- This file contains the sql script to remove all of the
-- IMS Tables for snapshot
--

DECLARE
	object_exist PLS_INTEGER;
BEGIN
	select count(*)   into object_exist from user_sequences where sequence_name = 'SEQ_IDREPORT';
	if object_exist = 1 then
		execute immediate 'DROP SEQUENCE seq_idreport';
	end if;

	select count(*)   into object_exist from user_views where view_name = 'IMRROLEINFO6';
	if object_exist = 1 then
		execute immediate 'DROP VIEW imrroleinfo6';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMREPORT6_INDEX_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imreport6_index_1';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMREPORT6_INDEX_2';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imreport6_index_2';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMREPORT6_INDEX_3';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imreport6_index_3';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMRROLE6_INDEX_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrrole6_index_1';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMRROLERULE6_INDEX_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrrolerule6_index_1';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMRROLESCOPERULE6_INDEX_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrrolescoperule6_index_1';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMRROLETASK6_INDEX_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrroletask6_index_1';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMRROLEMEMBER6_INDEX_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrrolemember6_index_1';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMRROLEMEMBER6_INDEX_2';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrrolemember6_index_2';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMRROLEADMIN6_INDEX_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrroleadmin6_index_1';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMRROLEADMIN6_INDEX_2';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrroleadmin6_index_2';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMRROLEOWNER6_INDEX_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrroleowner6_index_1';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMRROLEOWNER6_INDEX_2';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrroleowner6_index_2';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMRORG6_INDEX_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrorg6_index_1';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMRORGATTR6_INDEX_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrorgattr6_index_1';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMRORGATTR6_INDEX_2';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrorgattr6_index_2';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMRGROUP6_INDEX_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrgroup6_index_1';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMRGROUPATTR6_INDEX_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrgroupattr6_index_1';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMRGROUPATTR6_INDEX_2';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrgroupattr6_index_2';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMRGROUPMEMBER6_INDEX_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrgroupmember6_index_1';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMRGROUPMEMBER6_INDEX_2';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrgroupmember6_index_2';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMRGROUPADMIN6_INDEX_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrgroupadmin6_index_1';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMRGROUPADMIN6_INDEX_2';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrgroupadmin6_index_2';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMRUSER6_INDEX_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imruser6_index_1';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMRUSER6_INDEX_2';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imruser6_index_2';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMRUSERATTR6_INDEX_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imruserattr6_index_1';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMRUSERATTR6_INDEX_2';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imruserattr6_index_2';
	end if;
	-- identitypolicy index support
	select count(*)   into object_exist from user_indexes where index_name = 'IMRIDENTITYPOLICY6_INDEX_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imridentitypolicy6_index_1';
	end if;
	select count(*)   into object_exist from user_indexes where index_name = 'IMRIDENTITYPOLICY6_INDEX_2';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imridentitypolicy6_index_2';
	end if;
	select count(*)   into object_exist from user_indexes where index_name = 'IMRPOLICYACTIONS6_INDEX_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrpolicyactions6_index_1';
	end if;
	select count(*)   into object_exist from user_indexes where index_name = 'IMRPOLICYUSERSYNC6_INDEX_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrpolicyusersync6_index_1';
	end if;
	select count(*)   into object_exist from user_indexes where index_name = 'IMRPOLICYUSERSYNC6_INDEX_2';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrpolicyusersync6_index_2';
	end if;
	
	select count(*)   into object_exist from user_indexes where index_name = 'IMROBJECT_INDEX_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrobject_index_1';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMROBJECT_INDEX_2';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrobject_index_2';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMROBJECTCATEGORY_INDEX_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrobjectcategory_index_1';
	end if;
	
	select count(*)   into object_exist from user_indexes where index_name = 'IMROBJECTINFO_INDEX_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrobjectinfo_index_1';
	end if;
	
	select count(*)   into object_exist from user_indexes where index_name = 'IMRPROVROLETEMPLREL_INDEX_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrprovroletemplrel_index_1';
	end if;
	
	select count(*)   into object_exist from user_indexes where index_name = 'IMRUSERACCOUNTREL_INDEX_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imruseraccountrel_index_1';
	end if;
	
	select count(*)   into object_exist from user_indexes where index_name = 'IMRUSERACCOUNTREL_INDEX_2';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imruseraccountrel_index_2';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMRUSERACCOUNTREL_INDEX_3';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imruseraccountrel_index_3';
	end if;
	
	select count(*)   into object_exist from user_indexes where index_name = 'IMRCAPABILITYATTRREL_INDEX_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrcapabilityattrrel_index_1';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMRROLEATTR12_INDEX_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrroleattr12_index_1';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMRATTRIBUTE_INDEX_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrattribute_index_1';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'IMRATTRIBUTE_INDEX_2';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrattribute_index_2';
	end if;
	
	select count(*)   into object_exist from user_indexes where index_name = 'IMRATTRIBUTE_INDEX_3';
		if object_exist = 1 then
			execute immediate 'DROP INDEX imrattribute_index_3';
	end if;
	
	select count(*)   into object_exist from user_indexes where index_name = 'IMRATTRIBUTEINFO_INDEX_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrattributeinfo_index_1';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'imrtemplendpointrel_index_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrtemplendpointrel_index_1';
	end if;

	select count(*)   into object_exist from user_indexes where index_name = 'imrprovrolesrel_index_1';
	if object_exist = 1 then
		execute immediate 'DROP INDEX imrprovrolesrel_index_1';
	end if;
	
	-- end identitypolicy index support
	select count(*)   into object_exist from user_clusters where cluster_name = 'IMRORGATTR6_CLUSTER';
	if object_exist = 1 then
		execute immediate 'DROP CLUSTER imrorgattr6_cluster INCLUDING TABLES CASCADE CONSTRAINTS';
	end if;
	select count(*)   into object_exist from user_clusters where cluster_name = 'IMRGROUPATTR6_CLUSTER';
	if object_exist = 1 then
		execute immediate 'DROP CLUSTER imrgroupattr6_cluster INCLUDING TABLES CASCADE CONSTRAINTS';
	end if;
	select count(*)   into object_exist from user_clusters where cluster_name = 'IMRGROUPMEMBER6_CLUSTER';
	if object_exist = 1 then
		execute immediate 'DROP CLUSTER imrgroupmember6_cluster INCLUDING TABLES CASCADE CONSTRAINTS';
	end if;
	select count(*)   into object_exist from user_clusters where cluster_name = 'IMRGROUPADMIN6_CLUSTER';
	if object_exist = 1 then
		execute immediate 'DROP CLUSTER imrgroupadmin6_cluster INCLUDING TABLES CASCADE CONSTRAINTS';
	end if;
	select count(*)   into object_exist from user_clusters where cluster_name = 'IMRUSERATTR6_CLUSTER';
	if object_exist = 1 then
		execute immediate 'DROP CLUSTER imruserattr6_cluster INCLUDING TABLES CASCADE CONSTRAINTS';
	end if;
	select count(*)	into object_exist from user_tables where table_name = 'IMREPORT_VERSION';
	if object_exist = 1 then
		execute immediate 'DROP TABLE imreport_version CASCADE CONSTRAINTS';
	end if;	
	select count(*)	into object_exist from user_tables where table_name = 'IMREPORT6';
	if object_exist = 1 then
		execute immediate 'DROP TABLE imreport6 CASCADE CONSTRAINTS';
	end if;
	select count(*)	into object_exist from user_tables where table_name = 'IMRROLE6';
	if object_exist = 1 then
		execute immediate 'DROP TABLE imrrole6 CASCADE CONSTRAINTS';
	end if;
	select count(*)	into object_exist from user_tables where table_name = 'IMRROLERULE6';
	if object_exist = 1 then
		execute immediate 'DROP TABLE imrrolerule6 CASCADE CONSTRAINTS';
	end if;
	select count(*)	into object_exist from user_tables where table_name = 'IMRROLESCOPERULE6';
	if object_exist = 1 then
		execute immediate 'DROP TABLE imrrolescoperule6 CASCADE CONSTRAINTS';
	end if;
	select count(*)	into object_exist from user_tables where table_name = 'IMRROLETASK6';
	if object_exist = 1 then
		execute immediate 'DROP TABLE imrroletask6 CASCADE CONSTRAINTS';
	end if;
	select count(*)	into object_exist from user_tables where table_name = 'IMRTASK6';
	if object_exist = 1 then
		execute immediate 'DROP TABLE imrtask6 CASCADE CONSTRAINTS';
	end if;
	select count(*)	into object_exist from user_tables where table_name = 'IMRROLEMEMBER6';
	if object_exist = 1 then
		execute immediate 'DROP TABLE imrrolemember6 CASCADE CONSTRAINTS';
	end if;
	select count(*)	into object_exist from user_tables where table_name = 'IMRROLEADMIN6';
	if object_exist = 1 then
		execute immediate 'DROP TABLE imrroleadmin6 CASCADE CONSTRAINTS';
	end if;
	select count(*)	into object_exist from user_tables where table_name = 'IMRROLEOWNER6';
	if object_exist = 1 then
		execute immediate 'DROP TABLE imrroleowner6 CASCADE CONSTRAINTS';
	end if;
	select count(*)	into object_exist from user_tables where table_name = 'IMRORG6';
	if object_exist = 1 then
		execute immediate 'DROP TABLE imrorg6 CASCADE CONSTRAINTS';
	end if;
	select count(*)	into object_exist from user_tables where table_name = 'IMRGROUP6';
	if object_exist = 1 then
		execute immediate 'DROP TABLE imrgroup6 CASCADE CONSTRAINTS';
	end if;
	select count(*)	into object_exist from user_tables where table_name = 'IMRUSER6';
	if object_exist = 1 then
		execute immediate 'DROP TABLE imruser6 CASCADE CONSTRAINTS';
	end if;
	select count(*)	into object_exist from user_tables where table_name = 'RETIRED_SNAPSHOTS';
	if object_exist = 1 then
		execute immediate 'DROP TABLE retired_snapshots CASCADE CONSTRAINTS';
	end if;
	select count(*)	into object_exist from user_tables where table_name = 'IMRPTSNAPSHOTS12';
	if object_exist = 1 then
		execute immediate 'DROP TABLE imrptsnapshots12 CASCADE CONSTRAINTS';
	end if;
	-- identitypolicy TABLE support
	select count(*)	into object_exist from user_tables where table_name = 'IMRIDENTITYPOLICY6';
	if object_exist = 1 then
		execute immediate 'DROP TABLE imridentitypolicy6 CASCADE CONSTRAINTS';
	end if;
	select count(*)	into object_exist from user_tables where table_name = 'IMRIDENTITYPOLICYSET6';
	if object_exist = 1 then
		execute immediate 'DROP TABLE imridentitypolicyset6 CASCADE CONSTRAINTS';
	end if;
	select count(*)	into object_exist from user_tables where table_name = 'IMRIDENTITYPOLICYACTIONS6';
	if object_exist = 1 then
		execute immediate 'DROP TABLE imridentitypolicyactions6 CASCADE CONSTRAINTS';
	end if;
	select count(*)	into object_exist from user_tables where table_name = 'IMRIDENTITYPOLICYUSERSYNC6';
	if object_exist = 1 then
		execute immediate 'DROP TABLE imridentitypolicyusersync6 CASCADE CONSTRAINTS';
	end if;
	-- end of identitypolicy TABLE support
	select count(*)   into object_exist from user_procedures where object_name = 'INSERTINTOGROUPTABLE';
	if object_exist = 1 then
		execute immediate 'DROP PROCEDURE insertintogrouptable';
	end if;
	select count(*)   into object_exist from user_procedures where object_name = 'INSERTINTOIMREPORT';
	if object_exist = 1 then
		execute immediate 'DROP PROCEDURE insertintoimreport';
	end if;
        select count(*)   into object_exist from user_procedures where object_name = 'INSERTINTOIMRUSERACCOUNTS';
	if object_exist = 1 then
		execute immediate 'DROP PROCEDURE insertintoimruseraccounts';
	end if;
	select count(*)   into object_exist from user_procedures where object_name = 'INSERTINTOORGTABLE';
	if object_exist = 1 then
		execute immediate 'DROP PROCEDURE insertintoorgtable';
	end if;
	select count(*)   into object_exist from user_procedures where object_name = 'INSERTINTOUSERTABLE';
	if object_exist = 1 then
		execute immediate 'DROP PROCEDURE insertintousertable';
	end if;
	select count(*)   into object_exist from user_procedures where object_name = 'INSERTUSERMEMBERTABLE';
	if object_exist = 1 then
		execute immediate 'DROP PROCEDURE insertusermembertable';
	end if;
	select count(*)   into object_exist from user_procedures where object_name = 'IMRCLEANUPPROC6';
	if object_exist = 1 then
		execute immediate 'DROP PROCEDURE IMRCleanupProc6';
	end if;
	select count(*)   into object_exist from user_procedures where object_name = 'INSERTINTOACCOUNTATTRIBUTES';
	if object_exist = 1 then
		execute immediate 'DROP PROCEDURE insertintoaccountAttributes';
	end if;
	select count(*)   into object_exist from user_procedures where object_name = 'IMRREMOVESNAPSHOT';
	if object_exist = 1 then
		execute immediate 'DROP PROCEDURE IMRRemoveSnapshot';
	end if;
	select count(*)   into object_exist from user_procedures where object_name = 'IMRCLEANOLDSNAPSHOTSPROC';
	if object_exist = 1 then
		execute immediate 'DROP PROCEDURE IMRCleanOldSnapshotsProc';
	end if;
	select count(*)   into object_exist from user_views where view_name = 'TOTALEXCEPTIONACCOUNTS';
	if object_exist = 1 then
		execute immediate 'DROP VIEW totalExceptionAccounts';
	end if;
	select count(*)   into object_exist from user_views where view_name = 'PROVROLEACCTTMPLENDPTRELVIEW';
		if object_exist = 1 then
			execute immediate 'DROP VIEW provroleaccttmplendptrelview';
	end if;
	select count(*)   into object_exist from user_views where view_name = 'EXCEPTIONACCOUNTSVIEW';
		if object_exist = 1 then
			execute immediate 'DROP VIEW exceptionaccountsview';
	end if;
	select count(*)   into object_exist from user_views where view_name = 'ENDPOINTEXCEPTIONUSERACCOUNTS6';
		if object_exist = 1 then
			execute immediate 'DROP VIEW endpointexceptionuseraccounts6';
	end if;
	
	-- ***** IM r12.1 Provisioning tables
	select count(*)	into object_exist from user_tables where table_name = 'IMRATTRIBUTE';
		if object_exist = 1 then
			execute immediate 'DROP TABLE imrAttribute CASCADE CONSTRAINTS';
	end if;
	select count(*)	into object_exist from user_tables where table_name = 'IMRATTRIBUTEINFO';
		if object_exist = 1 then
			execute immediate 'DROP TABLE imrAttributeInfo CASCADE CONSTRAINTS';
	end if;
	select count(*)	into object_exist from user_tables where table_name = 'IMROBJECT';
		if object_exist = 1 then
			execute immediate 'DROP TABLE imrObject CASCADE CONSTRAINTS';
	end if;
	select count(*)	into object_exist from user_tables where table_name = 'IMROBJECTCATEGORY';
		if object_exist = 1 then
			execute immediate 'DROP TABLE imrObjectCategory CASCADE CONSTRAINTS';
	end if;
	select count(*)	into object_exist from user_tables where table_name = 'IMROBJECTINFO';
		if object_exist = 1 then
			execute immediate 'DROP TABLE imrObjectInfo CASCADE CONSTRAINTS';
	end if;
	select count(*)	into object_exist from user_tables where table_name = 'IMRPROVROLESRELATIONSHIP';
		if object_exist = 1 then
			execute immediate 'DROP TABLE imrProvRolesRelationship CASCADE CONSTRAINTS';
	end if;
	select count(*)	into object_exist from user_tables where table_name = 'IMRPROVROLETEMPLRELATIONSHIP';
		if object_exist = 1 then
			execute immediate 'DROP TABLE imrProvRoleTemplRelationship CASCADE CONSTRAINTS';
	end if;
	select count(*)	into object_exist from user_tables where table_name = 'IMRUSERACCOUNTRELATIONSHIP';
		if object_exist = 1 then
			execute immediate 'DROP TABLE imrUserAccountRelationship CASCADE CONSTRAINTS';
	end if;
	select count(*)   into object_exist from user_sequences where sequence_name = 'SEQ_ATTRINFO';
	if object_exist = 1 then
		execute immediate 'DROP SEQUENCE SEQ_ATTRINFO';
	end if;
	select count(*)   into object_exist from user_sequences where sequence_name = 'SEQ_ATTR';
	if object_exist = 1 then
		execute immediate 'DROP SEQUENCE SEQ_ATTR';
	end if;
	select count(*)   into object_exist from user_sequences where sequence_name = 'SEQ_IMROBJ';
		if object_exist = 1 then
			execute immediate 'DROP SEQUENCE SEQ_IMROBJ';
	end if;
	select count(*)   into object_exist from user_sequences where sequence_name = 'SEQ_OBJINFO';
		if object_exist = 1 then
			execute immediate 'DROP SEQUENCE SEQ_OBJINFO';
	end if;
	select count(*)   into object_exist from user_procedures where object_name = 'INSERTIMRATTR';
	if object_exist = 1 then
		execute immediate 'DROP PROCEDURE insertimrAttr';
	end if;
	select count(*)   into object_exist from user_procedures where object_name = 'INSERTIMRATTRINFO';
		if object_exist = 1 then
			execute immediate 'DROP PROCEDURE insertimrAttrInfo';
	end if;
	select count(*)   into object_exist from user_procedures where object_name = 'INSERTIMROBJECT';
		if object_exist = 1 then
			execute immediate 'DROP PROCEDURE insertimrobject';
	end if;
	select count(*)   into object_exist from user_procedures where object_name = 'INSERTIMROBJECTCATEGORY';
		if object_exist = 1 then
			execute immediate 'DROP PROCEDURE insertimrobjectcategory';
	end if;
	select count(*)   into object_exist from user_procedures where object_name = 'INSERTIMROBJECTINFO';
		if object_exist = 1 then
			execute immediate 'DROP PROCEDURE insertimrobjectinfo';
	end if;
	select count(*)   into object_exist from user_procedures where object_name = 'INSERTIMRROLETEMPLATE';
		if object_exist = 1 then
			execute immediate 'DROP PROCEDURE insertimrroletemplate';
	end if;
	
	select count(*)   into object_exist from user_views where view_name = 'IMRUSERACCOUNTS6';
	if object_exist = 1 then
		execute immediate 'DROP VIEW imruseraccounts6';
	end if;

	select count(*)   into object_exist from user_views where view_name = 'IMRACCOUNTATTRS6';
	if object_exist = 1 then
		execute immediate 'DROP VIEW imraccountattrs6';
	end if;

	select count(*)   into object_exist from user_views where view_name = 'ENDPOINTATTRIBUTES';
	if object_exist = 1 then
		execute immediate 'DROP VIEW endpointattributes';
	end if;

	select count(*)   into object_exist from user_views where view_name = 'ACCTTMPLATTRIBUTE';
	if object_exist = 1 then
		execute immediate 'DROP VIEW accttmplattribute';
	end if;

	select count(*)   into object_exist from user_views where view_name = 'ENDPOINTACCOUNT';
	if object_exist = 1 then
		execute immediate 'DROP VIEW endpointaccount';
	end if;

	select count(*)   into object_exist from user_views where view_name = 'ENDPOINTVIEW';
	if object_exist = 1 then
		execute immediate 'DROP VIEW endpointview';
	end if;

	select count(*)   into object_exist from user_views where view_name = 'PROVROLESRELATIONSHIPVIEW';
	if object_exist = 1 then
		execute immediate 'DROP VIEW provrolesrelationshipview';
	end if;

	select count(*)	into object_exist from user_tables where table_name = 'imrTemplEndpointRelationship';
	if object_exist = 1 then
		execute immediate 'DROP TABLE imrTemplEndpointRelationship CASCADE CONSTRAINTS';
	end if;
	
	select count(*)   into object_exist from user_procedures where object_name = 'insertintoimrroleattr12';
	if object_exist = 1 then
		execute immediate 'DROP PROCEDURE insertintoimrroleattr12';
	end if;

	select count(*)   into object_exist from user_procedures where object_name = 'insertProvRolesRel';
	if object_exist = 1 then
		execute immediate 'DROP PROCEDURE insertProvRolesRel';
	end if;
	
	select count(*)   into object_exist from user_procedures where object_name = 'insertCapabilityAttrRel';
		if object_exist = 1 then
			execute immediate 'DROP PROCEDURE insertCapabilityAttrRel';
	end if;

	select count(*)	into object_exist from user_tables where table_name = 'imrAccountTemplateRel';
	if object_exist = 1 then
		execute immediate 'DROP TABLE imrAccountTemplateRel CASCADE CONSTRAINTS';
	end if;

	select count(*)	into object_exist from user_tables where table_name = 'imrCapabilityAttrRel';
	if object_exist = 1 then
		execute immediate 'DROP TABLE imrCapabilityAttrRel CASCADE CONSTRAINTS';
	end if;

	select count(*)   into object_exist from user_procedures where object_name = 'INSERTACCOUNTTEMPLATEREL';
	if object_exist = 1 then
		execute immediate 'DROP PROCEDURE INSERTACCOUNTTEMPLATEREL';
	end if;

	select count(*)   into object_exist from user_procedures where object_name = 'INSERTTEMPLENDPOINTREL';
	if object_exist = 1 then
		execute immediate 'DROP PROCEDURE INSERTTEMPLENDPOINTREL';
	end if;
	
	select count(*)   into object_exist from user_views where view_name = 'ACCTTEMPLENDPOINTRELVIEW';
	if object_exist = 1 then
		execute immediate 'DROP VIEW accttemplEndpointRelView';
	end if;

	select count(*)   into object_exist from user_views where view_name = 'CAPABILITYATTRSVIEW';
	if object_exist = 1 then
		execute immediate 'DROP VIEW capabilityattrsview';
	end if;

	select count(*)   into object_exist from user_views where view_name = 'ENDPOINTACCOUNTATTRS6';
	if object_exist = 1 then
		execute immediate 'DROP VIEW endpointaccountattrs6';
	end if;
	
	select count(*)   into object_exist from user_views where view_name = 'ENDPOINTUSERACCOUNTS6';
		if object_exist = 1 then
			execute immediate 'DROP VIEW endpointuseraccounts6';
	end if;

	select count(*)	into object_exist from user_tables where table_name = 'IMRROLEATTR12';
	if object_exist = 1 then
		execute immediate 'DROP TABLE imrroleattr12 CASCADE CONSTRAINTS';
	end if;
	
	-- New 12.5 SP1 related support
	select count(*)	into object_exist from user_tables where table_name = 'IMRPOLICYXPRESS125';
	if object_exist = 1 then
		execute immediate 'DROP TABLE imrpolicyxpress125 CASCADE CONSTRAINTS';
	end if;
	select count(*)	into object_exist from user_tables where table_name = 'IMRREVERSESYNCNEWACCOUNT125';
	if object_exist = 1 then
		execute immediate 'DROP TABLE imrreversesyncnewaccount125 CASCADE CONSTRAINTS';
	end if;
	select count(*)	into object_exist from user_tables where table_name = 'IMRREVERSESYNCMODIFYACCOUNT125';
	if object_exist = 1 then
		execute immediate 'DROP TABLE imrreversesyncmodifyaccount125 CASCADE CONSTRAINTS';
	end if;
	select count(*)	into object_exist from user_tables where table_name = 'IMREMAILMANAGEMENT125';
	if object_exist = 1 then
		execute immediate 'DROP TABLE imremailmanagement125 CASCADE CONSTRAINTS';
	end if;
	select count(*)	into object_exist from user_tables where table_name = 'IMRBULKTASKS125';
	if object_exist = 1 then
		execute immediate 'DROP TABLE imrbulktasks125 CASCADE CONSTRAINTS';
	end if;
	-- New 12.5 SP1 related support
	select count(*)	into object_exist from user_tables where table_name = 'IMRNONSTANDARDACCTS';
	if object_exist = 1 then
		execute immediate 'DROP TABLE imrnonstandardaccts CASCADE CONSTRAINTS';
	end if;
END;
/