-- Copyright (C) 2009, Computer Associates, Inc. All rights reserved.
--
-- This file contains the schema for upgrading a IM 12 schema to a IM R12.5
-- Reporting snapshot schema
--
-------------------------------------------------------------------

UPDATE imreport_version SET imr_value='12.5.1.0.0';

------------------------------------------------------
-- New r12.5 SP1 support.
------------------------------------------------------

--
-- IMR imrpolicyxpress125
--

CREATE TABLE imrpolicyxpress125 (
    imr_reportid INTEGER  NOT NULL,
    imr_policyid     VARCHAR2(64) NOT NULL,
    imr_policyname    VARCHAR2(255) NULL,
    imr_enabled    VARCHAR2(5) NULL,
    imr_category    VARCHAR2(255) NULL,
    imr_description    VARCHAR2(1023) NULL,
    imr_runonce    VARCHAR2(5) NULL,
    imr_priority    INTEGER NULL,
    imr_type    VARCHAR2(255) NULL,
    imr_policyevents    NCLOB NULL,
    imr_policydata    NCLOB NULL,
    imr_entryrules    NCLOB NULL,
    imr_actionrules    NCLOB NULL,
    CONSTRAINT PK_01_imrpolicyxpress125 PRIMARY KEY  (imr_reportid, imr_policyid)
    );


--
-- IMR imrreversesyncmodifyaccount125
--
CREATE TABLE imrreversesyncmodifyaccount125 (
    imr_reportid INTEGER  NOT NULL,
    imr_policyid     VARCHAR2(64) NOT NULL,
    imr_policyname    VARCHAR2(255) NULL,
    imr_enabled    VARCHAR2(5) NULL,
    imr_description    VARCHAR2(1023) NULL,
    imr_priority    INTEGER NULL,
    imr_endpointtype    VARCHAR2(255) NULL,
    imr_endpointname    VARCHAR2(1023) NULL,
    imr_container    VARCHAR2(255) NULL,
    imr_attributename    VARCHAR2(255) NULL,
    imr_attributevalue    VARCHAR2(1023) NULL,
    imr_action    VARCHAR2(255) NULL,
    CONSTRAINT PK_01_imrreversesyncmodify125 PRIMARY KEY  (imr_reportid, imr_policyid)
    );


--
-- IMR imrreversesyncnewaccount125
--

CREATE TABLE imrreversesyncnewaccount125 (
    imr_reportid INTEGER  NOT NULL,
    imr_policyid     VARCHAR2(64) NOT NULL,
    imr_policyname    VARCHAR2(255) NULL,
    imr_enabled    VARCHAR2(5) NULL,
    imr_description    VARCHAR2(1023) NULL,
    imr_priority    INTEGER NULL,
    imr_endpointtype    VARCHAR2(255) NULL,
    imr_endpointname    VARCHAR2(1023) NULL,
    imr_container    VARCHAR2(255) NULL,
    imr_targetuserstatus    VARCHAR2(255) NULL,
    imr_action    VARCHAR2(255) NULL,
    CONSTRAINT PK_01_imrreversesyncnew125 PRIMARY KEY  (imr_reportid, imr_policyid)
    );


--
-- IMR imremailmanagement125
--

CREATE TABLE imremailmanagement125 (
    imr_reportid INTEGER  NOT NULL,
    imr_emailid     VARCHAR2(64) NOT NULL,
    imr_emailname    VARCHAR2(255) NULL,
    imr_enabled    VARCHAR2(5) NULL,
    imr_category    VARCHAR2(255) NULL,
    imr_description    VARCHAR2(1023) NULL,
    imr_subject    VARCHAR2(1023) NULL,
    CONSTRAINT PK_01_imremailmanagement125 PRIMARY KEY  (imr_reportid, imr_emailid)
    );


--
-- IMR imrbulktasks125
--

CREATE TABLE imrbulktasks125 (
    imr_reportid INTEGER  NOT NULL,
    imr_bulktaskid     VARCHAR2(64) NOT NULL,
    imr_bulktaskname    VARCHAR2(255) NULL,
    imr_description    VARCHAR2(1023) NULL,
    imr_tasktag    VARCHAR2(255) NULL,
    imr_objecttype    VARCHAR2(255) NULL,
    imr_initiator    VARCHAR2(255) NULL,
    imr_dateformat    VARCHAR2(255) NULL,
    imr_populationrule    NCLOB NULL,
    imr_datefilter    NCLOB NULL,
    CONSTRAINT PK_01_imrbulktasks125 PRIMARY KEY  (imr_reportid, imr_bulktaskid)
    );


------------------------------------------------------
-- End of r12.5 SP1 support.
------------------------------------------------------


----------
-- Cleanup Stuff
----------



--
-- PROCEDURE IMRCleanupProc6 For cleaning reports older than a month
-- *********DEPRICATED DO NOT USE
--
CREATE OR REPLACE PROCEDURE IMRCleanupProc6 AS
BEGIN
    DELETE FROM imrrole6 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imrroletask6 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imrtask6 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imrrolerule6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imrrolescoperule6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imrrolemember6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imrroleadmin6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imrroleowner6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imrorg6 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imrorgattr6 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imruser6 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imruserattr6 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imrgroup6 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imrgroupattr6 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imrgroupmember6 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imrgroupadmin6 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    -- delete identitypolicy related items
    DELETE FROM imridentitypolicy6 where imr_reportid IN
                 (
                 SELECT imreport6.imr_reportid
                 FROM imreport6
                 WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
   DELETE FROM imridentitypolicyset6 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
   DELETE FROM imridentitypolicyactions6 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
   DELETE FROM imridentitypolicyusersync6 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
   --New 12.5 SP1 suport
   DELETE FROM imrpolicyxpress125 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
   DELETE FROM imrreversesyncnewaccount125 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
   DELETE FROM imrreversesyncmodifyaccount125 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
   DELETE FROM imremailmanagement125 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
   DELETE FROM imrbulktasks125 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
   --End of 12.5 SP1 suport
   DELETE FROM imreport6 WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) );
END IMRCleanupProc6 ;
/



--
-- Procedure for removing a snapshot from all the tables it exist
--
CREATE OR REPLACE PROCEDURE IMRRemoveSnapshot (
	id INTEGER)
AS
BEGIN
	DELETE FROM imrrole6 WHERE imr_reportid = id;
	DELETE FROM imrrolemember6 WHERE imr_reportid = id;
	DELETE FROM imrroleadmin6 WHERE imr_reportid = id;
	DELETE FROM imrroleowner6 WHERE imr_reportid = id;
	DELETE FROM imrrolerule6 WHERE imr_reportid = id;
	DELETE FROM imrrolescoperule6 WHERE imr_reportid = id;

	DELETE FROM imrroletask6 WHERE imr_reportid = id;
	DELETE FROM imrtask6 WHERE imr_reportid = id;

	DELETE FROM imrorg6 WHERE imr_reportid = id;
	DELETE FROM imrorgattr6 WHERE imr_reportid = id;

	DELETE FROM imruser6 WHERE imr_reportid = id;
	DELETE FROM imruserattr6 WHERE imr_reportid = id;

	DELETE FROM imrgroup6 WHERE imr_reportid = id;
	DELETE FROM imrgroupattr6 WHERE imr_reportid = id;
	DELETE FROM imrgroupmember6 WHERE imr_reportid = id;
	DELETE FROM imrgroupadmin6 WHERE imr_reportid = id;

	DELETE FROM imridentitypolicy6 WHERE imr_reportid = id;
	DELETE FROM imridentitypolicyset6 WHERE imr_reportid = id;
	DELETE FROM imridentitypolicyusersync6 WHERE imr_reportid = id;
	DELETE FROM imridentitypolicyactions6 WHERE imr_reportid = id;

	DELETE FROM imrAttribute WHERE imr_reportid = id;
	DELETE FROM imrAttributeInfo WHERE imr_reportid = id;
	DELETE FROM imrObject WHERE imr_reportid = id;
	DELETE FROM imrObjectCategory WHERE imr_reportid = id;
	DELETE FROM imrObjectInfo WHERE imr_reportid = id;
	DELETE FROM imrProvRolesRelationship WHERE imr_reportid = id;
	DELETE FROM imrProvRoleTemplRelationship WHERE imr_reportid = id;
	DELETE FROM imrUserAccountRelationship WHERE imr_reportid = id;
	DELETE FROM imrTemplEndpointRelationship WHERE imr_reportid = id;
	DELETE FROM imrAccountTemplateRel WHERE imr_reportid = id;
	DELETE FROM imrCapabilityAttrRel WHERE imr_reportid = id;
	DELETE FROM imrroleattr12 WHERE imr_reportid = id;

	--New 12.5 SP1 suport
	DELETE FROM imrpolicyxpress125 WHERE imr_reportid = id;
	DELETE FROM imrreversesyncnewaccount125 WHERE imr_reportid = id;
	DELETE FROM imrreversesyncmodifyaccount125 WHERE imr_reportid = id;
	DELETE FROM imremailmanagement125 WHERE imr_reportid = id;
	DELETE FROM imrbulktasks125 WHERE imr_reportid = id;
	--End of 12.5 SP1 suport

	DELETE FROM imreport6 WHERE imr_reportid = id;
END;
/