-- Copyright (C) 2009, Computer Associates, Inc. All rights reserved.
--
-- This file contains the schema for upgrading a IM 12 schema to a IM R12.5
-- Reporting snapshot schema
--
-------------------------------------------------------------------

-------------------------------------------------   
--- Drop items no longer used
-------------------------------------------------

DROP INDEX imruseraccounts6_index_1;
/

DROP INDEX imruseraccounts6_index_2;
/

DROP INDEX imruseraccounts6_index_3;
/

DROP INDEX imruseraccounts6_index_4;
/

DROP INDEX imruseraccounts6_index_5;
/

DROP PROCEDURE insertintoimruseraccounts;
/

DROP INDEX imruserattr6_index_2;
/

-------------------------------------------------
--- Rename the table that will not be used any more
-------------------------------------------------

alter table imruseraccounts6 rename to imruseraccounts6_bak;
/

alter table imraccountattrs6 rename to imraccountattrs6_bak;
/

-- Add the Version table
CREATE TABLE imreport_version (
    imr_key varchar2(255) NOT NULL,
    imr_value varchar2(255) NOT NULL
    );
/
insert into imreport_version(imr_key,imr_value) values ('version','12.5.0.0.0');
/

------------------------------------------------------ 
-- New r12.5 support.
------------------------------------------------------ 

CREATE TABLE imrAttribute (
	imr_reportid INTEGER NOT NULL ,
	imr_objectid INTEGER NOT NULL ,
	imr_attrinfoid INTEGER NOT NULL ,
	imr_value varchar2(4000)  ,
	imr_objectrefid INTEGER  
);

CREATE INDEX imrattribute_index_1 ON imrattribute (imr_reportid, imr_attrinfoid, imr_objectid);

CREATE INDEX imrattribute_index_2 ON imrattribute (imr_reportid,imr_objectid);

CREATE INDEX imrattribute_index_3 ON imrattribute (imr_reportid,imr_value);

CREATE TABLE imrAttributeInfo (
	imr_reportid INTEGER NOT NULL ,
	imr_attrinfoid INTEGER  NOT NULL ,
	imr_syntaxid INTEGER NOT NULL ,
	imr_name varchar2(64) NOT NULL ,
	imr_objectinfoid INTEGER NOT NULL ,
	imr_isbasetype varchar2(256) NULL 
);

CREATE INDEX imrattributeinfo_index_1 ON imrattributeinfo (imr_reportid, imr_name);

CREATE TABLE imrObject (
	imr_reportid INTEGER NOT NULL ,
	imr_friendlyname VARCHAR2 (255) NOT NULL ,
	imr_objectdn VARCHAR2 (628) NOT NULL ,
	imr_objectinfoname VARCHAR2 (255) NOT NULL ,
	imr_objectid INTEGER  NOT NULL 
); 

CREATE INDEX imrobject_index_1 ON imrobject (imr_reportid, imr_friendlyname);

CREATE INDEX imrobject_index_2 ON imrobject (imr_reportid, imr_objectdn);

CREATE TABLE imrObjectCategory (
	imr_reportid INTEGER NOT NULL ,
	imr_name VARCHAR2 (255) NOT NULL 
); 

CREATE INDEX imrobjectcategory_index_1 ON imrobjectcategory (imr_reportid, imr_name);

CREATE TABLE imrObjectInfo (
	imr_reportid INTEGER NOT NULL ,
	imr_objectid INTEGER  NOT NULL ,
	imr_name VARCHAR2 (255) NOT NULL ,
	imr_objectcatname VARCHAR2 (255) NOT NULL 
); 

CREATE INDEX imrobjectinfo_index_1 ON imrobjectinfo (imr_reportid, imr_name);

CREATE TABLE imrProvRolesRelationship (
	imr_reportid INTEGER NOT NULL ,
	imr_parentoid VARCHAR2 (64) NOT NULL ,
	imr_childoid VARCHAR2 (64) NOT NULL 
); 

CREATE INDEX imrprovrolesrel_index_1 ON imrProvRolesRelationship (imr_reportid, imr_parentoid, imr_childoid);

CREATE TABLE imrProvRoleTemplRelationship (
	imr_reportid INTEGER NOT NULL ,
	imr_roleoid VARCHAR2(64) NOT NULL,
	imr_roledn VARCHAR2 (628) NOT NULL ,
	imr_templatedn VARCHAR2 (628) NOT NULL 
); 

CREATE INDEX imrprovroletemplrel_index_1 ON imrprovroletemplrelationship (imr_reportid, imr_roleoid, imr_templatedn, imr_roledn);


CREATE TABLE imrUserAccountRelationship (
	imr_reportid INTEGER NOT NULL ,
	imr_useraccountdn VARCHAR2 (1024) NOT NULL ,
	imr_provuserdn VARCHAR2 (1024) NOT NULL ,
	imr_userid VARCHAR2 (1024) NOT NULL
); 

CREATE INDEX imruseraccountrel_index_1 ON imruseraccountrelationship (imr_reportid, imr_userid);

CREATE INDEX imruseraccountrel_index_2 ON imruseraccountrelationship (imr_reportid, imr_provuserdn);

CREATE INDEX imruseraccountrel_index_3 ON imruseraccountrelationship (imr_reportid, imr_useraccountdn);

--
-- IM imrTemplEndpointRelationship
--

CREATE TABLE imrTemplEndpointRelationship (
   	imr_reportid INTEGER  NOT NULL,
	imr_templatedn VARCHAR2(628) ,
	imr_endpointname VARCHAR2(628) ,
	imr_endpointdn VARCHAR2(628) 
);

CREATE INDEX imrtemplendpointrel_index_1 ON imrtemplendpointrelationship (imr_reportid, imr_templatedn, imr_endpointname);

--
-- IM imrAccount
--

CREATE TABLE imrAccountTemplateRel (
    imr_reportid INTEGER  NOT NULL,
	imr_name VARCHAR2(628) NOT NULL,
	imr_templatedn VARCHAR2(628),
	imr_endpointtype VARCHAR2(628) 
);

CREATE INDEX imrAccountTemplateRel_index_1 ON imrAccountTemplateRel (imr_reportid, imr_name,imr_templatedn,imr_endpointtype);

--
-- IM imrCapabilityAttrRelationship
--

CREATE TABLE imrCapabilityAttrRel (
    imr_reportid integer  NOT NULL,
	imr_endpointtype VARCHAR2(628) not null,
	imr_objecttypename VARCHAR2(628) NOT NULL,
	imr_jiamobjecttypename VARCHAR2(628) NOT NULL,
	imr_attrid integer,
	imr_capabilityobjectname VARCHAR2(628) NOT NULL,
	imr_capabilityobjectdn VARCHAR2(628) NOT NULL,
	imr_endpointobjid integer,
	imr_name VARCHAR2(64),
	imr_value varchar2(4000)
);

CREATE INDEX imrcapabilityattrrel_index_1 ON imrcapabilityattrrel (imr_reportid, imr_endpointtype, imr_endpointobjid, imr_objecttypename, imr_capabilityobjectdn, imr_name);

--
-- IM imrroleattr12
--
CREATE TABLE imrroleattr12 (
	imr_reportid INTEGER NOT NULL ,
	imr_roleoid varchar(64) NOT NULL ,
	imr_name VARCHAR2 (628) NOT NULL ,
	imr_value varchar2(4000) NULL 
);

CREATE INDEX imrroleattr12_index_1 ON imrroleattr12 (imr_reportid, imr_roleoid, imr_name);

CREATE OR REPLACE PROCEDURE insertCapabilityAttrRel(
	reportid INTEGER,
	endpointtype VARCHAR2,
	objecttypename VARCHAR2,
	jiamobjecttypename VARCHAR2,
	attrid INTEGER,
	capabilityobjectname VARCHAR2,
	capabilityobjectdn VARCHAR2,
	endpointobjid integer,
	attrname VARCHAR2,
	attrvalue VARCHAR2
	)
IS
	rowcount INTEGER;
BEGIN
	rowcount:=0;
	BEGIN
		select count(*) into rowcount from imrCapabilityAttrRel
			where
				imr_reportid=reportid
				and imr_endpointtype=endpointtype
				and imr_objecttypename=objecttypename
				and imr_endpointtype=endpointtype
				and imr_jiamobjecttypename=jiamobjecttypename
				and imr_attrid=attrid
				and imr_capabilityobjectname=capabilityobjectname
				and imr_capabilityobjectdn=capabilityobjectdn
				and imr_endpointobjid=endpointobjid
				and imr_name=attrname;
		EXCEPTION
			WHEN NO_DATA_FOUND THEN
			rowcount:=0;
	END;
	IF rowcount = 0 THEN
		insert into imrCapabilityAttrRel(
			imr_reportid,
			imr_endpointtype,
			imr_objecttypename,
			imr_jiamobjecttypename,
			imr_attrid,
			imr_capabilityobjectname,
			imr_capabilityobjectdn,
			imr_endpointobjid,
			imr_name,
			imr_value
		)
		values(
			reportid,
			endpointtype,
			objecttypename,
			jiamobjecttypename,
			attrid,
			capabilityobjectname,
			capabilityobjectdn,
			endpointobjid,
			attrname,
			attrvalue
		);
	END IF;
END;
/

CREATE OR REPLACE PROCEDURE insertTemplEndpointRel(
	reportid INTEGER,
	templatedn VARCHAR2,
	endpointname VARCHAR2,
	endpointdn VARCHAR2
	)
IS
	rowcount INTEGER;
BEGIN
	rowcount:=0;
	BEGIN
		select count(*) into rowcount from imrTemplEndpointRelationship
			where
				imr_reportid=reportid
				and imr_templatedn=templatedn
				and imr_endpointname=endpointname
				and imr_endpointdn=endpointdn;
		EXCEPTION
			WHEN NO_DATA_FOUND THEN
			rowcount:=0;
	END;
	IF rowcount = 0 THEN
		insert into imrTemplEndpointRelationship(
			imr_reportid,
			imr_templatedn,
			imr_endpointname,
			imr_endpointdn
		)
		values(
			reportid,
			templatedn,
			endpointname,
			endpointdn
		);
	END IF;
END;
/

--
-- IM insertAccountTemplateRel
--

CREATE OR REPLACE PROCEDURE insertAccountTemplateRel(
	reportid INTEGER,
	name VARCHAR2,
	templatedn VARCHAR2,
	endpointtype VARCHAR2
	)
IS
	rowcount INTEGER;
BEGIN
	rowcount :=0;
	BEGIN
		select count(*) into rowcount from imrAccountTemplateRel
		where
			imr_reportid=reportid
			and imr_name=name
			and imr_templatedn=templatedn
			and imr_endpointtype=endpointtype;
		EXCEPTION
			WHEN NO_DATA_FOUND THEN
				rowcount:=0;
	END;
	IF(rowcount = 0) THEN
		insert into imrAccountTemplateRel(
			imr_reportid,
			imr_name,
			imr_templatedn,
			imr_endpointtype
		)
		values(
			reportid,
			name,
			templatedn,
			endpointtype
		);
	END IF;
END;
/

------------------------
-- Views
------------------------


CREATE OR REPLACE VIEW imruseraccounts6 
AS
SELECT
	accountObject.imr_reportid as imr_reportid,
	imruser.imr_userid as imr_userid,
	accountObject.imr_friendlyname as imr_accountname,
	accountObject.imr_objectdn as imr_accountdn,
	endPointAttr.imr_value as imr_endpoint,
	accountObject.imr_objectinfoname as imr_accounttype,
	accountAttr.imr_value as imr_createtime
FROM
	imrObject accountObject,
	imrUserAccountRelationship userAccountRelationship,
	imrAttributeInfo endPointAttrInfo,
	imrAttribute endPointAttr,
	imrAttributeInfo accountAttrInfo,
	imrAttribute accountAttr,
	imruser6 imruser
WHERE
	imruser.imr_userid = userAccountRelationship.imr_userid and
	accountObject.imr_objectdn = userAccountRelationship.imr_useraccountdn and
	accountObject.imr_objectid = endPointAttr.imr_objectid and
	endPointAttr.imr_attrinfoid = endPointAttrInfo.imr_attrinfoid and 
	endPointAttrInfo.imr_name = 'endPointName' and 
	accountAttr.imr_attrinfoid = accountAttrInfo.imr_attrinfoid and 
	accountAttrInfo.imr_name='createStatistics' and 
	accountObject.imr_reportid=imruser.imr_reportid and 
	userAccountRelationship.imr_reportid = imruser.imr_reportid and
	endPointAttrInfo.imr_reportid = imruser.imr_reportid and
	endPointAttr.imr_reportid = imruser.imr_reportid and 
	accountAttrInfo.imr_reportid = imruser.imr_reportid and
	accountAttr.imr_reportid = imruser.imr_reportid;
/

CREATE VIEW imraccountattrs6 
AS
SELECT
	accountObject.imr_reportid as imr_reportid,
	accountObject.imr_friendlyname as imr_accountname,
	accountObject.imr_objectdn as imr_accountdn,
	(SELECT imr_value
	FROM
		imrAttribute endPointAttr,
		imrAttributeInfo endPointAttrInfo
	WHERE
		accountObject.imr_objectid = endPointAttr.imr_objectid and
		endPointAttr.imr_attrinfoid = endPointAttrInfo.imr_attrinfoid and
		endPointAttrInfo.imr_name = 'endPointName' 
	) as imr_endpoint,
	accountObjectInfo.imr_name as imr_endpointtype,
	resourceAttrInfo.imr_name as imr_accountattr,
	resourceAttr.imr_value as imr_accountattrvalue,
	resourceAttr.imr_objectrefid as imr_objectrefid,
	resourceAttrInfo.imr_isbasetype as imr_isbasetype
FROM
	imrObjectCategory accountCategory,
	imrObjectInfo accountObjectInfo,
	imrObject accountObject,
	imrAttributeInfo resourceAttrInfo,
	imrAttribute resourceAttr
WHERE
	(resourceAttr.imr_value IS NOT NULL or
	resourceAttr.imr_objectrefid IS NOT NULL) and
	resourceAttr.imr_objectid = accountObject.imr_objectid and
	resourceAttrInfo.imr_attrinfoid = resourceAttr.imr_attrinfoid and
	accountObject.imr_objectinfoname = accountObjectInfo.imr_name and
	accountObjectInfo.imr_objectcatname = accountCategory.imr_name and
	accountCategory.imr_name = 'Account' and
	accountCategory.imr_reportid=accountObject.imr_reportid and
	accountObjectInfo.imr_reportid=accountObject.imr_reportid and
	resourceAttrInfo.imr_reportid=accountObject.imr_reportid and
	resourceAttr.imr_reportid=accountObject.imr_reportid;
/


CREATE OR REPLACE VIEW endpointaccountattrs6
AS
SELECT
	accountObject.imr_reportid as imr_reportid,
	accountObject.imr_objectid as imr_accountid,
	accountObject.imr_friendlyname as imr_accountname,
	accountObject.imr_objectdn as imr_accountdn,
	(SELECT imr_value
	FROM
		imrAttribute endPointAttr,
		imrAttributeInfo endPointAttrInfo
	WHERE
		accountObject.imr_objectid = endPointAttr.imr_objectid and
		endPointAttr.imr_attrinfoid = endPointAttrInfo.imr_attrinfoid and
		endPointAttrInfo.imr_name = 'endPointName' 
	) as imr_endpoint,
	accountObjectInfo.imr_name as imr_endpointtype,
	attr1.imr_value as imr_createtime,
	attr2.imr_value as imr_accountlastmodified
FROM
	imrObjectCategory accountCategory,
	imrObjectInfo accountObjectInfo,
	imrObject accountObject,
	imrAttributeInfo attrInfo1,
	imrAttribute attr1,
	imrAttributeInfo attrInfo2,
	imrAttribute attr2
WHERE
	(attr1.imr_value IS NOT NULL or
	attr1.imr_objectrefid IS NOT NULL or
	attr2.imr_value IS NOT NULL or
	attr2.imr_objectrefid IS NOT NULL) and
	attr1.imr_objectid = accountObject.imr_objectid and
	attr2.imr_objectid = accountObject.imr_objectid and
	accountObject.imr_objectinfoname = accountObjectInfo.imr_name and
	accountObjectInfo.imr_objectcatname = accountCategory.imr_name and
	accountCategory.imr_name = 'Account' and
	(attr1.imr_attrinfoid = attrInfo1.imr_attrinfoid and 
	attrInfo1.imr_name = 'createStatistics') and 
	(attr2.imr_attrinfoid = attrInfo2.imr_attrinfoid and 
	attrInfo2.imr_name = 'updateStatistics') and 
	accountCategory.imr_reportid=accountObject.imr_reportid and
	accountObjectInfo.imr_reportid=accountObject.imr_reportid and
	attrInfo1.imr_reportid=accountObject.imr_reportid and
	attr1.imr_reportid=accountObject.imr_reportid and 
	attrInfo2.imr_reportid=accountObject.imr_reportid and
	attr2.imr_reportid=accountObject.imr_reportid;
/

CREATE OR REPLACE VIEW endpointuseraccounts6
AS
select 
	a.imr_reportid imr_reportid, 
	b.imr_userid imr_userid, 
	a.imr_accountname imr_accountname, 
	a.imr_accountdn imr_accountdn, 
	a.imr_endpoint imr_endpoint,
	a.imr_endpointtype imr_accounttype, 
	a.imr_createtime imr_createtime,
	a.imr_accountlastmodified imr_accountlastmodified,
	c.imr_firstname imr_firstname,
	c.imr_lastname imr_lastname,
	c.imr_fullname imr_fullname
from  
	endpointaccountattrs6 a, 
	imrUserAccountRelationship b,
	imruser6 c 
where 
	b.imr_useraccountdn = a.imr_accountid
	and b.imr_reportid = a.imr_reportid
	and c.imr_reportid = a.imr_reportid
	and c.imr_userid=b.imr_userid;
/

---
--- Procedure for counting the number of exception accounts
---
CREATE OR REPLACE VIEW
    "TOTALEXCEPTIONACCOUNTS" ("REPORT_ID",
    "END_POINT_TYPE","END_POINT","EXCEPTION_TYPE","ACCOUNT_NAME","CREATION_DATE","LAST_MODIFIED") AS
    SELECT imr_reportid AS REPORT_ID, imr_accounttype AS
END_POINT_TYPE, imr_endpoint AS END_POINT, 'Exception' AS
EXCEPTION_TYPE,imr_accountname AS ACCOUNT_NAME, imr_createtime as CREATION_DATE, imr_accountlastmodified as LAST_MODIFIED 
FROM endpointuseraccounts6
WHERE imr_userid NOT IN ( '[default user]','[system user]')
UNION
SELECT imr_reportid AS REPORT_ID, imr_accounttype AS END_POINT_TYPE, imr_endpoint AS END_POINT, 'Orphan' AS EXCEPTION_TYPE,
imr_accountname AS ACCOUNT_NAME, imr_createtime as CREATION_DATE, imr_accountlastmodified as LAST_MODIFIED 
FROM         endpointuseraccounts6
WHERE  imr_userid  IN('[default user]')
UNION
SELECT     imr_reportid AS REPORT_ID, imr_accounttype AS END_POINT_TYPE, imr_endpoint AS END_POINT, 'System' AS EXCEPTION_TYPE,
imr_accountname AS ACCOUNT_NAME, imr_createtime as CREATION_DATE, imr_accountlastmodified as LAST_MODIFIED 
FROM         endpointuseraccounts6
WHERE      imr_userid  IN('[system user]');
/



-- Procedures to insert in to the provisioning tables r12.1 additions

create sequence SEQ_ATTRINFO increment by 1  start with 1 ;
/
create or replace PROCEDURE insertimrAttrInfo( 
	reportid INTEGER,
	syntaxid INTEGER,
	name varchar2,
	objectinfoid INTEGER,
	isbasetype char,    
	infoid OUT INTEGER)
AS
BEGIN
    BEGIN
        infoid := 0;
        Select imr_attrinfoid into infoid from imrAttributeInfo
        WHERE
        ( imr_reportid= reportid
        AND imr_name  = name
        AND imr_objectinfoid  = objectinfoid );
        EXCEPTION
            WHEN NO_DATA_FOUND THEN
            infoid := 0;
    END;
    IF NOT (infoid > 0) THEN
  		SELECT SEQ_ATTRINFO.NEXTVAL INTO infoid
                    FROM Dual;
    INSERT into imrAttributeInfo(
                        imr_reportid, 
                        IMR_ATTRINFOID,
                        imr_syntaxid,
                        imr_name,
                        imr_objectinfoid,
			imr_isbasetype		
                        ) 
                    values (
			reportid, 
			infoid,
                        syntaxid,
                    name,
                    objectinfoid,
                    isbasetype
		);
    END IF;
END insertimrAttrInfo;
/
-----------------------
create sequence SEQ_IMROBJ increment by 1  start with 1 ;
/
create or replace PROCEDURE insertimrobject(
    reportid integer ,
    friendlyname   varchar2,
    objectdn   varchar2, 
    objectinfoname   varchar2,
    objectid OUT INTEGER )

AS
BEGIN
	BEGIN
            objectid := 0;
            Select imr_objectid into objectid from imrObject
			WHERE
				imr_reportid= reportid
				AND imr_objectdn = objectdn;
            EXCEPTION
		        WHEN NO_DATA_FOUND THEN
                objectid := 0;
    END;
    IF not  (objectid >0) THEN
    	SELECT SEQ_IMROBJ.NEXTVAL INTO objectid
        FROM Dual;
    insert into imrObject (
            imr_reportid ,
            imr_friendlyname  ,
            imr_objectdn,
            imr_objectinfoname,
            IMR_OBJECTID
          	)
            values (
            reportid ,
            friendlyname ,
            objectdn,
            objectinfoname,
            objectid
            );
    END IF;
END insertimrobject;
/

---------------
create or replace PROCEDURE insertimrobjectcategory(
    reportid integer ,
    name   varchar2)
AS 
    rowcount INTEGER;
BEGIN
    BEGIN
	    rowcount :=0;
Select count(*) into rowcount from imrObjectCategory
		WHERE
	    (imr_reportid= reportid
	    AND imr_name = name);
EXCEPTION
	       WHEN NO_DATA_FOUND THEN
	       rowcount :=0;
END;
IF rowcount = 0 THEN
        insert into imrObjectCategory (
            imr_reportid ,
            imr_name  
          )
            values (
            reportid ,
            name 
           );
END IF;
END insertimrobjectcategory;
/

-------------
create sequence SEQ_OBJINFO increment by 1  start with 1 ;
/
CREATE OR REPLACE PROCEDURE insertimrobjectinfo(
    reportid integer ,
    name   varchar2,
    objectcatname   varchar2,
    infoid OUT INTEGER )
AS
BEGIN
     BEGIN
		infoid := 0;
		Select imr_objectid into infoid from imrObjectInfo
        WHERE
            imr_reportid= reportid
            AND imr_name = name;
        EXCEPTION
		WHEN NO_DATA_FOUND THEN
           	infoid := 0;
    END;
	IF not  (infoid >0) THEN
		SELECT SEQ_OBJINFO.NEXTVAL INTO infoid
                    FROM Dual;
	    insert into imrObjectInfo (
            imr_reportid ,
            imr_objectid,
            imr_name  ,
	    	imr_objectcatname
          )
            values (
            reportid ,
            infoid,
            name ,
		objectcatname
            );
   END IF;
END insertimrobjectinfo;
/

-----------
create or replace PROCEDURE insertimrroletemplate(
    reportid integer ,
	roleoid varchar2,
    roledn   varchar2,
    templatedn   varchar2)
AS 
    rowcount INTEGER;
BEGIN
	BEGIN
		rowcount :=0;
        Select count (*) into rowcount from imrProvRoleTemplRelationship 
		WHERE
		    (imr_reportid= reportid
			and imr_roleoid=roleoid 
		    AND imr_roledn = roledn
			AND imr_templatedn = templatedn);
			EXCEPTION
				WHEN NO_DATA_FOUND THEN
			rowcount :=0;
                        
        END;
        IF rowcount = 0 THEN
            insert into imrProvRoleTemplRelationship(
            imr_reportid ,
			imr_roleoid,
            imr_roledn  ,
		    imr_templatedn
            )
            values (
            reportid ,
			roleoid,
            roledn ,
	    	templatedn
            );
        END IF;
END insertimrroletemplate;
/

CREATE OR REPLACE PROCEDURE insertProvRolesRel(
	reportid integer,
	parentoid varchar2,
	childoid varchar2)
AS
  rowcount integer;
BEGIN
	BEGIN
		rowcount:=0;
		select count(imr_reportid) into rowcount from imrProvRolesRelationship
		where 
			imr_reportid=reportid
			and imr_parentoid=parentoid
			and imr_childoid=childoid;
		  EXCEPTION
				 WHEN NO_DATA_FOUND THEN
		  rowcount :=0;
			
	END;
	IF not  (rowcount >0) THEN
		insert into imrProvRolesRelationship(
			imr_reportid,
			imr_parentoid,
			imr_childoid
		)
		values(
			reportid,
			parentoid,
			childoid
		);
	END IF;
END insertProvRolesRel;
/

CREATE VIEW endPointAttributes
AS
SELECT Attribute.imr_reportid as imr_reportid,  
	Attribute.imr_objectid as imr_endpointid, 
	Attribute.imr_attrInfoID as AttributeInfoID, AttributeInfo.imr_name as Name, 
	Attribute.imr_value as AttributeValue 
FROM 
	imrattribute Attribute, 
	imrattributeinfo AttributeInfo  
WHERE imr_objectid IN (SELECT endpointObject.imr_objectid
		FROM
			imrObject endpointObject,
			imrObjectCategory endpointCategory,
			imrObjectInfo endpointObjectInfo
		WHERE
			endpointObject.imr_objectinfoname = endpointObjectInfo.imr_name and
			endpointObjectInfo.imr_objectcatname = endpointCategory.imr_name and
			endpointCategory.imr_name = 'EndPoint' and 
			endpointCategory.imr_reportid = endpointObject.imr_reportid and 
			endpointObjectInfo.imr_reportid = endpointCategory.imr_reportid and
			endpointObject.imr_reportid = endpointCategory.imr_reportid)
AND AttributeInfo.imr_attrinfoid = Attribute.imr_attrinfoid;
/

CREATE VIEW accttmplattribute 
AS
SELECT
	acctTmplObject.imr_reportid as imr_reportid,
	acctTmplObject.imr_friendlyname as imr_accttmplname,
	acctTmplObject.imr_objectdn as imr_accttmpldn,
	acctTmplObjectInfo.imr_name as imr_endpointtype,
	resourceAttrInfo.imr_name as imr_attrname,
	resourceAttr.imr_value as imr_attrvalue,
	resourceAttr.imr_objectrefid as imr_objectrefid,
	resourceAttrInfo.imr_isbasetype as imr_isbasetype
FROM
	imrObjectCategory acctTmplCategory,
	imrObjectInfo acctTmplObjectInfo,
	imrObject acctTmplObject,
	imrAttributeInfo resourceAttrInfo,
	imrAttribute resourceAttr
WHERE
  -- NULL attr values means attr is a subattr
	(resourceAttr.imr_value IS NOT NULL or
	resourceAttr.imr_objectrefid IS NOT NULL) and
	resourceAttr.imr_objectid = acctTmplObject.imr_objectid and
	resourceAttrInfo.imr_attrinfoid = resourceAttr.imr_attrinfoid and
	acctTmplObject.imr_objectinfoname = acctTmplObjectInfo.imr_name and
	acctTmplObjectInfo.imr_objectcatname = acctTmplCategory.imr_name and
	acctTmplCategory.imr_name = 'Policy' and 
	acctTmplCategory.imr_reportid=acctTmplObject.imr_reportid and 
	acctTmplObjectInfo.imr_reportid = acctTmplObject.imr_reportid and 
	resourceAttrInfo.imr_reportid = acctTmplObject.imr_reportid and 
	resourceAttr.imr_reportid = acctTmplObject.imr_reportid;
/

CREATE VIEW endpointaccount 
AS
SELECT
	accountObject.imr_reportid as imr_reportid,
	endPointObject.imr_friendlyname as imr_endpoint,
	accountObjectInfo.imr_name as imr_endpointtype,
	accountObject.imr_friendlyname as imr_accountname,
	accountObject.imr_objectdn as imr_accountdn
FROM
	imrObject endPointObject,
	imrObjectInfo endPointObjectInfo,
	imrObjectCategory endPointCategory,
	imrObject accountObject,
	imrObjectInfo accountObjectInfo,
	imrObjectCategory accountCategory,
	imrAttributeInfo endPointAttrInfo,
	imrAttribute endPointAttr
WHERE
	endPointObject.imr_objectinfoname = endPointObjectInfo.imr_name and
	endPointObjectInfo.imr_objectcatname = endPointCategory.imr_name and
	endPointCategory.imr_name = 'EndPoint' and
	endPointObject.imr_friendlyname = endPointAttr.imr_value and
	endPointAttr.imr_attrinfoid = endPointAttrInfo.imr_attrinfoid and
	endPointAttrInfo.imr_name = 'endPointName' and
	endPointAttr.imr_objectid = accountObject.imr_objectid and
	accountObject.imr_objectinfoname = accountObjectInfo.imr_name and
	accountObjectInfo.imr_objectcatname = accountCategory.imr_name and
	accountCategory.imr_name = 'Account' and 
	endPointObject.imr_reportid=accountObject.imr_reportid and
	endPointObjectInfo.imr_reportid = accountObject.imr_reportid and
	endPointCategory.imr_reportid=accountObject.imr_reportid and 
	accountObjectInfo.imr_reportid = accountObject.imr_reportid and 
	accountCategory.imr_reportid = accountObject.imr_reportid and 
	endPointAttrInfo.imr_reportid = accountObject.imr_reportid and 
	endPointAttr.imr_reportid = accountObject.imr_reportid;
/

CREATE VIEW endpointview 
AS
SELECT
	endpointObject.imr_reportid as imr_reportid,
	endpointObject.imr_friendlyname as imr_endpoint,
	endpointObject.imr_objectdn as imr_endpointdn,
	endpointObject.imr_objectid as imr_endpointid,
	endpointObjectInfo.imr_name as imr_endpointtype
FROM
	imrObject endpointObject,
	imrObjectCategory endpointCategory,
	imrObjectInfo endpointObjectInfo
WHERE
	endpointObject.imr_objectinfoname = endpointObjectInfo.imr_name and
	endpointObjectInfo.imr_objectcatname = endpointCategory.imr_name and
	endpointCategory.imr_name = 'EndPoint' and 
	endpointCategory.imr_reportid = endpointObject.imr_reportid and 
	endpointObjectInfo.imr_reportid = endpointObject.imr_reportid;
/

CREATE VIEW provrolesrelationshipview 
AS
SELECT
	provRolesRelationship.imr_reportid as imr_reportid,
	provRolesRelationship.imr_parentoid as imr_parentoid,
	provRolesRelationship.imr_childoid as imr_childoid
FROM
	imrProvRolesRelationship provRolesRelationship;
/

CREATE VIEW accttemplEndpointRelView
AS
SELECT     
	imrObjectInfo.imr_name AS TemplateType, imrObject.imr_objectdn AS TemplateDN, 		     imrObject.imr_friendlyname AS TemplateName, 
    imrTemplEndpointRelationship.imr_endpointname AS EndpointName,  	imrTemplEndpointRelationship.imr_endpointdn AS EndpointDN, 
    imrObject.imr_reportid
FROM         
	imrTemplEndpointRelationship RIGHT OUTER JOIN
    imrObject ON imrTemplEndpointRelationship.imr_reportid = imrObject.imr_reportid AND 
    imrTemplEndpointRelationship.imr_templatedn = imrObject.imr_objectdn LEFT OUTER JOIN
    imrObjectCategory INNER JOIN
    imrObjectInfo ON imrObjectCategory.imr_name = imrObjectInfo.imr_objectcatname ON 	imrObject.imr_reportid = imrObjectCategory.imr_reportid AND 
    imrObject.imr_reportid = imrObjectInfo.imr_reportid AND imrObject.imr_objectinfoname = 	imrObjectInfo.imr_name
WHERE     
	(imrObjectCategory.imr_name = 'Policy');
/

CREATE VIEW capabilityattrsview
AS
SELECT     
imrCapabilityAttrRel.imr_reportid, imrCapabilityAttrRel.imr_endpointtype AS EndpointType, imrObject.imr_friendlyname AS EndpointName, 
                      imrObject.imr_objectdn AS EndpointDN, imrCapabilityAttrRel.imr_objecttypename, imrCapabilityAttrRel.imr_jiamobjecttypename, 
                      imrCapabilityAttrRel.imr_capabilityobjectname, imrCapabilityAttrRel.imr_capabilityobjectdn, imrCapabilityAttrRel.imr_endpointobjid AS endpointid, imrCapabilityAttrRel.imr_attrid AS Attributeid,imrCapabilityAttrRel.imr_name, imrCapabilityAttrRel.imr_value 
FROM imrCapabilityAttrRel, imrObject 
where 
	imrCapabilityAttrRel.imr_reportid = imrObject.imr_reportid
	and imrCapabilityAttrRel.imr_endpointobjid = imrObject.imr_objectid;
/

CREATE VIEW provroleaccttmplendptrelview
AS
SELECT     
	imrProvRoleTemplRelationship.imr_reportid, 
	imrProvRoleTemplRelationship.imr_roleoid,
	imrProvRoleTemplRelationship.imr_roledn,
	accttemplEndpointRelView.TemplateType,
	accttemplEndpointRelView.TemplateDN,
	accttemplEndpointRelView.TemplateName,
	accttemplEndpointRelView.EndpointName,
	accttemplEndpointRelView.EndpointDN
		
FROM         
	imrProvRoleTemplRelationship LEFT OUTER JOIN
    accttemplEndpointRelView ON imrProvRoleTemplRelationship.imr_reportid = accttemplEndpointRelView.imr_reportid 
	AND imrProvRoleTemplRelationship.imr_templatedn = accttemplEndpointRelView.TemplateDN;
/

----------
-- Cleanup Stuff
----------


--
-- PROCEDURE IMRCleanupProc6 For cleaning reports older than a month
-- *********DEPRICATED DO NOT USE
--
CREATE OR REPLACE PROCEDURE IMRCleanupProc6 AS
BEGIN
    DELETE FROM imrrole6 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imrroletask6 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imrtask6 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imrrolerule6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imrrolescoperule6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imrrolemember6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imrroleadmin6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imrroleowner6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imrorg6 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imrorgattr6 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imruser6 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imruserattr6 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imrgroup6 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imrgroupattr6 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imrgroupmember6 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imrgroupadmin6 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    -- delete identitypolicy related items
    DELETE FROM imridentitypolicy6 where imr_reportid IN
                 (
                 SELECT imreport6.imr_reportid
                 FROM imreport6
                 WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
   DELETE FROM imridentitypolicyset6 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
   DELETE FROM imridentitypolicyactions6 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
   DELETE FROM imridentitypolicyusersync6 where imr_reportid IN
                (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) )
                );
    DELETE FROM imreport6 WHERE ( imreport6.imr_reporttime < ADD_MONTHS(SYSDATE,-1) );
END IMRCleanupProc6 ;
/


--
-- Procedure for removing a snapshot from all the tables it exist
--
CREATE OR REPLACE PROCEDURE IMRRemoveSnapshot (
	id INTEGER)
AS
BEGIN
	DELETE FROM imrrole6 WHERE imr_reportid = id;
	DELETE FROM imrrolemember6 WHERE imr_reportid = id;
	DELETE FROM imrroleadmin6 WHERE imr_reportid = id;
	DELETE FROM imrroleowner6 WHERE imr_reportid = id;
	DELETE FROM imrrolerule6 WHERE imr_reportid = id;
	DELETE FROM imrrolescoperule6 WHERE imr_reportid = id;

	DELETE FROM imrroletask6 WHERE imr_reportid = id;
	DELETE FROM imrtask6 WHERE imr_reportid = id;

	DELETE FROM imrorg6 WHERE imr_reportid = id;
	DELETE FROM imrorgattr6 WHERE imr_reportid = id;

	DELETE FROM imruser6 WHERE imr_reportid = id;
	DELETE FROM imruserattr6 WHERE imr_reportid = id;

	DELETE FROM imrgroup6 WHERE imr_reportid = id;
	DELETE FROM imrgroupattr6 WHERE imr_reportid = id;
	DELETE FROM imrgroupmember6 WHERE imr_reportid = id;
	DELETE FROM imrgroupadmin6 WHERE imr_reportid = id;

	DELETE FROM imridentitypolicy6 WHERE imr_reportid = id;
	DELETE FROM imridentitypolicyset6 WHERE imr_reportid = id;
	DELETE FROM imridentitypolicyusersync6 WHERE imr_reportid = id;
	DELETE FROM imridentitypolicyactions6 WHERE imr_reportid = id;
	
	DELETE FROM imrAttribute WHERE imr_reportid = id;
	DELETE FROM imrAttributeInfo WHERE imr_reportid = id;
	DELETE FROM imrObject WHERE imr_reportid = id;
	DELETE FROM imrObjectCategory WHERE imr_reportid = id;
	DELETE FROM imrObjectInfo WHERE imr_reportid = id;
	DELETE FROM imrProvRolesRelationship WHERE imr_reportid = id;
	DELETE FROM imrProvRoleTemplRelationship WHERE imr_reportid = id;
	DELETE FROM imrUserAccountRelationship WHERE imr_reportid = id;
	DELETE FROM imrTemplEndpointRelationship WHERE imr_reportid = id;
	DELETE FROM imrAccountTemplateRel WHERE imr_reportid = id;
	DELETE FROM imrCapabilityAttrRel WHERE imr_reportid = id;
	DELETE FROM imrroleattr12 WHERE imr_reportid = id;
	

	DELETE FROM imreport6 WHERE imr_reportid = id;
END;
/

--
-- Procedure for keeping only top X snapshots that we want, and remove the rest.
--
CREATE OR REPLACE PROCEDURE IMRCleanOldSnapshotsProc (
	   skeep INTEGER,
	   name VARCHAR2,
	   source VARCHAR2)

IS
  snap_cur    SYS_REFCURSOR;
  at_rec      imreport6%ROWTYPE;

BEGIN
	 INSERT INTO retired_snapshots (SELECT * FROM imreport6 WHERE imr_reportname=name
	  AND imr_snapshotsource=source AND imr_snapshotstatus = 'Completed'
	   AND imr_reportid NOT IN
	    (SELECT imr_reportid FROM
		 (SELECT imr_reportid FROM imreport6 WHERE  imr_reportname=name
		  AND imr_snapshotsource=source AND imr_snapshotstatus = 'Completed' ORDER BY imr_reportid DESC)
		   WHERE ROWNUM <= skeep));

	 OPEN snap_cur FOR SELECT * FROM retired_snapshots;

	 LOOP
	  	  FETCH snap_cur INTO at_rec;
		  EXIT WHEN snap_cur%NOTFOUND;
		  IMRRemoveSnapshot (at_rec.imr_reportid);
	 END LOOP;

END;
/