-- Copyright (C) 2009, CA, Inc. All rights reserved.
--
-- This file contains the upgrade schema for all of the 12.5 SP1
-- tables for snapshot
--
--
-------------------------------------------------------------------


--IMRCleanupProc6
--Recreating the procedure below.
IF EXISTS (SELECT name FROM sysobjects
    WHERE name = 'IMRCleanupProc6' AND type = 'P')
    DROP PROCEDURE IMRCleanupProc6
GO

--IMRRemoveSnapshot
--Recreating the procedure below.
IF EXISTS (SELECT name FROM sysobjects
    WHERE name = 'IMRRemoveSnapshot' AND type = 'P')
    DROP PROCEDURE IMRRemoveSnapshot
GO

IF EXISTS(SELECT name
	  FROM 	 sysobjects
	  WHERE  name = 'imreport_version'
	  AND 	 type = 'U')
    DROP TABLE imreport_version
go

CREATE TABLE imreport_version (
    imr_key nvarchar(255) NOT NULL,
    imr_value nvarchar(255) NOT NULL
    )

insert into imreport_version(imr_key,imr_value) values ('version','12.5.1.0.0')
go

------------------------------------------------------
-- New r12.5 SP1 support.
------------------------------------------------------

--
-- IMR imrpolicyxpress125
--

CREATE TABLE imrpolicyxpress125 (
    imr_reportid integer  NOT NULL,
    imr_policyid     nvarchar(64) NOT NULL,
    imr_policyname    nvarchar(255) NOT NULL,
    imr_enabled    nvarchar(5) NOT NULL,
    imr_category    nvarchar(255) NOT NULL,
    imr_description    nvarchar(1023) NOT NULL,
    imr_runonce    nvarchar(5) NOT NULL,
    imr_priority    integer NOT NULL,
    imr_type    nvarchar(255) NOT NULL,
    imr_policyevents    ntext NOT NULL,
    imr_policydata    ntext NOT NULL,
    imr_entryrules    ntext NOT NULL,
    imr_actionrules    ntext NOT NULL,
    CONSTRAINT PK_01_imrpolicyxpress125 PRIMARY KEY  (imr_reportid, imr_policyid)
    )
go

CREATE INDEX imrpolicyxpress125_index_1 ON imrpolicyxpress125 (imr_reportid, imr_policyid)
go

--
-- IMR imrreversesyncmodifyaccount125
--

CREATE TABLE imrreversesyncmodifyaccount125 (
    imr_reportid integer  NOT NULL,
    imr_policyid     nvarchar(64) NOT NULL,
    imr_policyname    nvarchar(255) NOT NULL,
    imr_enabled    nvarchar(5) NOT NULL,
    imr_description    nvarchar(1023) NOT NULL,
    imr_priority    integer NOT NULL,
    imr_endpointtype    nvarchar(255) NOT NULL,
    imr_endpointname    nvarchar(1023) NOT NULL,
    imr_container    nvarchar(255) NOT NULL,
    imr_attributename    nvarchar(255) NOT NULL,
    imr_attributevalue    nvarchar(1023) NOT NULL,
    imr_action    nvarchar(255) NOT NULL,
    CONSTRAINT PK_01_imrreversesyncmodifyaccount125 PRIMARY KEY  (imr_reportid, imr_policyid)
    )
go

CREATE INDEX imrreversesyncmodifyaccount125_index_1 ON imrreversesyncmodifyaccount125 (imr_reportid, imr_policyid)
go

--
-- IMR imrreversesyncnewaccount125
--

CREATE TABLE imrreversesyncnewaccount125 (
    imr_reportid integer  NOT NULL,
    imr_policyid     nvarchar(64) NOT NULL,
    imr_policyname    nvarchar(255) NOT NULL,
    imr_enabled    nvarchar(5) NOT NULL,
    imr_description    nvarchar(1023) NOT NULL,
    imr_priority    integer NOT NULL,
    imr_endpointtype    nvarchar(255) NOT NULL,
    imr_endpointname    nvarchar(1023) NOT NULL,
    imr_container    nvarchar(255) NOT NULL,
    imr_targetuserstatus    nvarchar(255) NOT NULL,
    imr_action    nvarchar(255) NOT NULL,
    CONSTRAINT PK_01_imrreversesyncnewaccount125 PRIMARY KEY  (imr_reportid, imr_policyid)
    )
go

CREATE INDEX imrreversesyncnewaccount125_index_1 ON imrreversesyncnewaccount125 (imr_reportid, imr_policyid)
go
--
-- IMR imremailmanagement125
--

CREATE TABLE imremailmanagement125 (
    imr_reportid integer  NOT NULL,
    imr_emailid     nvarchar(64) NOT NULL,
    imr_emailname    nvarchar(255) NOT NULL,
    imr_enabled    nvarchar(5) NOT NULL,
    imr_category    nvarchar(255) NOT NULL,
    imr_description    nvarchar(1023) NOT NULL,
    imr_subject    nvarchar(1023) NOT NULL,
    CONSTRAINT PK_01_imremailmanagement125 PRIMARY KEY  (imr_reportid, imr_emailid)
    )
go

CREATE INDEX imremailmanagement125_index_1 ON imremailmanagement125 (imr_reportid, imr_emailid)
go

--
-- IMR imrbulktasks125
--

CREATE TABLE imrbulktasks125 (
    imr_reportid integer  NOT NULL,
    imr_bulktaskid     nvarchar(64) NOT NULL,
    imr_bulktaskname    nvarchar(255) NOT NULL,
    imr_description    nvarchar(1023) NOT NULL,
    imr_tasktag    nvarchar(255) NOT NULL,
    imr_objecttype    nvarchar(255) NOT NULL,
    imr_initiator    nvarchar(255) NOT NULL,
    imr_dateformat    nvarchar(255) NOT NULL,
    imr_populationrule    ntext NULL,
    imr_datefilter    ntext NULL,
    CONSTRAINT PK_01_imrbulktasks125 PRIMARY KEY  (imr_reportid, imr_bulktaskid)
    )
go

CREATE INDEX imrbulktasks125_index_1 ON imrbulktasks125 (imr_reportid, imr_bulktaskid)
go

------------------------------------------------------
-- End of r12.5 SP1 support.
------------------------------------------------------


----------
-- Cleanup Stuff
----------

--
-- PROCEDURE IMRCleanupProc6 For cleaning reports older than a month
-- *********DEPRICATED DO NOT USE
--

CREATE PROCEDURE IMRCleanupProc6 AS
BEGIN


    DELETE FROM imrrole6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
    DELETE FROM imrroletask6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
    DELETE FROM imrtask6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )

    DELETE FROM imrrolerule6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )

    DELETE FROM imrrolescoperule6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )

    DELETE FROM imrrolemember6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )

    DELETE FROM imrroleadmin6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
    DELETE FROM imrroleowner6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
    DELETE FROM imrorg6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
    DELETE FROM imrorgattr6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
    DELETE FROM imruser6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
    DELETE FROM imruserattr6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
    DELETE FROM imrgroup6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
    DELETE FROM imrgroupattr6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
               WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
    DELETE FROM imrgroupmember6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
               WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
    DELETE FROM imrgroupadmin6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
               WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
-- add identitypolicy support
     DELETE FROM imridentitypolicy6 where imr_reportid IN (
                 SELECT imreport6.imr_reportid
                 FROM imreport6
                WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
    DELETE FROM imridentitypolicyset6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
               WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
     DELETE FROM imridentitypolicyusersync6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
               WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )

     DELETE FROM imridentitypolicyactions6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
               WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
-- end of identitypolicy support
-- 12.5 SP1 support
     DELETE FROM imrpolicyxpress125 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
               WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
		)
     DELETE FROM imrreversesyncnewaccount125 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
               WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
		)
     DELETE FROM imrreversesyncmodifyaccount125 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
               WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
		)
     DELETE FROM imremailmanagement125 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
               WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
		)
     DELETE FROM imrbulktasks125 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
               WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
		)
-- end of 12.5 SP1 support

    DELETE FROM imreport6 WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )

END
go


CREATE PROCEDURE IMRRemoveSnapshot
	@id int
AS
BEGIN
	DELETE FROM imrrole6 WHERE imr_reportid = @id
	DELETE FROM imrrolemember6 WHERE imr_reportid = @id
	DELETE FROM imrroleadmin6 WHERE imr_reportid = @id
	DELETE FROM imrroleowner6 WHERE imr_reportid = @id
	DELETE FROM imrrolerule6 WHERE imr_reportid = @id
	DELETE FROM imrrolescoperule6 WHERE imr_reportid = @id

	DELETE FROM imrroletask6 WHERE imr_reportid = @id
	DELETE FROM imrtask6 WHERE imr_reportid = @id

	DELETE FROM imrorg6 WHERE imr_reportid = @id
	DELETE FROM imrorgattr6 WHERE imr_reportid = @id

	DELETE FROM imruser6 WHERE imr_reportid = @id
	DELETE FROM imruserattr6 WHERE imr_reportid = @id

	DELETE FROM imrgroup6 WHERE imr_reportid = @id
	DELETE FROM imrgroupattr6 WHERE imr_reportid = @id
	DELETE FROM imrgroupmember6 WHERE imr_reportid = @id
	DELETE FROM imrgroupadmin6 WHERE imr_reportid = @id

	DELETE FROM imridentitypolicy6 WHERE imr_reportid = @id
	DELETE FROM imridentitypolicyset6 WHERE imr_reportid = @id
	DELETE FROM imridentitypolicyusersync6 WHERE imr_reportid = @id
	DELETE FROM imridentitypolicyactions6 WHERE imr_reportid = @id

	DELETE FROM imrAttribute WHERE imr_reportid = @id;
	DELETE FROM imrAttributeInfo WHERE imr_reportid = @id;
	DELETE FROM imrObject WHERE imr_reportid = @id;
	DELETE FROM imrObjectCategory WHERE imr_reportid = @id;
	DELETE FROM imrObjectInfo WHERE imr_reportid = @id;
	DELETE FROM imrProvRolesRelationship WHERE imr_reportid = @id;
	DELETE FROM imrProvRoleTemplRelationship WHERE imr_reportid = @id;
	DELETE FROM imrUserAccountRelationship WHERE imr_reportid = @id;
	DELETE FROM imrTemplEndpointRelationship WHERE imr_reportid = @id;
	DELETE FROM imrAccountTemplateRel WHERE imr_reportid = @id;
	DELETE FROM imrCapabilityAttrRel WHERE imr_reportid = @id;
	DELETE FROM imrroleattr12 WHERE imr_reportid = @id;

	-- 12.5 SP1 support
	DELETE FROM imrpolicyxpress125 WHERE imr_reportid = @id
	DELETE FROM imrreversesyncnewaccount125 WHERE imr_reportid = @id
	DELETE FROM imrreversesyncmodifyaccount125 WHERE imr_reportid = @id
	DELETE FROM imremailmanagement125 WHERE imr_reportid = @id
	DELETE FROM imrbulktasks125 WHERE imr_reportid = @id
	-- End of 12.5 SP1 support

	DELETE FROM imreport6 WHERE imr_reportid = @id
END
GO