-- Copyright (C) 2009, CA, Inc. All rights reserved.
--
-- This file contains the upgrade schema for all of the 12.5
-- tables for snapshot
--
--
-------------------------------------------------------------------



------------------------------------------------
-- Rename the table that will not be used any more
------------------------------------------------
EXEC sp_rename 'imruseraccounts6', 'imruseraccounts6_bak'
go

EXEC sp_rename 'imraccountattrs6', 'imraccountattrs6_bak'
go


------------------------------------------------   
-- Drop items no longer used
------------------------------------------------

--imruseraccounts6_index_1
IF EXISTS (SELECT name FROM sysindexes
         WHERE name = 'imruseraccounts6_index_1')
   DROP INDEX imruseraccounts6_bak.imruseraccounts6_index_1
GO

--imruseraccounts6_index_2
IF EXISTS (SELECT name FROM sysindexes
         WHERE name = 'imruseraccounts6_index_2')
   DROP INDEX imruseraccounts6_bak.imruseraccounts6_index_2
GO
--imruseraccounts6_index_3
IF EXISTS (SELECT name FROM sysindexes
         WHERE name = 'imruseraccounts6_index_3')
   DROP INDEX imruseraccounts6_bak.imruseraccounts6_index_3
GO
--imruseraccounts6_index_4
IF EXISTS (SELECT name FROM sysindexes
         WHERE name = 'imruseraccounts6_index_4')
   DROP INDEX imruseraccounts6_bak.imruseraccounts6_index_4
GO
--imruseraccounts6_index_5
IF EXISTS (SELECT name FROM sysindexes
         WHERE name = 'imruseraccounts6_index_5')
   DROP INDEX imruseraccounts6_bak.imruseraccounts6_index_5
GO
--insertintoimruseraccounts
IF EXISTS (SELECT name FROM sysobjects
    WHERE name = 'insertintoimruseraccounts' AND type = 'P')
    DROP PROCEDURE insertintoimruseraccounts
GO
--insertintoaccountAttributes
IF EXISTS (SELECT name FROM sysobjects
    WHERE name = 'insertintoaccountAttributes' AND type = 'P')
    DROP PROCEDURE insertintoaccountAttributes
GO

--IMRCleanupProc6 
--Recreating the procedure below.
IF EXISTS (SELECT name FROM sysobjects
    WHERE name = 'IMRCleanupProc6' AND type = 'P')
    DROP PROCEDURE IMRCleanupProc6
GO

--IMRRemoveSnapshot 
--Recreating the procedure below.
IF EXISTS (SELECT name FROM sysobjects
    WHERE name = 'IMRRemoveSnapshot' AND type = 'P')
    DROP PROCEDURE IMRRemoveSnapshot
GO

--IMRRemoveSnapshot 
--Recreating the procedure below.
IF EXISTS (SELECT name FROM sysobjects
    WHERE name = 'IMRCleanOldSnapshotsProc' AND type = 'P')
    DROP PROCEDURE IMRCleanOldSnapshotsProc
GO

--totalExceptionAccounts 
--Recreating the view below.
IF EXISTS (SELECT name FROM sysobjects
    WHERE name = 'totalExceptionAccounts' AND type = 'V')
    DROP VIEW totalExceptionAccounts
GO


-- Add the Version table
CREATE TABLE imreport_version (
    imr_key nvarchar(255) NOT NULL,
    imr_value nvarchar(255) NOT NULL
    )
go

insert into imreport_version(imr_key,imr_value) values ('version','12.5.0.0.0')
go

------------------------------------------------------ 
-- New r12.5 support.
------------------------------------------------------ 
CREATE TABLE [imrAttribute] (
	[imr_reportid] [int] NOT NULL ,
	[imr_objectid] [int] NOT NULL ,
	[imr_attrinfoid] [int] NOT NULL ,
	[imr_value] nvarchar(max) NULL ,
	[imr_objectrefid] [int] NULL 
) ON [PRIMARY]
GO

CREATE INDEX imrattribute_index_1 ON imrattribute (imr_reportid, imr_attrinfoid, imr_objectid)
go

CREATE INDEX imrattribute_index_2 ON imrattribute (imr_reportid, imr_objectid)
go

CREATE INDEX imrattribute_index_3 ON imrattribute (imr_reportid)
INCLUDE(imr_value)
go

CREATE TABLE [imrAttributeInfo] (
	[imr_reportid] [int] NOT NULL ,
	[imr_attrinfoid] [int] IDENTITY (1, 1) NOT NULL ,
	[imr_syntaxid] [int] NOT NULL ,
	[imr_name] [nvarchar] (64) NOT NULL ,
	[imr_objectinfoid] [int] NOT NULL ,
	[imr_isbasetype] [nvarchar] (256) NULL 
) ON [PRIMARY]
GO

CREATE INDEX imrattributeinfo_index_1 ON imrattributeinfo (imr_reportid, imr_name)
go

CREATE TABLE [imrObject] (
	[imr_reportid] [int] NOT NULL ,
	[imr_friendlyname] [nvarchar] (255) NOT NULL ,
	[imr_objectdn] [nvarchar] (628) NOT NULL ,
	[imr_objectinfoname] [nvarchar] (255) NOT NULL ,
	[imr_objectid] [int] IDENTITY (1, 1) NOT NULL 
) ON [PRIMARY]
GO

CREATE INDEX imrobject_index_1 ON imrobject (imr_reportid)
	INCLUDE(imr_friendlyname)
go

CREATE INDEX imrobject_index_2 ON imrobject (imr_reportid)
	INCLUDE(imr_objectdn)
go

CREATE TABLE [imrObjectCategory] (
	[imr_reportid] [int] NOT NULL ,
	[imr_name] [nvarchar] (255) NOT NULL 
) ON [PRIMARY]
GO

CREATE INDEX imrobjectcategory_index_1 ON imrobjectcategory (imr_reportid, imr_name)
go

CREATE TABLE [imrObjectInfo] (
	[imr_reportid] [int] NOT NULL ,
	[imr_objectid] [int] IDENTITY (1, 1) NOT NULL ,
	[imr_name] [nvarchar] (255) NOT NULL ,
	[imr_objectcatname] [nvarchar] (255) NOT NULL 
) ON [PRIMARY]
GO

CREATE INDEX imrobjectinfo_index_1 ON imrobjectinfo (imr_reportid, imr_name)
go

CREATE TABLE [imrProvRolesRelationship] (
	[imr_reportid] [int] NOT NULL ,
	[imr_parentoid] [nvarchar] (64) NOT NULL ,
	[imr_childoid] [nvarchar] (64) NOT NULL 
) ON [PRIMARY]
GO

CREATE INDEX imrprovrolesrel_index_1 ON imrProvRolesRelationship (imr_reportid, imr_parentoid, imr_childoid)
go

CREATE TABLE imrProvRoleTemplRelationship (
	imr_reportid int NOT NULL ,
    imr_roleoid    nvarchar(64) NOT NULL,
	imr_roledn nvarchar(628) NOT NULL ,
	imr_templatedn nvarchar(628) NOT NULL 
)
GO

CREATE INDEX imrprovroletemplrel_index_1 ON imrprovroletemplrelationship (imr_reportid, imr_roleoid)
	INCLUDE(imr_templatedn, imr_roledn)
go

CREATE TABLE [imrUserAccountRelationship] (
	[imr_reportid] [int] NOT NULL ,
	[imr_useraccountdn] [nvarchar] (1024) NOT NULL ,
	[imr_provuserdn] [nvarchar] (1024) NOT NULL ,
	[imr_userid] [nvarchar] (1024) NOT NULL ,
) ON [PRIMARY]
GO

CREATE INDEX imruseraccountrel_index_1 ON imruseraccountrelationship (imr_reportid)
	INCLUDE (imr_useraccountdn)
go

CREATE INDEX imruseraccountrel_index_2 ON imruseraccountrelationship (imr_reportid)
	INCLUDE (imr_provuserdn)
go

CREATE INDEX imruseraccountrel_index_3 ON imruseraccountrelationship (imr_reportid)
	INCLUDE (imr_userid)
go

-- Procedures to insert in to the provisioning tables


CREATE PROCEDURE insertimrAttrInfo 
	@imr_reportid integer,
	@imr_syntaxid integer,
	@imr_name nvarchar(64),
	@imr_objectinfoid integer,
	@imr_isbasetype char(1),    
	@infoid INTEGER OUTPUT
AS
BEGIN
SET @infoid = 0;
Select @infoid =imr_attrinfoid  from imrAttributeInfo
        WHERE
           ( imr_reportid= @imr_reportid
            AND imr_name  = @imr_name
            AND imr_objectinfoid  = @imr_objectinfoid ) ;

  IF not  @infoid >0
       BEGIN
 	INSERT into imrAttributeInfo(
            imr_reportid, 
            imr_syntaxid,
            imr_name,
            imr_objectinfoid,
	imr_isbasetype		
		) 
            values (
	@imr_reportid, 
            	@imr_syntaxid,
            	@imr_name,
            	@imr_objectinfoid,
	@imr_isbasetype
		) 
      SELECT @infoid=IDENT_CURRENT('imrAttributeInfo');
    END
END
GO

CREATE PROCEDURE insertimrobject
    @imr_reportid integer ,
    @imr_friendlyname   nvarchar(255),
    @imr_objectdn   nvarchar(628), 
    @imr_objectinfoname   nvarchar(255),
    @objectid INTEGER OUTPUT

AS
BEGIN
SET @objectid = 0;
Select @objectid = imr_objectid  from imrObject
        WHERE
            imr_reportid= @imr_reportid
            AND imr_objectdn = @imr_objectdn;

    IF not  @objectid >0
     BEGIN
        insert into imrObject (
            imr_reportid ,
            imr_friendlyname  ,
            imr_objectdn,
	imr_objectinfoname

          )
            values (
            @imr_reportid ,
            @imr_friendlyname ,
	@imr_objectdn,
	@imr_objectinfoname

            )
	SELECT @objectid=IDENT_CURRENT('imrObject');
      END
END
GO

CREATE PROCEDURE insertimrobjectcategory
    @imr_reportid integer ,
    @imr_name   nvarchar(255) 

AS
BEGIN
    IF NOT EXISTS (Select imr_name  from imrObjectCategory
        WHERE
            imr_reportid= @imr_reportid
            AND imr_name = @imr_name)
        insert into imrObjectCategory (
            imr_reportid ,
            imr_name  

          )
            values (
            @imr_reportid ,
            @imr_name 

            );
END
GO

CREATE PROCEDURE insertimrobjectinfo
    @imr_reportid integer ,
    @imr_name   nvarchar(255),
    @imr_objectcatname   nvarchar(255) ,
    @infoid INTEGER OUTPUT

AS
BEGIN
SET @infoid = 0;
Select @infoid=imr_objectid  from imrObjectInfo
        WHERE
            imr_reportid= @imr_reportid
            AND imr_name = @imr_name;

IF not  @infoid >0
    BEGIN
        insert into imrObjectInfo (
            imr_reportid ,
            imr_name  ,
	    imr_objectcatname

          )
            values (
            @imr_reportid ,
            @imr_name ,
	@imr_objectcatname

            )
         SELECT @infoid=IDENT_CURRENT('imrObjectInfo');
   END

END
GO

CREATE PROCEDURE insertimrroletemplate
    @imr_reportid integer ,
	@imr_roleoid nvarchar(64),
    @imr_roledn   nvarchar(628),
    @imr_templatedn   nvarchar(628) 

AS
BEGIN
    IF NOT EXISTS (Select imr_roledn from imrProvRoleTemplRelationship
        WHERE
            imr_reportid= @imr_reportid
			and imr_roleoid = @imr_roleoid
            AND imr_roledn = @imr_roledn
   	    AND imr_templatedn = @imr_templatedn)
        insert into imrProvRoleTemplRelationship(
            imr_reportid ,
			imr_roleoid,
            imr_roledn  ,
	    imr_templatedn

          )
            values (
            @imr_reportid ,
			@imr_roleoid,
            @imr_roledn ,
	    @imr_templatedn

            );
END
GO

CREATE PROCEDURE insertTemplEndpointRel
	@imr_reportid integer,
	@imr_templatedn nvarchar(628),
	@imr_endpointname nvarchar(628),
	@imr_endpointdn nvarchar(628)
AS
BEGIN
	IF NOT EXISTS (select imr_reportid from imrTemplEndpointRelationship
		where
			imr_reportid=@imr_reportid
			and imr_templatedn=@imr_templatedn
			and imr_endpointname=@imr_endpointname
			and imr_endpointdn=@imr_endpointdn)
			insert into imrTemplEndpointRelationship(
				imr_reportid,
				imr_templatedn,
				imr_endpointname,
				imr_endpointdn
			)
			values(
				@imr_reportid,
				@imr_templatedn,
				@imr_endpointname,
				@imr_endpointdn
			);
END
GO

CREATE PROCEDURE insertAccountTemplateRel
	@imr_reportid integer,
	@imr_name nvarchar(628),
	@imr_templatedn nvarchar(628),
	@imr_endpointtype nvarchar(628)
AS
BEGIN
	IF NOT EXISTS (select imr_reportid from imrAccountTemplateRel
		where
			imr_reportid=@imr_reportid
			and imr_name=@imr_name
			and imr_templatedn=@imr_templatedn
			and imr_endpointtype=@imr_endpointtype)
			insert into imrAccountTemplateRel(
				imr_reportid,
				imr_name,
				imr_templatedn,
				imr_endpointtype
			)
			values(
				@imr_reportid,
				@imr_name,
				@imr_templatedn,
				@imr_endpointtype
			);
END
GO

CREATE PROCEDURE insertProvRolesRel
	@imr_reportid integer,
	@imr_parentoid nvarchar(64),
	@imr_childoid nvarchar(64)
AS
BEGIN
	IF NOT EXISTS(select imr_reportid from imrProvRolesRelationship
		where 
			imr_reportid=@imr_reportid
			and imr_parentoid=@imr_parentoid
			and imr_childoid=@imr_childoid)
			insert into imrProvRolesRelationship(
				imr_reportid,
				imr_parentoid,
				imr_childoid
			)
			values(
				@imr_reportid,
				@imr_parentoid,
				@imr_childoid
			);
			
END
GO

--
-- IM imrTemplEndpointRelationship
--
CREATE TABLE imrTemplEndpointRelationship (
    imr_reportid integer  NOT NULL,
	imr_templatedn nvarchar(628) ,
	imr_endpointname nvarchar(628) ,
	imr_endpointdn nvarchar(628) 
    )
go

CREATE INDEX imrtemplendpointrel_index_1 ON imrtemplendpointrelationship (imr_reportid)
	INCLUDE(imr_templatedn, imr_endpointname)
go

--
-- IM imrAccount
--

CREATE TABLE imrAccountTemplateRel (
    imr_reportid integer  NOT NULL,
	imr_name nvarchar(628) NOT NULL,
	imr_templatedn nvarchar(628),
	imr_endpointtype nvarchar(628) 
    )
go

CREATE INDEX imrAccountTemplateRel ON imrAccountTemplateRel (imr_reportid)
	INCLUDE(imr_name,imr_templatedn,imr_endpointtype)
go

CREATE TABLE imrCapabilityAttrRel (
    imr_reportid integer  NOT NULL,
	imr_endpointtype nvarchar(628) not null,
	imr_objecttypename nvarchar(628) NOT NULL,
	imr_jiamobjecttypename nvarchar(628) NOT NULL,
	imr_attrid integer,
	imr_capabilityobjectname nvarchar(628) NOT NULL,
	imr_capabilityobjectdn nvarchar(628) NOT NULL,
	imr_endpointobjid integer,
	imr_name nvarchar(64),
	imr_value nvarchar(max)
    )
go

CREATE INDEX imrcapabilityattrrel_index_1 ON imrcapabilityattrrel (imr_reportid)
	INCLUDE(imr_endpointtype, imr_endpointobjid, imr_objecttypename, imr_capabilityobjectdn, imr_name)
go

CREATE TABLE imrroleattr12(
	imr_reportid int NOT NULL,
	imr_roleoid nvarchar(64) NOT NULL,
	imr_name nvarchar(628) NOT NULL,
	imr_value nvarchar(max)  NULL
) 
GO

CREATE INDEX imrroleattr12_index_1 ON imrroleattr12 (imr_reportid, imr_roleoid)
	INCLUDE(imr_name)
go

--
-- IM imrCapabilityAttrRel
--

CREATE PROCEDURE insertCapabilityAttrRel
	@imr_reportid integer,
	@imr_endpointtype nvarchar(628),
	@imr_objecttypename nvarchar(628),
	@imr_jiamobjecttypename nvarchar(628) ,
	@imr_attrid integer,
	@imr_capabilityobjectname nvarchar(628),
	@imr_capabilityobjectdn nvarchar(628),
	@imr_endpointobjid integer,
	@imr_name nvarchar(64),
	@imr_value nvarchar(max)
	
AS
BEGIN
	IF NOT EXISTS (select imr_reportid from imrCapabilityAttrRel
		where
			imr_reportid=@imr_reportid
			and imr_endpointtype=@imr_endpointtype
			and imr_objecttypename=@imr_objecttypename
			and imr_endpointtype=@imr_endpointtype
			and imr_jiamobjecttypename=@imr_jiamobjecttypename
			and imr_attrid=@imr_attrid
			and imr_capabilityobjectname=@imr_capabilityobjectname
			and imr_capabilityobjectdn=@imr_capabilityobjectdn
			and imr_endpointobjid=@imr_endpointobjid 
			and imr_name=@imr_name)
			insert into imrCapabilityAttrRel(
				imr_reportid,
				imr_endpointtype,
				imr_objecttypename,
				imr_jiamobjecttypename,
				imr_attrid,
				imr_capabilityobjectname,
				imr_capabilityobjectdn,
				imr_endpointobjid,
				imr_name,
				imr_value
			)
			values(
				@imr_reportid,
				@imr_endpointtype,
				@imr_objecttypename,
				@imr_jiamobjecttypename,
				@imr_attrid,
				@imr_capabilityobjectname,
				@imr_capabilityobjectdn,
				@imr_endpointobjid,
				@imr_name,
				@imr_value
			);
END
GO

CREATE PROCEDURE insertintoimrroleattr12
	@imr_reportid integer,
	@imr_roleoid nvarchar(64),
	@imr_name nvarchar(256),
	@imr_value nvarchar(max)
AS
BEGIN
	IF NOT EXISTS (select imr_name from imrroleattr12
		where
			imr_reportid = @imr_reportid
			and imr_roleoid = @imr_roleoid
			and imr_name = @imr_name)
			insert into imrroleattr12(
				imr_reportid,
				imr_roleoid,
				imr_name,
				imr_value
			)
			values(
				@imr_reportid,
				@imr_roleoid,
				@imr_name,
				@imr_value
			);
END
GO

-- ---- Views

CREATE VIEW imruseraccounts6 
AS
SELECT 	accountObject.imr_reportid as imr_reportid,
	imruser.imr_userid as imr_userid,
	accountObject.imr_friendlyname as imr_accountname,
	accountObject.imr_objectdn as imr_accountdn,
	endPointAttr.imr_value as imr_endpoint,
	accountObject.imr_objectinfoname as imr_accounttype,
	accountAttr.imr_value as imr_createtime
FROM imrObject accountObject,
	imrUserAccountRelationship userAccountRelationship,
	imrAttributeInfo endPointAttrInfo,
	imrAttribute endPointAttr,
	imrAttributeInfo accountAttrInfo,
	imrAttribute accountAttr,
	imruser6 imruser
WHERE imruser.imr_userid = userAccountRelationship.imr_userid and
	accountObject.imr_objectdn = userAccountRelationship.imr_useraccountdn and
	accountObject.imr_objectid = endPointAttr.imr_objectid and
	endPointAttr.imr_attrinfoid = endPointAttrInfo.imr_attrinfoid and 
	endPointAttrInfo.imr_name = 'endPointName' and 
	accountAttr.imr_attrinfoid = accountAttrInfo.imr_attrinfoid and 
	accountAttrInfo.imr_name='createStatistics' and 
	accountObject.imr_objectid = accountAttr.imr_objectid and
	accountObject.imr_reportid=imruser.imr_reportid and 
	userAccountRelationship.imr_reportid = imruser.imr_reportid and
	endPointAttrInfo.imr_reportid = imruser.imr_reportid and
	endPointAttr.imr_reportid = imruser.imr_reportid and 
	accountAttrInfo.imr_reportid = imruser.imr_reportid and
	accountAttr.imr_reportid = imruser.imr_reportid;
GO

CREATE VIEW imraccountattrs6 
AS
SELECT
	accountObject.imr_reportid as imr_reportid,
	accountObject.imr_objectid as accountObjid,
	accountObject.imr_friendlyname as imr_accountname,
	accountObject.imr_objectdn as imr_accountdn,
	(SELECT imr_value
	FROM
		imrAttribute endPointAttr,
		imrAttributeInfo endPointAttrInfo
	WHERE
		accountObject.imr_objectid = endPointAttr.imr_objectid and
		endPointAttr.imr_attrinfoid = endPointAttrInfo.imr_attrinfoid and
		endPointAttrInfo.imr_name = 'endPointName' 
	) as imr_endpoint,
	accountObjectInfo.imr_name as imr_endpointtype,
	resourceAttrInfo.imr_name as imr_accountattr,
	resourceAttr.imr_value as imr_accountattrvalue,
	resourceAttr.imr_objectrefid as imr_objectrefid,
	resourceAttrInfo.imr_isbasetype as imr_isbasetype
FROM
	imrObjectCategory accountCategory,
	imrObjectInfo accountObjectInfo,
	imrObject accountObject,
	imrAttributeInfo resourceAttrInfo,
	imrAttribute resourceAttr
WHERE
	(resourceAttr.imr_value IS NOT NULL or
	resourceAttr.imr_objectrefid IS NOT NULL) and
	resourceAttr.imr_objectid = accountObject.imr_objectid and
	resourceAttrInfo.imr_attrinfoid = resourceAttr.imr_attrinfoid and
	accountObject.imr_objectinfoname = accountObjectInfo.imr_name and
	accountObjectInfo.imr_objectcatname = accountCategory.imr_name and
	accountCategory.imr_name = 'Account' and
	accountCategory.imr_reportid=accountObject.imr_reportid and
	accountObjectInfo.imr_reportid=accountObject.imr_reportid and
	resourceAttrInfo.imr_reportid=accountObject.imr_reportid and
	resourceAttr.imr_reportid=accountObject.imr_reportid;

GO

CREATE VIEW endpointaccountattrs6
AS
SELECT
	accountObject.imr_reportid as imr_reportid,
	accountObject.imr_objectid as imr_accountid,
	accountObject.imr_friendlyname as imr_accountname,
	accountObject.imr_objectdn as imr_accountdn,
	(SELECT imr_value
	FROM
		imrAttribute endPointAttr,
		imrAttributeInfo endPointAttrInfo
	WHERE
		accountObject.imr_objectid = endPointAttr.imr_objectid and
		endPointAttr.imr_attrinfoid = endPointAttrInfo.imr_attrinfoid and
		endPointAttrInfo.imr_name = 'endPointName' 
	) as imr_endpoint,
	accountObjectInfo.imr_name as imr_endpointtype,
	attr1.imr_value as imr_createtime,
	attr2.imr_value as imr_accountlastmodified
FROM
	imrObjectCategory accountCategory,
	imrObjectInfo accountObjectInfo,
	imrObject accountObject,
	imrAttributeInfo attrInfo1,
	imrAttribute attr1,
	imrAttributeInfo attrInfo2,
	imrAttribute attr2
WHERE
	(attr1.imr_value IS NOT NULL or
	attr1.imr_objectrefid IS NOT NULL or
	attr2.imr_value IS NOT NULL or
	attr2.imr_objectrefid IS NOT NULL) and
	attr1.imr_objectid = accountObject.imr_objectid and
	attr2.imr_objectid = accountObject.imr_objectid and
	accountObject.imr_objectinfoname = accountObjectInfo.imr_name and
	accountObjectInfo.imr_objectcatname = accountCategory.imr_name and
	accountCategory.imr_name = 'Account' and
	(attr1.imr_attrinfoid = attrInfo1.imr_attrinfoid and 
	attrInfo1.imr_name = 'createStatistics') and 
	(attr2.imr_attrinfoid = attrInfo2.imr_attrinfoid and 
	attrInfo2.imr_name = 'updateStatistics') and 
	accountCategory.imr_reportid=accountObject.imr_reportid and
	accountObjectInfo.imr_reportid=accountObject.imr_reportid and
	attrInfo1.imr_reportid=accountObject.imr_reportid and
	attr1.imr_reportid=accountObject.imr_reportid and 
	attrInfo2.imr_reportid=accountObject.imr_reportid and
	attr2.imr_reportid=accountObject.imr_reportid;
GO


CREATE VIEW endpointuseraccounts6
AS
SELECT 
	a.imr_reportid imr_reportid, 
	b.imr_userid imr_userid, 
	a.imr_accountname imr_accountname, 
	a.imr_accountdn imr_accountdn, 
	a.imr_endpoint as imr_endpoint,
	a.imr_endpointtype imr_accounttype, 
	a.imr_createtime imr_createtime,
	a.imr_accountlastmodified imr_accountlastmodified,
	c.imr_firstname imr_firstname,
	c.imr_lastname imr_lastname,
	c.imr_fullname imr_fullname
FROM  
	endpointaccountattrs6 a, 
	imrUserAccountRelationship b,
	imruser6 c 
WHERE 
	b.imr_useraccountdn = a.imr_accountid
	and b.imr_reportid = a.imr_reportid
	and c.imr_reportid = a.imr_reportid
	and c.imr_userid=b.imr_userid;
GO

CREATE   VIEW totalExceptionAccounts
AS
SELECT     imr_reportid AS REPORT_ID, imr_accounttype AS END_POINT_TYPE, imr_endpoint AS END_POINT, 'Exception' AS EXCEPTION_TYPE,
           imr_accountname AS ACCOUNT_NAME, imr_createtime as CREATION_DATE, imr_accountlastmodified as LAST_MODIFIED 
FROM         endpointuseraccounts6
WHERE imr_userid NOT IN ( '[default user]','[system user]')
UNION
-- ADD ORPHAN ACCOUNTS
SELECT     imr_reportid AS REPORT_ID, imr_accounttype AS END_POINT_TYPE, imr_endpoint AS END_POINT, 'Orphan' AS EXCEPTION_TYPE,
           imr_accountname AS ACCOUNT_NAME, imr_createtime as CREATION_DATE, imr_accountlastmodified as LAST_MODIFIED 
FROM         endpointuseraccounts6
WHERE      imr_userid  IN('[default user]')
UNION
-- ADD SYSTEM ACCOUNTS
SELECT     imr_reportid AS REPORT_ID, imr_accounttype AS END_POINT_TYPE, imr_endpoint AS END_POINT, 'System' AS EXCEPTION_TYPE,
           imr_accountname AS ACCOUNT_NAME, imr_createtime as CREATION_DATE, imr_accountlastmodified as LAST_MODIFIED 
FROM         endpointuseraccounts6
WHERE      imr_userid  IN('[system user]')
GO

CREATE VIEW endpointattributes
AS
SELECT Attribute.imr_reportid as imr_reportid,  
	Attribute.imr_objectid as imr_endpointid, 
	Attribute.imr_attrInfoID as AttributeInfoID, AttributeInfo.imr_name as Name, 
	Attribute.imr_value as AttributeValue 
FROM 
	imrattribute Attribute, 
	imrattributeinfo AttributeInfo  
WHERE imr_objectid IN (SELECT endpointObject.imr_objectid
		FROM
			imrObject endpointObject,
			imrObjectCategory endpointCategory,
			imrObjectInfo endpointObjectInfo
		WHERE
			endpointObject.imr_objectinfoname = endpointObjectInfo.imr_name and
			endpointObjectInfo.imr_objectcatname = endpointCategory.imr_name and
			endpointCategory.imr_name = 'EndPoint' and 
			endpointCategory.imr_reportid = endpointObject.imr_reportid and 
			endpointObjectInfo.imr_reportid = endpointCategory.imr_reportid and
			endpointObject.imr_reportid = endpointCategory.imr_reportid)
AND AttributeInfo.imr_attrinfoid = Attribute.imr_attrinfoid;

GO

CREATE VIEW accttmplattribute 
AS
SELECT
	acctTmplObject.imr_reportid as imr_reportid,
	acctTmplObject.imr_objectid as acctTmplObjectid,
	acctTmplObject.imr_friendlyname as imr_accttmplname,
	acctTmplObject.imr_objectdn as imr_accttmpldn,
	acctTmplObjectInfo.imr_name as imr_endpointtype,
	resourceAttrInfo.imr_name as imr_attrname,
	resourceAttr.imr_value as imr_attrvalue,
	resourceAttr.imr_objectrefid as imr_objectrefid,
	resourceAttrInfo.imr_isbasetype as imr_isbasetype
FROM
	imrObjectCategory acctTmplCategory,
	imrObjectInfo acctTmplObjectInfo,
	imrObject acctTmplObject,
	imrAttributeInfo resourceAttrInfo,
	imrAttribute resourceAttr
WHERE
	(resourceAttr.imr_value IS NOT NULL or
	resourceAttr.imr_objectrefid IS NOT NULL) and
	resourceAttr.imr_objectid = acctTmplObject.imr_objectid and
	resourceAttrInfo.imr_attrinfoid = resourceAttr.imr_attrinfoid and
	acctTmplObject.imr_objectinfoname = acctTmplObjectInfo.imr_name and
	acctTmplObjectInfo.imr_objectcatname = acctTmplCategory.imr_name and
	acctTmplCategory.imr_name = 'Policy' and 
	acctTmplCategory.imr_reportid=acctTmplObject.imr_reportid and 
	acctTmplObjectInfo.imr_reportid = acctTmplObject.imr_reportid and 
	resourceAttrInfo.imr_reportid = acctTmplObject.imr_reportid and 
	resourceAttr.imr_reportid = acctTmplObject.imr_reportid;
GO

CREATE VIEW endpointaccount 
AS
SELECT
	accountObject.imr_reportid as imr_reportid,
	endPointObject.imr_friendlyname as imr_endpoint,
	accountObjectInfo.imr_name as imr_endpointtype,
	accountObject.imr_friendlyname as imr_accountname,
	accountObject.imr_objectdn as imr_accountdn
FROM
	imrObject endPointObject,
	imrObjectInfo endPointObjectInfo,
	imrObjectCategory endPointCategory,
	imrObject accountObject,
	imrObjectInfo accountObjectInfo,
	imrObjectCategory accountCategory,
	imrAttributeInfo endPointAttrInfo,
	imrAttribute endPointAttr
WHERE
	endPointObject.imr_objectinfoname = endPointObjectInfo.imr_name and
	endPointObjectInfo.imr_objectcatname = endPointCategory.imr_name and
	endPointCategory.imr_name = 'EndPoint' and
	endPointObject.imr_friendlyname = endPointAttr.imr_value and
	endPointAttr.imr_attrinfoid = endPointAttrInfo.imr_attrinfoid and
	endPointAttrInfo.imr_name = 'endPointName' and
	endPointAttr.imr_objectid = accountObject.imr_objectid and
	accountObject.imr_objectinfoname = accountObjectInfo.imr_name and
	accountObjectInfo.imr_objectcatname = accountCategory.imr_name and
	accountCategory.imr_name = 'Account' and 
	endPointObject.imr_reportid=accountObject.imr_reportid and
	endPointObjectInfo.imr_reportid = accountObject.imr_reportid and
	endPointCategory.imr_reportid=accountObject.imr_reportid and 
	accountObjectInfo.imr_reportid = accountObject.imr_reportid and 
	accountCategory.imr_reportid = accountObject.imr_reportid and 
	endPointAttrInfo.imr_reportid = accountObject.imr_reportid and 
	endPointAttr.imr_reportid = accountObject.imr_reportid;
GO

CREATE VIEW endpointview 
AS
SELECT
	endpointObject.imr_reportid as imr_reportid,
	endpointObject.imr_friendlyname as imr_endpoint,
	endpointObject.imr_objectdn as imr_endpointdn,
	endpointObject.imr_objectid as imr_endpointid,
	endpointObjectInfo.imr_name as imr_endpointtype
FROM
	imrObject endpointObject,
	imrObjectCategory endpointCategory,
	imrObjectInfo endpointObjectInfo
WHERE
	endpointObject.imr_objectinfoname = endpointObjectInfo.imr_name and
	endpointObjectInfo.imr_objectcatname = endpointCategory.imr_name and
	endpointCategory.imr_name = 'EndPoint' and 
	endpointCategory.imr_reportid = endpointObject.imr_reportid and 
	endpointObjectInfo.imr_reportid = endpointObject.imr_reportid;
GO

CREATE VIEW provrolesrelationshipview 
AS
SELECT
	provRolesRelationship.imr_reportid as imr_reportid,
	provRolesRelationship.imr_parentoid as imr_parentoid,
	provRolesRelationship.imr_childoid as imr_childoid
FROM
	imrProvRolesRelationship provRolesRelationship
GO

CREATE VIEW accttemplEndpointRelView
AS
SELECT     
	imrObjectInfo.imr_name AS TemplateType, imrObject.imr_objectdn AS TemplateDN, 		     imrObject.imr_friendlyname AS TemplateName, 
    imrTemplEndpointRelationship.imr_endpointname AS EndpointName,  	imrTemplEndpointRelationship.imr_endpointdn AS EndpointDN, 
    imrObject.imr_reportid
FROM         
	imrTemplEndpointRelationship RIGHT OUTER JOIN
    imrObject ON imrTemplEndpointRelationship.imr_reportid = imrObject.imr_reportid AND 
    imrTemplEndpointRelationship.imr_templatedn = imrObject.imr_objectdn LEFT OUTER JOIN
    imrObjectCategory INNER JOIN
    imrObjectInfo ON imrObjectCategory.imr_name = imrObjectInfo.imr_objectcatname ON 	imrObject.imr_reportid = imrObjectCategory.imr_reportid AND 
    imrObject.imr_reportid = imrObjectInfo.imr_reportid AND imrObject.imr_objectinfoname = 	imrObjectInfo.imr_name
WHERE     
	(imrObjectCategory.imr_name = 'Policy')
GO

CREATE VIEW capabilityattrsview
AS
SELECT     
imrCapabilityAttrRel.imr_reportid, imrCapabilityAttrRel.imr_endpointtype AS EndpointType, imrObject.imr_friendlyname AS EndpointName, 
                      imrObject.imr_objectdn AS EndpointDN, imrCapabilityAttrRel.imr_objecttypename, imrCapabilityAttrRel.imr_jiamobjecttypename, 
                      imrCapabilityAttrRel.imr_capabilityobjectname, imrCapabilityAttrRel.imr_capabilityobjectdn, imrCapabilityAttrRel.imr_endpointobjid AS endpointid, imrCapabilityAttrRel.imr_attrid AS Attributeid, imrCapabilityAttrRel.imr_name, imrCapabilityAttrRel.imr_value
FROM imrCapabilityAttrRel, imrObject where 
	imrCapabilityAttrRel.imr_reportid = imrObject.imr_reportid
	and imrCapabilityAttrRel.imr_endpointobjid = imrObject.imr_objectid
GO

CREATE VIEW provroleaccttmplendptrelview
AS
SELECT     
	imrProvRoleTemplRelationship.imr_reportid, 
	imrProvRoleTemplRelationship.imr_roleoid,
	imrProvRoleTemplRelationship.imr_roledn,
	accttemplEndpointRelView.TemplateType,
	accttemplEndpointRelView.TemplateDN,
	accttemplEndpointRelView.TemplateName,
	accttemplEndpointRelView.EndpointName,
	accttemplEndpointRelView.EndpointDN
		
FROM         
	imrProvRoleTemplRelationship LEFT OUTER JOIN
    accttemplEndpointRelView ON imrProvRoleTemplRelationship.imr_reportid = accttemplEndpointRelView.imr_reportid 
	AND imrProvRoleTemplRelationship.imr_templatedn = accttemplEndpointRelView.TemplateDN
go

----------
-- Cleanup Stuff
----------


--
-- PROCEDURE IMRCleanupProc6 For cleaning reports older than a month
-- *********DEPRICATED DO NOT USE
--

CREATE PROCEDURE IMRCleanupProc6 AS
BEGIN


    DELETE FROM imrrole6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
    DELETE FROM imrroletask6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
    DELETE FROM imrtask6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )

    DELETE FROM imrrolerule6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )

    DELETE FROM imrrolescoperule6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )

    DELETE FROM imrrolemember6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )

    DELETE FROM imrroleadmin6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
    DELETE FROM imrroleowner6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
    DELETE FROM imrorg6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
    DELETE FROM imrorgattr6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
    DELETE FROM imruser6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
    DELETE FROM imruserattr6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
    DELETE FROM imrgroup6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
                WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
    DELETE FROM imrgroupattr6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
               WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
    DELETE FROM imrgroupmember6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
               WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
    DELETE FROM imrgroupadmin6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
               WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
-- add identitypolicy support
     DELETE FROM imridentitypolicy6 where imr_reportid IN (
                 SELECT imreport6.imr_reportid
                 FROM imreport6
                WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
    DELETE FROM imridentitypolicyset6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
               WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
     DELETE FROM imridentitypolicyusersync6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
               WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )

     DELETE FROM imridentitypolicyactions6 where imr_reportid IN (
                SELECT imreport6.imr_reportid
                FROM imreport6
               WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )
        )
-- end of identitypolicy support
    DELETE FROM imreport6 WHERE ( imreport6.imr_reporttime < DATEADD(Month,-1,GETDATE()) )

END
go

CREATE PROCEDURE IMRRemoveSnapshot
	@id int
AS
BEGIN
	DELETE FROM imrrole6 WHERE imr_reportid = @id
	DELETE FROM imrrolemember6 WHERE imr_reportid = @id
	DELETE FROM imrroleadmin6 WHERE imr_reportid = @id
	DELETE FROM imrroleowner6 WHERE imr_reportid = @id
	DELETE FROM imrrolerule6 WHERE imr_reportid = @id
	DELETE FROM imrrolescoperule6 WHERE imr_reportid = @id

	DELETE FROM imrroletask6 WHERE imr_reportid = @id
	DELETE FROM imrtask6 WHERE imr_reportid = @id

	DELETE FROM imrorg6 WHERE imr_reportid = @id
	DELETE FROM imrorgattr6 WHERE imr_reportid = @id

	DELETE FROM imruser6 WHERE imr_reportid = @id
	DELETE FROM imruserattr6 WHERE imr_reportid = @id

	DELETE FROM imrgroup6 WHERE imr_reportid = @id
	DELETE FROM imrgroupattr6 WHERE imr_reportid = @id
	DELETE FROM imrgroupmember6 WHERE imr_reportid = @id
	DELETE FROM imrgroupadmin6 WHERE imr_reportid = @id

	DELETE FROM imridentitypolicy6 WHERE imr_reportid = @id
	DELETE FROM imridentitypolicyset6 WHERE imr_reportid = @id
	DELETE FROM imridentitypolicyusersync6 WHERE imr_reportid = @id
	DELETE FROM imridentitypolicyactions6 WHERE imr_reportid = @id

	DELETE FROM imrAttribute WHERE imr_reportid = @id;
	DELETE FROM imrAttributeInfo WHERE imr_reportid = @id;
	DELETE FROM imrObject WHERE imr_reportid = @id;
	DELETE FROM imrObjectCategory WHERE imr_reportid = @id;
	DELETE FROM imrObjectInfo WHERE imr_reportid = @id;
	DELETE FROM imrProvRolesRelationship WHERE imr_reportid = @id;
	DELETE FROM imrProvRoleTemplRelationship WHERE imr_reportid = @id;
	DELETE FROM imrUserAccountRelationship WHERE imr_reportid = @id;
	DELETE FROM imrTemplEndpointRelationship WHERE imr_reportid = @id;
	DELETE FROM imrAccountTemplateRel WHERE imr_reportid = @id;
	DELETE FROM imrCapabilityAttrRel WHERE imr_reportid = @id;
	DELETE FROM imrroleattr12 WHERE imr_reportid = @id;

	DELETE FROM imreport6 WHERE imr_reportid = @id
END
GO


CREATE PROCEDURE IMRCleanOldSnapshotsProc
	@keep int,
	@name varchar (255),
	@source varchar (255)
AS
BEGIN
	DECLARE @SQLString NVARCHAR(500)
	DECLARE @SQLDef NVARCHAR(100)
	DECLARE @runCursor CURSOR
	DECLARE @reportId int

	-- make temp table to keep the snapshots ids we want to clean
	create table #retired_snpashots (id int)

	SET @SQLString = 'INSERT INTO #retired_snpashots SELECT imr_reportid FROM imreport6 ' +
					'WHERE imr_reportname=@n AND imr_snapshotsource=@s AND imr_snapshotstatus = ''Completed '' ' +
					'AND imr_reportid NOT IN ' +
					'(SELECT TOP ' + STR(@keep) + ' imr_reportid FROM imreport6 ' +
					'WHERE imr_reportname=@n AND imr_snapshotsource=@s AND imr_snapshotstatus = ''Completed '''+
					'ORDER BY imr_reportid DESC)'
	SET @SQLDef = '@n varchar (255),@s varchar (255)'

	EXECUTE sp_executesql @SQLString,@SQLDef,@n=@name,@s=@source

	SET @runCursor = CURSOR FAST_FORWARD FOR
	SELECT id from #retired_snpashots

	OPEN @runCursor
	FETCH NEXT FROM @runCursor INTO @reportId

	WHILE @@FETCH_STATUS = 0
	BEGIN
		EXECUTE IMRRemoveSnapshot @reportId
		FETCH NEXT FROM @runCursor INTO @reportId
	END

	CLOSE @runCursor
	DEALLOCATE @runCursor

	DROP TABLE #retired_snpashots
END
GO
