-- COPYRIGHT (C) 2009, CA, INC. ALL RIGHTS RESERVED.
--
-- THIS FILE CONTAINS THE SCHEMA FOR
-- IAM FRAMEWORK TABLES FOR AUDITING
--
--

-- INNODB is required for FOREIGN KEY CONSTRAINTS and AUTO_INCREMENT.
SET storage_engine=INNODB;

DELIMITER $$

CREATE PROCEDURE cleanup_report_table_constraints ()
BEGIN
    DECLARE table_count INT;

    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'IMSAUDITTASKSESSION12' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        ALTER TABLE IMSAUDITTASKSESSION12 MODIFY ID INT NOT NULL;
        ALTER TABLE IMSAUDITTASKSESSION12 DROP PRIMARY KEY;
        ALTER TABLE IMSAUDITTASKSESSION12 DROP INDEX AUDIT_UNIQUE_TS12;
        DROP INDEX IMSAUDITTASKSESSION12_INDEX_1 ON IMSAUDITTASKSESSION12;
        DROP INDEX IMSAUDITTASKSESSION12_INDEX_2 ON IMSAUDITTASKSESSION12;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'IMSAUDITEVENT12' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        ALTER TABLE IMSAUDITEVENT12 MODIFY ID INT NOT NULL;
        ALTER TABLE IMSAUDITEVENT12 DROP PRIMARY KEY;
        DROP INDEX IMSAUDITEVENT12_INDEX_1 ON IMSAUDITEVENT12;
        DROP INDEX IMSAUDITEVENT12_INDEX_2 ON IMSAUDITEVENT12;
        DROP INDEX IMSAUDITEVENT12_INDEX_3 ON IMSAUDITEVENT12;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'IMSAUDITEVENTOBJECT12' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        ALTER TABLE IMSAUDITEVENTOBJECT12 MODIFY ID INT NOT NULL;
        ALTER TABLE IMSAUDITEVENTOBJECT12 DROP PRIMARY KEY;
        DROP INDEX IMSAUDITEVENTOBJECT12_INDEX_1 ON IMSAUDITEVENTOBJECT12;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'IMSAUDITOBJECTATTRIBUTES12' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        ALTER TABLE IMSAUDITOBJECTATTRIBUTES12 MODIFY ID INT NOT NULL;
        ALTER TABLE IMSAUDITOBJECTATTRIBUTES12 DROP PRIMARY KEY;
        DROP INDEX IMSAUDITOBJECTATTRIB12_INDEX_1 ON IMSAUDITOBJECTATTRIBUTES12;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'IMSAUDITOBJECTRELATIONSHIP12' AND table_schema = DATABASE();
    IF table_count > 0 THEN
        ALTER TABLE IMSAUDITOBJECTRELATIONSHIP12 MODIFY ID INT NOT NULL;
        ALTER TABLE IMSAUDITOBJECTRELATIONSHIP12 DROP PRIMARY KEY;
        DROP INDEX IMSAUDITOBJECTREL12_INDEX_1 ON IMSAUDITOBJECTRELATIONSHIP12;
    END IF;
END$$

DELIMITER ;

-- Call it...
CALL cleanup_report_table_constraints();

-- ...then drop it.
DROP PROCEDURE IF EXISTS cleanup_report_table_constraints;

-- drop tables
DROP TABLE IF EXISTS IMSAUDIT_VERSION;

DROP TABLE IF EXISTS IMSAUDITTASKSESSION12;

DROP TABLE IF EXISTS IMSAUDITEVENT12;

DROP TABLE IF EXISTS IMSAUDITEVENTOBJECT12;

DROP TABLE IF EXISTS IMSAUDITOBJECTATTRIBUTES12;

DROP TABLE IF EXISTS IMSAUDITOBJECTRELATIONSHIP12;

-- drop procedures
DROP PROCEDURE IF EXISTS INSERTIMSAUDITTASKSESSION125;

DROP PROCEDURE IF EXISTS INSERTIMSAUDITEVENTOBJECT125;

DROP PROCEDURE IF EXISTS INSERTIMSAUDITEVENT125;

DROP PROCEDURE IF EXISTS GARBAGECOLLECTAUDITING12;

