-- COPYRIGHT (C) 2009, CA, INC. ALL RIGHTS RESERVED.
--
-- This file contains the sql script to remove all of the 
-- IAM Framework Tables for auditing (Version r12.5+)
--


DECLARE
	OBJECT_EXIST PLS_INTEGER;
BEGIN
	SELECT COUNT(*) INTO OBJECT_EXIST FROM USER_SEQUENCES WHERE SEQUENCE_NAME = 'SEQ_AUDITTS12';
	IF OBJECT_EXIST = 1 THEN
		EXECUTE IMMEDIATE 'DROP SEQUENCE SEQ_AUDITTS12';
	END IF;
	
	SELECT COUNT(*) INTO OBJECT_EXIST FROM USER_SEQUENCES WHERE SEQUENCE_NAME = 'SEQ_AUDITEVTOBJ12';
		IF OBJECT_EXIST = 1 THEN
			EXECUTE IMMEDIATE 'DROP SEQUENCE SEQ_AUDITEVTOBJ12';
	END IF;
	
	SELECT COUNT(*) INTO OBJECT_EXIST FROM USER_SEQUENCES WHERE SEQUENCE_NAME = 'SEQ_AUDITEVT12';
			IF OBJECT_EXIST = 1 THEN
				EXECUTE IMMEDIATE 'DROP SEQUENCE SEQ_AUDITEVT12';
	END IF;
	
	SELECT COUNT(*) INTO OBJECT_EXIST FROM USER_SEQUENCES WHERE SEQUENCE_NAME = 'SEQ_AUDITOBJATTR12';
		IF OBJECT_EXIST = 1 THEN
			EXECUTE IMMEDIATE 'DROP SEQUENCE SEQ_AUDITOBJATTR12';
	END IF;
	
	SELECT COUNT(*) INTO OBJECT_EXIST FROM USER_SEQUENCES WHERE SEQUENCE_NAME = 'SEQ_AUDITOBJREL12';
		IF OBJECT_EXIST = 1 THEN
			EXECUTE IMMEDIATE 'DROP SEQUENCE SEQ_AUDITOBJREL12';
	END IF;

-- TABLES	
	SELECT COUNT(*)	INTO OBJECT_EXIST FROM USER_TABLES WHERE TABLE_NAME = 'IMSAUDITTASKSESSION12';
		IF OBJECT_EXIST = 1 THEN
			EXECUTE IMMEDIATE 'DROP TABLE IMSAUDITTASKSESSION12 CASCADE CONSTRAINTS';
	END IF;
	
	SELECT COUNT(*) INTO OBJECT_EXIST FROM USER_INDEXES WHERE INDEX_NAME = 'IMSAUDITTASKSESSION12_INDEX_1';
		IF OBJECT_EXIST = 1 THEN
			EXECUTE IMMEDIATE 'DROP INDEX IMSAUDITTASKSESSION12_INDEX_1';
	END IF;
	
	SELECT COUNT(*) INTO OBJECT_EXIST FROM USER_INDEXES WHERE INDEX_NAME = 'IMSAUDITTASKSESSION12_INDEX_2';
			IF OBJECT_EXIST = 1 THEN
				EXECUTE IMMEDIATE 'DROP INDEX IMSAUDITTASKSESSION12_INDEX_2';
	END IF;
--
	SELECT COUNT(*)	INTO OBJECT_EXIST FROM USER_TABLES WHERE TABLE_NAME = 'IMSAUDITEVENT12';
		IF OBJECT_EXIST = 1 THEN
			EXECUTE IMMEDIATE 'DROP TABLE IMSAUDITEVENT12 CASCADE CONSTRAINTS';
	END IF;
	
	SELECT COUNT(*) INTO OBJECT_EXIST FROM USER_INDEXES WHERE INDEX_NAME = 'IMSAUDITEVENT12_INDEX_1';
		IF OBJECT_EXIST = 1 THEN
			EXECUTE IMMEDIATE 'DROP INDEX IMSAUDITEVENT12_INDEX_1';
	END IF;
	
	SELECT COUNT(*) INTO OBJECT_EXIST FROM USER_INDEXES WHERE INDEX_NAME = 'IMSAUDITEVENT12_INDEX_2';
			IF OBJECT_EXIST = 1 THEN
				EXECUTE IMMEDIATE 'DROP INDEX IMSAUDITEVENT12_INDEX_2';
	END IF;
	
	SELECT COUNT(*) INTO OBJECT_EXIST FROM USER_INDEXES WHERE INDEX_NAME = 'IMSAUDITEVENT12_INDEX_3';
			IF OBJECT_EXIST = 1 THEN
				EXECUTE IMMEDIATE 'DROP INDEX IMSAUDITEVENT12_INDEX_3';
	END IF;
--
	SELECT COUNT(*)	INTO OBJECT_EXIST FROM USER_TABLES WHERE TABLE_NAME = 'IMSAUDITEVENTOBJECT12';
			IF OBJECT_EXIST = 1 THEN
				EXECUTE IMMEDIATE 'DROP TABLE IMSAUDITEVENTOBJECT12 CASCADE CONSTRAINTS';
	END IF;
		
	SELECT COUNT(*) INTO OBJECT_EXIST FROM USER_INDEXES WHERE INDEX_NAME = 'IMSAUDITEVENTOBJECT12_INDEX_1';
			IF OBJECT_EXIST = 1 THEN
				EXECUTE IMMEDIATE 'DROP INDEX IMSAUDITEVENTOBJECT12_INDEX_1';
	END IF;
--
	SELECT COUNT(*)	INTO OBJECT_EXIST FROM USER_TABLES WHERE TABLE_NAME = 'IMSAUDITOBJECTATTRIBUTES12';
			IF OBJECT_EXIST = 1 THEN
				EXECUTE IMMEDIATE 'DROP TABLE IMSAUDITOBJECTATTRIBUTES12 CASCADE CONSTRAINTS';
	END IF;
	
	SELECT COUNT(*) INTO OBJECT_EXIST FROM USER_INDEXES WHERE INDEX_NAME = 'IMSAUDITOBJECTATTRIB12_INDEX_1';
				IF OBJECT_EXIST = 1 THEN
					EXECUTE IMMEDIATE 'DROP INDEX IMSAUDITOBJECTATTRIB12_INDEX_1';
	END IF;
--
	SELECT COUNT(*)	INTO OBJECT_EXIST FROM USER_TABLES WHERE TABLE_NAME = 'IMSAUDITOBJECTRELATIONSHIP12';
			IF OBJECT_EXIST = 1 THEN
				EXECUTE IMMEDIATE 'DROP TABLE IMSAUDITOBJECTRELATIONSHIP12 CASCADE CONSTRAINTS';
	END IF;
	
	SELECT COUNT(*) INTO OBJECT_EXIST FROM USER_INDEXES WHERE INDEX_NAME = 'IMSAUDITOBJECTREL12_INDEX_1';
				IF OBJECT_EXIST = 1 THEN
				EXECUTE IMMEDIATE 'DROP INDEX IMSAUDITOBJECTREL12_INDEX_1';
	END IF;	

  SELECT COUNT(*)	INTO OBJECT_EXIST FROM USER_TABLES WHERE TABLE_NAME = 'IMSAUDIT_VERSION';
		   IF OBJECT_EXIST = 1 THEN
		   EXECUTE IMMEDIATE 'DROP TABLE IMSAUDIT_VERSION CASCADE CONSTRAINTS';
  END IF;
  
-- PROCS
	SELECT COUNT(*) INTO OBJECT_EXIST FROM USER_PROCEDURES WHERE OBJECT_NAME = 'INSERTIMSAUDITTASKSESSION125';
	IF OBJECT_EXIST = 1 THEN
		EXECUTE IMMEDIATE 'DROP PROCEDURE INSERTIMSAUDITTASKSESSION125';
	END IF;

	SELECT COUNT(*) INTO OBJECT_EXIST FROM USER_PROCEDURES WHERE OBJECT_NAME = 'INSERTIMSAUDITEVENTOBJECT125';
	IF OBJECT_EXIST = 1 THEN
		EXECUTE IMMEDIATE 'DROP PROCEDURE INSERTIMSAUDITEVENTOBJECT125';
	END IF;	
	
	SELECT COUNT(*) INTO OBJECT_EXIST FROM USER_PROCEDURES WHERE OBJECT_NAME = 'INSERTIMSAUDITEVENT125';
		IF OBJECT_EXIST = 1 THEN
			EXECUTE IMMEDIATE 'DROP PROCEDURE INSERTIMSAUDITEVENT125';
	END IF;
	
	SELECT COUNT(*) INTO OBJECT_EXIST FROM USER_PROCEDURES WHERE OBJECT_NAME = 'GARBAGECOLLECTAUDITING12';
		IF OBJECT_EXIST = 1 THEN
			EXECUTE IMMEDIATE 'DROP PROCEDURE GARBAGECOLLECTAUDITING12';
	END IF;
	
-- TRIGGERS
	SELECT COUNT(*) INTO OBJECT_EXIST FROM USER_TRIGGERS WHERE TRIGGER_NAME = 'AUDITOBJATTR12_PK';
			IF OBJECT_EXIST = 1 THEN
				EXECUTE IMMEDIATE 'DROP TRIGGER AUDITOBJATTR12_PK';
	END IF;	

	SELECT COUNT(*) INTO OBJECT_EXIST FROM USER_TRIGGERS WHERE TRIGGER_NAME = 'AUDITOBJECTREL12_PK';
			IF OBJECT_EXIST = 1 THEN
				EXECUTE IMMEDIATE 'DROP TRIGGER AUDITOBJECTREL12_PK';
	END IF;	

	
END;
/
