create or replace FUNCTION IM_Audit_Start_Date (rangeVal int, multiplier int, startdatetime DATE)

RETURN DATE is
tempid1 DATE;

BEGIN

if rangeVal = -1
then tempid1 := startdatetime;
else
case rangeVal
  when 1 then tempid1 := sysdate - multiplier; --Last N days
  when 2 then tempid1 := trunc(sysdate, 'DAY') - (7 * multiplier); --weekly
  when 3 then tempid1 := add_months(trunc(sysdate, 'month'), -multiplier); -- first day of the month
  when 4 then tempid1 := add_months(trunc(sysdate, 'month'), -(3 * multiplier)); -- quarter of the month
  when 5 then tempid1 := add_months(trunc(sysdate,'y'), -(12 * multiplier)); --Yearly
  else tempid1 := sysdate;
end case;
end if;
return tempid1;
END;
/

create or replace FUNCTION IM_Audit_End_Date (rangeVal int, enddatetime DATE)

RETURN DATE is
tempid1 DATE;

BEGIN
if rangeVal = -1
then tempid1 := enddatetime;
else
case rangeVal
  when 1 then tempid1 := sysdate; --Last N days
  when 2 then tempid1 := trunc(sysdate, 'day') -1 + (1439/1440); --weekly
  when 3 then tempid1 := trunc(sysdate, 'month') - 1 + (1439/1440); -- last day of the month
  when 4 then tempid1 := trunc(sysdate, 'month') - 1 + (1439/1440); -- quarter of the month
  when 5 then tempid1 := trunc(sysdate,'y')-1 + (1439/1440); --Yearly
else tempid1 := sysdate;
end case;
end if;
return tempid1;
END;
/

UPDATE IMSAUDIT_VERSION SET IMR_VALUE = '12.6.2.0.0' WHERE IMR_KEY = 'version';