-- COPYRIGHT (C) 2009, CA, INC. ALL RIGHTS RESERVED.

-- There is no data migration from pre r12.5 to r12.5 Auditing schema.
-- All the tables and other schema objects are new to r12.5
-- To get the r12.5 schema, use the new schema creation file  : ims_mssql_audit.sql
-- This upgrade is to set the stored procedure queries with ROWLOCK (for inserts) and NOLOCK (for selects).
IF EXISTS(SELECT name
	  FROM 	 sysobjects
	  WHERE  name = 'insertImsAuditTasksession125'
	  AND 	 type = 'P')
	  DROP PROCEDURE insertImsAuditTasksession125
go

IF EXISTS(SELECT name
	  FROM 	 sysobjects
	  WHERE  name = 'insertImsAuditEventObject125'
	  AND 	 type = 'P')
	  DROP PROCEDURE insertImsAuditEventObject125
go

IF EXISTS(SELECT name
	  FROM 	 sysobjects
	  WHERE  name = 'insertImsAuditEvent125'
	  AND 	 type = 'P')
	  DROP PROCEDURE insertImsAuditEvent125
go

CREATE PROCEDURE insertImsAuditTasksession125
      @parent_ts_oid nvarchar(100) ,
      @parent_event_oid nvarchar(100) ,
      @tasksession_oid nvarchar(100) ,
      @admin_dn  nvarchar(512) ,
      @admin_name nvarchar(255) ,
      @task_name  nvarchar(255) ,
      @task_tag  nvarchar(255) ,
      @task_description nvarchar(4000) ,      
      @task_priority int ,
      @state nvarchar(100) ,
      @envname   nvarchar(100) ,
      @env_oid    nvarchar(100),
      @audit_time	datetime,
      @current_id INTEGER OUTPUT
AS
BEGIN
SET @current_id = 0;
Select @current_id =id  from imsAuditTaskSession12 WITH (NOLOCK) 
        WHERE
           ( tasksession_oid= @tasksession_oid
            AND state  = @state
            AND env_oid  = @env_oid ) ;

  IF not  @current_id >0
       BEGIN
 	INSERT into imsAuditTaskSession12 WITH (ROWLOCK) (
            parent_ts_oid	, 
            parent_event_oid,
            tasksession_oid	,
            admin_dn	,
            admin_name	,
            task_name	,
            task_tag	,
            task_description	,
            task_priority	,
            state	,
            envname	,
            env_oid	,
            audit_time	) 
            values ( 
            @parent_ts_oid	, 
            @parent_event_oid	, 
            @tasksession_oid	,
            @admin_dn	,
            @admin_name	,
            @task_name	,
            @task_tag	,
            @task_description	,
            @task_priority	,
            @state	,
            @envname	,
            @env_oid	,
            @audit_time	) ;
 	SELECT @current_id=IDENT_CURRENT('imsAuditTaskSession12');
    END
END
GO

CREATE PROCEDURE insertImsAuditEventObject125
	@parent_event_id int,
	@object_type nvarchar(100),
	@object_name nvarchar(255),
	@audit_time datetime,
	@current_id INTEGER OUTPUT
AS
BEGIN
 	INSERT into imsAuditEventObject12 WITH (ROWLOCK) (
	parent_event_id ,
	object_type, 
	object_name, 
	audit_time  ) 
            values (
	@parent_event_id ,
	@object_type, 
	@object_name,
	@audit_time
 ) ;
    SELECT @current_id=IDENT_CURRENT('imsAuditEventObject12');
END
GO

CREATE PROCEDURE insertImsAuditEvent125
	@parent_ts_oid nvarchar	(100)	,
	@parent_event_oid nvarchar	(100)	,
	@event_oid nvarchar	(100)	,
	@admin_dn nvarchar	(512)	,
	@admin_name	nvarchar(255),
	@event_name	nvarchar(255),
	@event_description nvarchar(4000)	,
	@event_state nvarchar(100)	,
	@envname nvarchar(100)	,
	@env_oid nvarchar(100)	 ,
	@tasksession_id int,
	@audit_time datetime	,
	@current_eventid INTEGER OUTPUT
AS
BEGIN
 	INSERT into imsAuditEvent12 WITH (ROWLOCK) (
	tasksession_id,
        tasksession_oid	,
        parent_event_oid	,
	event_oid	,
	admin_dn	,
	admin_name	,
	event_name	,
	event_description	,
	event_state	,
	envname	,
	env_oid	,
	audit_time	) 
            values (
	@tasksession_id,
	@parent_ts_oid	,
	@parent_event_oid	,
	@event_oid	,
	@admin_dn	,
	@admin_name	,
	@event_name	,
	@event_description	,
	@event_state	,
	@envname	,
	@env_oid	,
	@audit_time
 ) ;
    SELECT @current_eventid=IDENT_CURRENT('imsAuditEvent12');
END
GO

update imsAudit_version set imr_value = '13.0.0.0.0' where imr_key = 'version'
GO

