CREATE FUNCTION [IM_Audit_Start_Date](@rangeVal integer, @multiplier integer, @startdatetime datetime)
RETURNS datetime
AS
BEGIN
DECLARE @tempid1 datetime, @tempid2 datetime

if @rangeVal = -1 
SET @tempid1 = @startdatetime;
else
if @rangeVal = 1 --days
SET @tempid1 = dateadd(day, -@multiplier, SYSDATETIME());
else
if @rangeVal = 2 --weekly
SET @tempid2 = dateadd (day, (-7 * @multiplier) + 1, dateadd(DAY, (-DATEPART(WEEKDAY, sysdatetime())), sysdatetime()))
if @rangeVal = 3 -- monthly
SET @tempid1 = dateadd(DAY,-(day(sysdatetime())- 1), DATEADD(MONTH, -@multiplier, SYSDATETIME()));
if @rangeVal = 4 --quarter
SET @tempid1 = dateadd(month, -(3 *@multiplier), DATEADD(DAY, -(DATEPART(day, sysdatetime())-1), SYSDATETIME()))
if @rangeVal = 5 -- yearly
SET @tempid1 = dateadd(day, -(DATEPART(day, sysdatetime())-1), DATEADD(MONTH, -(DATEPART(month, sysdatetime()) - 1), DATEADD(year, -@multiplier, SYSDATETIME())))

RETURN @tempid1

END
GO

CREATE FUNCTION [IM_Audit_End_Date](@rangeVal integer, @enddatetime datetime)
RETURNS datetime
AS
BEGIN
DECLARE @tempid1 datetime, @tempid2 datetime

if @rangeVal = -1 
SET @tempid1 = @enddatetime;
else
if @rangeVal = 1 --days
SET @tempid1 = SYSDATETIME();
else
if @rangeVal = 2 --weekly
SET @tempid2 = DATEADD(day, -DATEPART(WEEKDAY, sysdatetime()), sysdatetime())
if @rangeVal = 3 -- monthly
SET @tempid1 = dateadd(DAY,-(day(sysdatetime())), SYSDATETIME());
if @rangeVal = 4 --quarter
SET @tempid1 = dateadd(DAY,-(day(sysdatetime())), SYSDATETIME());
if @rangeVal = 5 -- yearly
SET @tempid1 = dateadd(day, -(DATEPART(day, sysdatetime())), DATEADD(MONTH, -(DATEPART(month, sysdatetime()) - 1), SYSDATETIME()))

RETURN @tempid1

END
GO

update imsAudit_version set imr_value = '12.6.2.0.0' where imr_key = 'version'
GO