
CREATE TABLE archive_runtimeStatusDetail12 (
    id INTEGER NOT NULL ,
    originationTime DATE NOT NULL ,
    eventID VARCHAR (255) NOT NULL ,
    parentID VARCHAR (255) ,
    sourceIdentifier VARCHAR (255) NOT NULL ,
    serverName VARCHAR (255) NOT NULL ,
    provDomainName VARCHAR (255) ,
    displayName VARCHAR (255) NOT NULL ,
    description VARCHAR (2000) ,
    descriptionType VARCHAR (255) ,
    descriptionParam VARCHAR (1024) ,
    admindn VARCHAR (628) NOT NULL ,
    adminName VARCHAR (255) NOT NULL ,
    importance INTEGER
) ;

ALTER TABLE archive_runtimeStatusDetail12  ADD 
    CONSTRAINT PK_archive_statusDetail12 PRIMARY KEY   
    (
        id
    )  ;


CREATE TABLE archive_rsdAttribute12 (
    id INTEGER NOT NULL ,
    rsdid INTEGER NOT NULL ,
    profiletype INTEGER NOT NULL ,
    profilename VARCHAR (255) NOT NULL ,
    attrname VARCHAR (255) NOT NULL ,
    attrvalue VARCHAR (1024) ,
    status VARCHAR (255) ,
    attrType VARCHAR (255) ,
    additionalInfo VARCHAR (255)
) ;

ALTER TABLE archive_rsdAttribute12  ADD 
    CONSTRAINT PK_archive_rsdAttribute12 PRIMARY KEY   
    (
        rsdid,
        id
    )  ;

CREATE TABLE archive_object12_5 (
        objectid VARCHAR (50)   NOT NULL ,
        objecttype INTEGER NOT NULL ,
        object BLOB
);

CREATE TABLE archive_tasksession12_5 (
        tasksessionid VARCHAR (50)   NOT NULL ,
        state VARCHAR(50) NOT NULL ,
        created_time TIMESTAMP NOT NULL ,
        last_access_time TIMESTAMP NOT NULL ,
        user_dn VARCHAR (512)NOT NULL ,
        org_dn VARCHAR (512) NOT NULL ,
        environmentid VARCHAR (50) NOT NULL ,
        name VARCHAR (512) NOT NULL ,
        description VARCHAR (2000) NOT NULL ,
        acknowledged CHAR NOT NULL ,
        parent_of_wf_id VARCHAR (50) ,
        action_type INTEGER NOT NULL ,
        priority INTEGER,
        initiatorid VARCHAR (50) ,
        nesting_type INTEGER,
        next_state INTEGER
);

CREATE TABLE archive_event12_5 (
        eventid VARCHAR (50)   NOT NULL ,
        state INTEGER NOT NULL ,
        tasksessionid VARCHAR (50)   NOT NULL ,
        created_on TIMESTAMP NOT NULL ,
        last_access_time TIMESTAMP NOT NULL ,
        name VARCHAR (512)   NOT NULL ,
        description VARCHAR (2000)   NOT NULL ,
        type INTEGER NOT NULL ,
        next_state INTEGER
); 

CREATE TABLE archive_event_object12_5 (
        tasksessionid VARCHAR (50)   NOT NULL ,
        eventid VARCHAR (50)   NOT NULL ,
        object_type VARCHAR (128)  NOT NULL ,
        isprimary CHAR NOT NULL ,
        object_uniquename VARCHAR (512) NOT NULL
);

ALTER TABLE archive_event12_5 ADD 
        CONSTRAINT PK_archive_event12_5 PRIMARY KEY   
        (
                eventid
        )  ;

ALTER TABLE archive_event_object12_5 ADD 
        CONSTRAINT PK_archive_event_object12_5 PRIMARY KEY
        (
                eventid,
                object_type,
                object_uniquename
        );

ALTER TABLE  archive_object12_5 ADD 
        CONSTRAINT PK_archive_object12_5 PRIMARY KEY
        (
                objectid,
                objecttype
        );

ALTER TABLE archive_tasksession12_5 ADD 
        CONSTRAINT PK_archive_tasksession12_5 PRIMARY KEY
        (
                tasksessionid
        );

ALTER TABLE archive_event12_5 ADD 
        CONSTRAINT FK_archive_event12_5_archive_tasksession12_5 FOREIGN KEY 
        (
                tasksessionid
        ) REFERENCES archive_tasksession12_5 (
                tasksessionid
        );

ALTER TABLE archive_tasksession12_5 ADD 
        CONSTRAINT FK_archive_tasksession12_5_archive_tasksession12_5 FOREIGN KEY 
        (
                initiatorid
        ) REFERENCES archive_tasksession12_5 (
                tasksessionid
        );

ALTER TABLE archive_event_object12_5 ADD 
        CONSTRAINT FK_archive_event_object12_5_archive_event12_5 FOREIGN KEY 
        (
                eventid
        ) REFERENCES archive_event12_5 (
                eventid
        );
