--
-- Install Procedures
--
-- The section below is for reference purpoces. Procedures are instaleld/removed through schema initialization code
-- The code below installs IAMProcedures (stored procedures installed with IAM)
-- Correct location of EAR is required for jar
-- CALL sqlj.install_jar(
-- 	'<ear_location\library\iamderbysp.jar'
-- 	, 'IAMProcedures', 0);
-- CALL SYSCS_UTIL.SYSCS_SET_DATABASE_PROPERTY('derby.database.classpath', CURRENT SCHEMA || '.IAMProcedures');

CREATE TABLE runtimeStatusDetail12 (
    id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1) NOT NULL ,
    originationTime TIMESTAMP NOT NULL ,
    eventID VARCHAR (255) NOT NULL ,
    parentID VARCHAR (255) ,
    sourceIdentifier VARCHAR (255) NOT NULL ,
    serverName VARCHAR (255) NOT NULL ,
    provDomainName VARCHAR (255) ,
    displayName VARCHAR (255) NOT NULL ,
    description VARCHAR (2000) ,
    descriptionType VARCHAR (255) ,
    descriptionParam VARCHAR (1024) ,
    admindn VARCHAR (628) NOT NULL ,
    adminName VARCHAR (255) NOT NULL ,
    importance INTEGER
) ;

ALTER TABLE runtimeStatusDetail12  ADD 
    CONSTRAINT PK_runtimeStatusDetail12 PRIMARY KEY   
    (
        id
    )  ;


CREATE TABLE runtimeStatusDetailAttribute12 (
    id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1) NOT NULL ,
    rsdid INTEGER NOT NULL ,
    profiletype INTEGER NOT NULL ,
    profilename VARCHAR (255) NOT NULL ,
    attrname VARCHAR (255) NOT NULL ,
    attrvalue VARCHAR (1024) ,
    status VARCHAR (255) ,
    attrType VARCHAR (255) ,
    additionalInfo VARCHAR (255)
) ;

ALTER TABLE runtimeStatusDetailAttribute12  ADD 
    CONSTRAINT PK_rsdAttribute12 PRIMARY KEY   
    (
        rsdid,
        id
    )  ;


CREATE PROCEDURE insertRuntimeStatusDetail (
                  IN originationTime TIMESTAMP,
                  IN eventID VARCHAR (255),
                  IN parentID VARCHAR (255),
                  IN sourceIdentifier VARCHAR (255),
                  IN serverName VARCHAR (255),
                  IN provDomainName VARCHAR (255),
                  IN displayName VARCHAR (255),
                  IN description VARCHAR (2000),
                  IN descriptionType VARCHAR (255),
                  IN descriptionParam VARCHAR (1024),
                  IN admindn VARCHAR (255),
                  IN adminName VARCHAR (255),
                  IN importance INTEGER,
                  OUT current_id INTEGER )
                  PARAMETER STYLE JAVA
                  LANGUAGE JAVA
                  MODIFIES SQL DATA
                  EXTERNAL NAME 'com.ca.ims.db.derby.RuntimeDBProcedures.insertRuntimeStatusDetailProcedure';

CREATE PROCEDURE insertRuntimeStatusDetailAttr(
                  IN rsdid INTEGER,
                  IN profiletype INTEGER,
                  IN profilename VARCHAR (255),
                  IN attrname VARCHAR (255),
                  IN attrvalue VARCHAR (255),
                  IN status VARCHAR (255),
                  IN attrType VARCHAR (255),
                  IN additionalInfo VARCHAR (255))
                  PARAMETER STYLE JAVA
                  MODIFIES SQL DATA
                  LANGUAGE JAVA
                  EXTERNAL NAME 'com.ca.ims.db.derby.RuntimeDBProcedures.insertRuntimeStatusDetailAttrProcedure';


CREATE TABLE AuxData12 (
  Id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1) NOT NULL ,
  EnvOID VARCHAR(64) NOT NULL ,
  ParentId INTEGER ,
  Precedence INTEGER ,
  ProviderId INTEGER ,
  Name VARCHAR(255) NOT NULL ,
  Type VARCHAR(255) NOT NULL ,
  DisplayName VARCHAR(255)
);

CREATE PROCEDURE insertAuxData (
    IN envOID VARCHAR(64) ,
    IN parentID INTEGER,
    IN precedence INTEGER,
    IN providerID INTEGER,
    IN name VARCHAR(255),
    IN type VARCHAR(255),
    IN displayName VARCHAR(255),
    OUT currentID INTEGER)
    PARAMETER STYLE JAVA
    MODIFIES SQL DATA
    LANGUAGE JAVA
    EXTERNAL NAME 'com.ca.ims.db.derby.RuntimeDBProcedures.insertAuxDataProcedure';


CREATE TABLE AuxDataProviders12 (
  Id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1) NOT NULL ,
  EnvOID VARCHAR(64) NOT NULL ,
  Type INTEGER NOT NULL ,
  DisplayName VARCHAR(255) NOT NULL ,
  Precedence INTEGER NOT NULL ,
  Description VARCHAR(255) ,
  NodeId INTEGER ,
  FileName VARCHAR(255) ,
  ClassName VARCHAR(255)
);

CREATE PROCEDURE insertAuxDataProvider (
    IN envOID VARCHAR(64),
    IN type VARCHAR(255),
    IN displayName VARCHAR(255),
    IN precedence INTEGER,
    IN description VARCHAR(255),
    IN nodeID INTEGER,
    IN fileName VARCHAR(255),
    IN className VARCHAR(255),
    OUT currentID INTEGER)
    PARAMETER STYLE JAVA
    MODIFIES SQL DATA
    LANGUAGE JAVA
    EXTERNAL NAME 'com.ca.ims.db.derby.RuntimeDBProcedures.insertAuxDataProviderProcedure';


CREATE TABLE lock12_5 (
        lockid VARCHAR (50)   NOT NULL ,
        lockinfo VARCHAR (400)  NOT NULL
);

CREATE TABLE object12_5 (
        objectid VARCHAR (50)   NOT NULL ,
        objecttype INTEGER NOT NULL ,
        object BLOB
);


CREATE TABLE tasksession12_5 (
        tasksessionid VARCHAR (50)   NOT NULL ,
        state VARCHAR(50) NOT NULL ,
        created_time TIMESTAMP NOT NULL ,
        last_access_time TIMESTAMP NOT NULL ,
        user_dn VARCHAR (512)NOT NULL ,
        org_dn VARCHAR (512) NOT NULL ,
        environmentid VARCHAR (50) NOT NULL ,
        name VARCHAR (512) NOT NULL ,
        description VARCHAR (2000) NOT NULL ,
        acknowledged CHAR NOT NULL ,
        parent_of_wf_id VARCHAR (50) ,
        action_type INTEGER NOT NULL ,
        priority INTEGER,
        initiatorid VARCHAR (50) ,
        nesting_type INTEGER,
        next_state INTEGER
);

CREATE TABLE event12_5 (
        eventid VARCHAR (50)   NOT NULL ,
        state INTEGER NOT NULL ,
        tasksessionid VARCHAR (50)   NOT NULL ,
        created_on TIMESTAMP NOT NULL ,
        last_access_time TIMESTAMP NOT NULL ,
        name VARCHAR (512)   NOT NULL ,
        description VARCHAR (2000)   NOT NULL ,
        type INTEGER NOT NULL ,
        next_state INTEGER
); 

CREATE TABLE event_object12_5 (
        tasksessionid VARCHAR (50)   NOT NULL ,
        eventid VARCHAR (50)   NOT NULL ,
        object_type VARCHAR (128)  NOT NULL ,
        isprimary CHAR NOT NULL ,
        object_uniquename VARCHAR (512) NOT NULL
);


CREATE TABLE tp_version (
    tp_key VARCHAR (255) NOT NULL,
    tp_value VARCHAR(255) NOT NULL
);

ALTER TABLE tp_version ADD 
    CONSTRAINT PK_tp_version PRIMARY KEY 
    (
        tp_key
    ) ;

insert into tp_version(tp_key,tp_value) values ('version','12.6.2.0.0')
;

ALTER TABLE event12_5 ADD 
        CONSTRAINT PK_event12_5 PRIMARY KEY   
        (
                eventid
        )  ;

ALTER TABLE event_object12_5 ADD 
        CONSTRAINT PK_event_object12_5 PRIMARY KEY
        (
                eventid,
                object_type,
                object_uniquename
        );

ALTER TABLE lock12_5 ADD 
        CONSTRAINT PK_lock12_5 PRIMARY KEY
        (
                lockid,
                lockinfo
        );

ALTER TABLE  object12_5 ADD 
        CONSTRAINT PK_object12_5 PRIMARY KEY
        (
                objectid,
                objecttype
        );

ALTER TABLE tasksession12_5 ADD 
        CONSTRAINT PK_tasksession12_5 PRIMARY KEY
        (
                tasksessionid
        );

ALTER TABLE event12_5 ADD 
        CONSTRAINT FK_event12_5_tasksession12_5 FOREIGN KEY 
        (
                tasksessionid
        ) REFERENCES tasksession12_5 (
                tasksessionid
        );

ALTER TABLE tasksession12_5 ADD 
        CONSTRAINT FK_tasksession12_5_tasksession12_5 FOREIGN KEY 
        (
                initiatorid
        ) REFERENCES tasksession12_5 (
                tasksessionid
        );

ALTER TABLE event_object12_5 ADD 
        CONSTRAINT FK_event_object12_5_event12_5 FOREIGN KEY 
        (
                eventid
        ) REFERENCES event12_5 (
                eventid
        );

ALTER TABLE AuxData12 ADD 
        CONSTRAINT PK_AuxData12 PRIMARY KEY
        (
                Id
        );
        
ALTER TABLE AuxDataProviders12 ADD 
        CONSTRAINT PK_AuxDataProviders12 PRIMARY KEY
        (
                Id
        );
        
ALTER TABLE AuxData12 ADD 
        CONSTRAINT FK_AuxData12_parent FOREIGN KEY 
        (
                ParentId
        ) REFERENCES AuxData12 (
                Id
        );
        
ALTER TABLE AuxData12 ADD 
        CONSTRAINT FK_AuxData12_provider FOREIGN KEY 
        (
                ProviderId
        ) REFERENCES AuxDataProviders12 (
                Id
        );
        
ALTER TABLE AuxDataProviders12 ADD 
        CONSTRAINT FK_AuxDataProviders12_rootNode FOREIGN KEY 
        (
                NodeId
        ) REFERENCES AuxData12 (
                Id
        );


create table qrtz_job_details (
job_name varchar(200) not null,
job_group varchar(200) not null,
description varchar(250) ,
job_class_name varchar(250) not null,
is_durable varchar(5) not null,
is_volatile varchar(5) not null,
is_stateful varchar(5) not null,
requests_recovery varchar(5) not null,
job_data blob,
primary key (job_name,job_group)
);

create table qrtz_job_listeners(
job_name varchar(200) not null,
job_group varchar(200) not null,
job_listener varchar(200) not null,
primary key (job_name,job_group,job_listener),
foreign key (job_name,job_group) references qrtz_job_details(job_name,job_group)
);

create table qrtz_triggers(
trigger_name varchar(200) not null,
trigger_group varchar(200) not null,
job_name varchar(200) not null,
job_group varchar(200) not null,
is_volatile varchar(5) not null,
description varchar(250),
next_fire_time bigint,
prev_fire_time bigint,
priority integer,
trigger_state varchar(16) not null,
trigger_type varchar(8) not null,
start_time bigint not null,
end_time bigint,
calendar_name varchar(200),
misfire_instr smallint,
job_data blob,
primary key (trigger_name,trigger_group),
foreign key (job_name,job_group) references qrtz_job_details(job_name,job_group)
);

create table qrtz_simple_triggers(
trigger_name varchar(200) not null,
trigger_group varchar(200) not null,
repeat_count bigint not null,
repeat_interval bigint not null,
times_triggered bigint not null,
primary key (trigger_name,trigger_group),
foreign key (trigger_name,trigger_group) references qrtz_triggers(trigger_name,trigger_group)
);

create table qrtz_cron_triggers(
trigger_name varchar(200) not null,
trigger_group varchar(200) not null,
cron_expression varchar(120) not null,
time_zone_id varchar(80),
primary key (trigger_name,trigger_group),
foreign key (trigger_name,trigger_group) references qrtz_triggers(trigger_name,trigger_group)
);

create table qrtz_blob_triggers(
trigger_name varchar(200) not null,
trigger_group varchar(200) not null,
blob_data blob,
primary key (trigger_name,trigger_group),
foreign key (trigger_name,trigger_group) references qrtz_triggers(trigger_name,trigger_group)
);

create table qrtz_trigger_listeners(
trigger_name varchar(200) not null,
trigger_group varchar(200) not null,
trigger_listener varchar(200) not null,
primary key (trigger_name,trigger_group,trigger_listener),
foreign key (trigger_name,trigger_group) references qrtz_triggers(trigger_name,trigger_group)
);

create table qrtz_calendars(
calendar_name varchar(200) not null,
calendar blob not null,
primary key (calendar_name)
);

create table qrtz_paused_trigger_grps
  (
    trigger_group varchar(200) not null,
primary key (trigger_group)
);

create table qrtz_fired_triggers(
entry_id varchar(95) not null,
trigger_name varchar(200) not null,
trigger_group varchar(200) not null,
is_volatile varchar(5) not null,
instance_name varchar(200) not null,
fired_time bigint not null,
priority integer not null,
state varchar(16) not null,
job_name varchar(200),
job_group varchar(200),
is_stateful varchar(5),
requests_recovery varchar(5),
primary key (entry_id)
);

create table qrtz_scheduler_state
  (
    instance_name varchar(200) not null,
    last_checkin_time bigint not null,
    checkin_interval bigint not null,
primary key (instance_name)
);

create table qrtz_locks
  (
    lock_name varchar(40) not null,
primary key (lock_name)
);

insert into qrtz_locks values('TRIGGER_ACCESS');
insert into qrtz_locks values('JOB_ACCESS');
insert into qrtz_locks values('CALENDAR_ACCESS');
insert into qrtz_locks values('STATE_ACCESS');
insert into qrtz_locks values('MISFIRE_ACCESS');

create index idx_qrtz_j_req_recovery on qrtz_job_details(REQUESTS_RECOVERY);
create index idx_qrtz_t_next_fire_time on qrtz_triggers(NEXT_FIRE_TIME);
create index idx_qrtz_t_state on qrtz_triggers(TRIGGER_STATE);
create index idx_qrtz_t_nft_st on qrtz_triggers(NEXT_FIRE_TIME,TRIGGER_STATE);
create index idx_qrtz_t_volatile on qrtz_triggers(IS_VOLATILE);
create index idx_qrtz_ft_trig_name on qrtz_fired_triggers(TRIGGER_NAME);
create index idx_qrtz_ft_trig_group on qrtz_fired_triggers(TRIGGER_GROUP);
create index idx_qrtz_ft_trig_nm_gp on qrtz_fired_triggers(TRIGGER_NAME,TRIGGER_GROUP);
create index idx_qrtz_ft_trig_volatile on qrtz_fired_triggers(IS_VOLATILE);
create index idx_qrtz_ft_trig_inst_name on qrtz_fired_triggers(INSTANCE_NAME);
create index idx_qrtz_ft_job_name on qrtz_fired_triggers(JOB_NAME);
create index idx_qrtz_ft_job_group on qrtz_fired_triggers(JOB_GROUP);
create index idx_qrtz_ft_job_stateful on qrtz_fired_triggers(IS_STATEFUL);
create index idx_qrtz_ft_job_req_recovery on qrtz_fired_triggers(REQUESTS_RECOVERY);

create index idx_ts12_5_initiatorid on tasksession12_5(initiatorid);
create index idx_event12_5_tasksessionid on event12_5(tasksessionid);
create index idx_rtmstatusdetail12_eventid on runtimestatusdetail12(eventid);



CREATE PROCEDURE garbageCollectTaskPersistence (
    IN ime_id VARCHAR(255),
    IN cutoff_time TIMESTAMP)
    PARAMETER STYLE JAVA
    MODIFIES SQL DATA
    LANGUAGE JAVA
    EXTERNAL NAME 'com.ca.ims.db.derby.RuntimeDBProcedures.garbageCollectTaskPersistence';

CREATE PROCEDURE garbageCollectTaskPersistenceWithTimeOut (
    IN ime_id VARCHAR(255),
    IN cutoff_time TIMESTAMP,
    IN audit_timeout_days FLOAT)
    PARAMETER STYLE JAVA
    MODIFIES SQL DATA
    LANGUAGE JAVA
    EXTERNAL NAME 'com.ca.ims.db.derby.RuntimeDBProcedures.garbageCollectTaskPersistence';
