CREATE TABLE lock12_5 (
        lockid VARCHAR (50)   NOT NULL ,
        lockinfo VARCHAR (400)  NOT NULL
);

CREATE TABLE object12_5 (
        objectid VARCHAR (50)   NOT NULL ,
        objecttype INTEGER NOT NULL ,
        object BLOB
);


CREATE TABLE tasksession12_5 (
        tasksessionid VARCHAR (50)   NOT NULL ,
        state VARCHAR(50) NOT NULL ,
        created_time TIMESTAMP NOT NULL ,
        last_access_time TIMESTAMP NOT NULL ,
        user_dn VARCHAR (512)NOT NULL ,
        org_dn VARCHAR (512) NOT NULL ,
        environmentid VARCHAR (50) NOT NULL ,
        name VARCHAR (512) NOT NULL ,
        description VARCHAR (2000) NOT NULL ,
        acknowledged CHAR NOT NULL ,
        parent_of_wf_id VARCHAR (50) ,
        action_type INTEGER NOT NULL ,
        priority INTEGER,
        initiatorid VARCHAR (50) ,
        nesting_type INTEGER,
        next_state INTEGER
);

CREATE TABLE event12_5 (
        eventid VARCHAR (50)   NOT NULL ,
        state INTEGER NOT NULL ,
        tasksessionid VARCHAR (50)   NOT NULL ,
        created_on TIMESTAMP NOT NULL ,
        last_access_time TIMESTAMP NOT NULL ,
        name VARCHAR (512)   NOT NULL ,
        description VARCHAR (2000)   NOT NULL ,
        type INTEGER NOT NULL ,
        next_state INTEGER
); 

CREATE TABLE event_object12_5 (
        tasksessionid VARCHAR (50)   NOT NULL ,
        eventid VARCHAR (50)   NOT NULL ,
        object_type VARCHAR (128)  NOT NULL ,
        isprimary CHAR NOT NULL ,
        object_uniquename VARCHAR (512) NOT NULL
);


CREATE TABLE tp_version (
    tp_key VARCHAR (255) NOT NULL,
    tp_value VARCHAR(255) NOT NULL
);

ALTER TABLE tp_version ADD 
    CONSTRAINT PK_tp_version PRIMARY KEY 
    (
        tp_key
    ) ;

insert into tp_version(tp_key,tp_value) values ('version','12.6.2.0.0')
;

alter table runtimeStatusDetail12 alter column descriptionParam varchar(1024);
alter table runtimeStatusDetail12 alter column description varchar(2000);

DROP PROCEDURE insertRuntimeStatusDetail;

CREATE PROCEDURE insertRuntimeStatusDetail (
                  IN originationTime TIMESTAMP,
                  IN eventID VARCHAR (255),
                  IN parentID VARCHAR (255),
                  IN sourceIdentifier VARCHAR (255),
                  IN serverName VARCHAR (255),
                  IN provDomainName VARCHAR (255),
                  IN displayName VARCHAR (255),
                  IN description VARCHAR (2000),
                  IN descriptionType VARCHAR (255),
                  IN descriptionParam VARCHAR (1024),
                  IN admindn VARCHAR (255),
                  IN adminName VARCHAR (255),
                  IN importance INTEGER,
                  OUT current_id INTEGER )
                  PARAMETER STYLE JAVA
                  LANGUAGE JAVA
                  MODIFIES SQL DATA
                  EXTERNAL NAME 'com.ca.ims.db.derby.RuntimeDBProcedures.insertRuntimeStatusDetailProcedure';


ALTER TABLE event12_5 ADD 
        CONSTRAINT PK_event12_5 PRIMARY KEY   
        (
                eventid
        )  ;

ALTER TABLE event_object12_5 ADD 
        CONSTRAINT PK_event_object12_5 PRIMARY KEY
        (
                eventid,
                object_type,
                object_uniquename
        );

ALTER TABLE lock12_5 ADD 
        CONSTRAINT PK_lock12_5 PRIMARY KEY
        (
                lockid,
                lockinfo
        );

ALTER TABLE  object12_5 ADD 
        CONSTRAINT PK_object12_5 PRIMARY KEY
        (
                objectid,
                objecttype
        );

ALTER TABLE tasksession12_5 ADD 
        CONSTRAINT PK_tasksession12_5 PRIMARY KEY
        (
                tasksessionid
        );

ALTER TABLE event12_5 ADD 
        CONSTRAINT FK_event12_5_tasksession12_5 FOREIGN KEY 
        (
                tasksessionid
        ) REFERENCES tasksession12_5 (
                tasksessionid
        );

ALTER TABLE tasksession12_5 ADD 
        CONSTRAINT FK_tasksession12_5_tasksession12_5 FOREIGN KEY 
        (
                initiatorid
        ) REFERENCES tasksession12_5 (
                tasksessionid
        );

ALTER TABLE event_object12_5 ADD 
        CONSTRAINT FK_event_object12_5_event12_5 FOREIGN KEY 
        (
                eventid
        ) REFERENCES event12_5 (
                eventid
        );
        
create index idx_ts12_5_initiatorid on tasksession12_5(initiatorid);
create index idx_event12_5_tasksessionid on event12_5(tasksessionid);
create index idx_rtmstatusdetail12_eventid on runtimestatusdetail12(eventid);

DROP PROCEDURE garbageCollectTaskPersistenceWithTimeOut;
DROP PROCEDURE garbageCollectTaskPersistence;

-- Upgrade to Quartz 1.7.3 db sql begin

  ALTER TABLE qrtz_triggers ADD COLUMN priority integer;
  ALTER TABLE qrtz_fired_triggers ADD COLUMN priority integer;
    
  UPDATE qrtz_triggers SET priority=5 WHERE priority IS NULL;
  UPDATE qrtz_fired_triggers SET priority=5 WHERE priority IS NULL;
		  
-- Upgrade to Quartz 1.7.3 db sql end

