create index idx_ts12_5_initiatorid on tasksession12_5(initiatorid);
create index idx_event12_5_tasksessionid on event12_5(tasksessionid);
create index idx_rtmstatusdetail12_eventid on runtimestatusdetail12(eventid);

delete from tp_version;
insert into tp_version(tp_key,tp_value) values ('version','12.6.2.0.0');

alter table runtimeStatusDetail12 alter column descriptionParam varchar(1024);
alter table runtimeStatusDetail12 alter column description varchar(2000);

DROP PROCEDURE insertRuntimeStatusDetail;

CREATE PROCEDURE insertRuntimeStatusDetail (
                  IN originationTime TIMESTAMP,
                  IN eventID VARCHAR (255),
                  IN parentID VARCHAR (255),
                  IN sourceIdentifier VARCHAR (255),
                  IN serverName VARCHAR (255),
                  IN provDomainName VARCHAR (255),
                  IN displayName VARCHAR (255),
                  IN description VARCHAR (2000),
                  IN descriptionType VARCHAR (255),
                  IN descriptionParam VARCHAR (1024),
                  IN admindn VARCHAR (255),
                  IN adminName VARCHAR (255),
                  IN importance INTEGER,
                  OUT current_id INTEGER )
                  PARAMETER STYLE JAVA
                  LANGUAGE JAVA
                  MODIFIES SQL DATA
                  EXTERNAL NAME 'com.ca.ims.db.derby.RuntimeDBProcedures.insertRuntimeStatusDetailProcedure';

-- Upgrade to Quartz 1.7.3 db sql begin

  ALTER TABLE qrtz_triggers ADD COLUMN priority integer;
  ALTER TABLE qrtz_fired_triggers ADD COLUMN priority integer;
    
  UPDATE qrtz_triggers SET priority=5 WHERE priority IS NULL;
  UPDATE qrtz_fired_triggers SET priority=5 WHERE priority IS NULL;
		  
-- Upgrade to Quartz 1.7.3 db sql end

