--
-- Runtime status detail related schema objects.
--

-- INNODB is required for FOREIGN KEY CONSTRAINTS and AUTO_INCREMENT.
SET storage_engine=INNODB;


CREATE TABLE archive_runtimeStatusDetail12 (
        id                  INT NOT NULL,
        originationTime     DATETIME NOT NULL,
        eventID             VARCHAR (255) NOT NULL,
        parentID            VARCHAR (255) NULL,
        sourceIdentifier    VARCHAR (255) NOT NULL,
        serverName          VARCHAR (255) NOT NULL,
        provDomainName      VARCHAR (255) NULL,
        displayName         VARCHAR (255) NOT NULL,
        description         VARCHAR (2000) NULL,
        descriptionType     VARCHAR (255) NULL,
        descriptionParam    VARCHAR (1024) NULL,
        admindn             VARCHAR (628) NOT NULL,
        adminName           VARCHAR (255) NOT NULL,
        importance          INT NULL
);

ALTER TABLE archive_runtimeStatusDetail12 ADD
        CONSTRAINT PK_archive_runtimeStatusDetail12 PRIMARY KEY (
        id
);


CREATE TABLE archive_rsdAttribute12 (
        id              INT NOT NULL,
        rsdid           INT NOT NULL,
        profiletype     INT NOT NULL,
        profilename     VARCHAR (255) NOT NULL,
        attrname        VARCHAR (255) NOT NULL,
        attrvalue       VARCHAR (1024) NULL,
        status          VARCHAR (255) NULL,
        attrType        VARCHAR (255) NULL,
        additionalInfo  VARCHAR (255) NULL
);

ALTER TABLE archive_rsdAttribute12 ADD
        CONSTRAINT PK_archive_rsdAttribute12 PRIMARY KEY (
            rsdid,
            id
        );


CREATE TABLE archive_object12_5 (
        objectid    VARCHAR (50) NOT NULL,
        objecttype  INT NOT NULL,
        object      LONGBLOB NULL
);

ALTER TABLE archive_object12_5 ADD
        CONSTRAINT PK_archive_object12_5 PRIMARY KEY (
                objectid,
                objecttype
        );


CREATE TABLE archive_tasksession12_5 (
        tasksessionid       VARCHAR (50) NOT NULL,
        state               VARCHAR(50) NOT NULL,
        created_time        DATETIME NOT NULL,
        last_access_time    DATETIME NOT NULL,
        user_dn             VARCHAR (512)NOT NULL,
        org_dn              VARCHAR (512) NOT NULL,
        environmentid       VARCHAR (50) NOT NULL,
        name                VARCHAR (512) NOT NULL,
        description         VARCHAR (2000) NOT NULL,
        acknowledged        CHAR NOT NULL,
        parent_of_wf_id     VARCHAR (50) NULL,
        action_type         INT NOT NULL,
        priority            INT NULL,
        initiatorid         VARCHAR (50) NULL,
        nesting_type        INT NULL,
        next_state          INT NULL
);

ALTER TABLE archive_tasksession12_5 ADD
        CONSTRAINT PK_archive_tasksession12_5 PRIMARY KEY (
                tasksessionid
        );


CREATE TABLE archive_event12_5 (
        eventid             VARCHAR (50) NOT NULL,
        state               INT NOT NULL,
        tasksessionid       VARCHAR (50) NOT NULL,
        created_on          DATETIME NOT NULL,
        last_access_time    DATETIME NOT NULL,
        name                VARCHAR (512) NOT NULL,
        description         VARCHAR (2000) NOT NULL,
        type                INT NOT NULL,
        next_state          INT NULL
);

ALTER TABLE archive_event12_5 ADD
        CONSTRAINT PK_archive_event12_5 PRIMARY KEY   (
                eventid
        );


-- with charset=utf8, MySQL requires 3x the number of chars and
-- consquently throws a ERROR 1071: Specified key was too long; max length
-- is 767 bytes

CREATE TABLE archive_event_object12_5 (
        tasksessionid       VARCHAR (50) NOT NULL,
        eventid             VARCHAR (50) NOT NULL,
        -- object_type         VARCHAR (128) NOT NULL,
        object_type         VARCHAR (100) NOT NULL,
        isprimary           CHAR NOT NULL,
        -- object_uniquename   VARCHAR (512) NOT NULL
        object_uniquename   VARCHAR (250) NOT NULL
);

ALTER TABLE archive_event_object12_5 ADD
        CONSTRAINT PK_archive_event_object12_5 PRIMARY KEY (
                eventid,
                object_type,
                object_uniquename
        );


ALTER TABLE archive_event12_5 ADD
        CONSTRAINT FK_archive_event12_5_archive_tasksession12_5 FOREIGN KEY (
                tasksessionid
        )
        REFERENCES archive_tasksession12_5 (
                tasksessionid
        );


ALTER TABLE archive_tasksession12_5 ADD
        CONSTRAINT FK_archive_tasksession12_5_archive_tasksession12_5 FOREIGN KEY (
                initiatorid
        ) REFERENCES archive_tasksession12_5 (
                tasksessionid
        );


ALTER TABLE archive_event_object12_5 ADD
        CONSTRAINT FK_archive_event_object12_5_archive_event12_5 FOREIGN KEY (
                eventid
        ) REFERENCES archive_event12_5 (
                eventid
        );


