-- INNODB is required for FOREIGN KEY CONSTRAINTS and AUTO_INCREMENT.
SET storage_engine=INNODB;
DROP PROCEDURE IF EXISTS remove_table_constraints;

DELIMITER ++

CREATE PROCEDURE remove_table_constraints ()
BEGIN
    DECLARE table_count INT;

    -- foreign key constraints must be deleted first
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'archive_event12_5' AND table_schema = DATABASE();
    IF table_count > 0 THEN
            ALTER TABLE archive_event12_5 DROP FOREIGN KEY FK_archive_event12_5_archive_tasksession12_5;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'archive_tasksession12_5' AND table_schema = DATABASE();
    IF table_count > 0 THEN
            ALTER TABLE archive_tasksession12_5 DROP FOREIGN KEY FK_archive_tasksession12_5_archive_tasksession12_5;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'archive_event_object12_5' AND table_schema = DATABASE();
    IF table_count > 0 THEN
            ALTER TABLE archive_event_object12_5 DROP FOREIGN KEY FK_archive_event_object12_5_archive_event12_5;
    END IF;

    -- followed by any primary key, auto_increment, unique constraints or indexes
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'archive_runtimeStatusDetail12' AND table_schema = DATABASE();
    IF table_count > 0 THEN
            ALTER TABLE archive_runtimeStatusDetail12 MODIFY id INT NOT NULL;
            ALTER TABLE archive_runtimeStatusDetail12 DROP PRIMARY KEY;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'archive_rsdAttribute12' AND table_schema = DATABASE();
    IF table_count > 0 THEN
            ALTER TABLE archive_rsdAttribute12 MODIFY id INT NOT NULL;
            ALTER TABLE archive_rsdAttribute12 DROP PRIMARY KEY;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'archive_object12_5' AND table_schema = DATABASE();
    IF table_count > 0 THEN
            ALTER TABLE archive_object12_5 DROP PRIMARY KEY;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'archive_event12_5' AND table_schema = DATABASE();
    IF table_count > 0 THEN
            ALTER TABLE archive_event12_5 DROP PRIMARY KEY;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'archive_tasksession12_5' AND table_schema = DATABASE();
    IF table_count > 0 THEN
            ALTER TABLE archive_tasksession12_5 DROP PRIMARY KEY;
    END IF;
    SELECT COUNT(*) INTO table_count FROM information_schema.tables WHERE table_name = 'archive_event_object12_5' AND table_schema = DATABASE();
    IF table_count > 0 THEN
            ALTER TABLE archive_event_object12_5 DROP PRIMARY KEY;
    END IF;

END++

DELIMITER ;

-- Call it...
CALL remove_table_constraints();

-- ...then drop it.

DROP TABLE IF EXISTS archive_runtimeStatusDetail12;

DROP TABLE IF EXISTS archive_rsdAttribute12;

DROP TABLE IF EXISTS archive_object12_5;

DROP TABLE IF EXISTS archive_tasksession12_5;

DROP TABLE IF EXISTS archive_event12_5;

DROP TABLE IF EXISTS archive_event_object12_5;

