
CREATE TABLE archive_runtimeStatusDetail12 (
    id NUMBER(16,0) NOT NULL ,
    originationTime DATE NOT NULL ,
    eventID VARCHAR2 (255) NOT NULL ,
    parentID VARCHAR2 (255) ,
    sourceIdentifier VARCHAR2 (255) NOT NULL ,
    serverName VARCHAR2 (255) NOT NULL ,
    provDomainName VARCHAR2 (255) ,
    displayName VARCHAR2 (255) NOT NULL ,
    description VARCHAR2 (2000) ,
    descriptionType VARCHAR2 (255) ,
    descriptionParam VARCHAR2 (1024) NULL ,
    admindn VARCHAR2 (628) NOT NULL ,
    adminName VARCHAR2 (255) NOT NULL ,
    importance NUMBER(16,0)
) ;

ALTER TABLE archive_runtimeStatusDetail12  ADD 
    CONSTRAINT PK_arch_runtimeStatusDetail12 PRIMARY KEY   
    (
        id
    )  ;

CREATE TABLE archive_rsdAttribute12 (
    id NUMBER(16,0) NOT NULL ,
    rsdid NUMBER(16,0) NOT NULL ,
    profiletype NUMBER(16,0) NOT NULL ,
    profilename VARCHAR2 (255) NOT NULL ,
    attrname VARCHAR2 (255) NOT NULL ,
    attrvalue VARCHAR2 (1024) ,
    status VARCHAR2 (255) ,
    attrType VARCHAR2 (255) ,
    additionalInfo VARCHAR2 (255)  
) ;

ALTER TABLE archive_rsdAttribute12  ADD 
    CONSTRAINT PK_arch_rsdAttribute12 PRIMARY KEY   
    (
        rsdid,
        id
    )  ;

CREATE TABLE archive_event12_5 (
        eventid NVARCHAR2 (50)   NOT NULL ,
        state NUMBER(16,0) NOT NULL ,
        tasksessionid NVARCHAR2 (50)   NOT NULL ,
        created_on DATE NOT NULL ,
        last_access_time DATE NOT NULL ,
        name NVARCHAR2 (512)   NOT NULL ,
        description NVARCHAR2 (2000)   NOT NULL ,
        type NUMBER(16,0) NOT NULL ,
        next_state NUMBER(16,0)
); 

CREATE TABLE archive_event_object12_5 (
        tasksessionid NVARCHAR2 (50)   NOT NULL ,
        eventid NVARCHAR2 (50)   NOT NULL ,
        object_type NVARCHAR2 (128) NOT NULL ,
        isprimary CHAR NOT NULL ,
        object_uniquename NVARCHAR2 (256) NOT NULL 
);

CREATE TABLE archive_object12_5 (
        objectid NVARCHAR2 (50)   NOT NULL ,
        objecttype NUMBER(16,0) NOT NULL ,
        object BLOB
);

CREATE TABLE archive_tasksession12_5 (
        tasksessionid NVARCHAR2 (50)   NOT NULL ,
        state NUMBER(16,0) NOT NULL ,
        created_time DATE NOT NULL ,
        last_access_time DATE NOT NULL ,
        user_dn NVARCHAR2 (512)   NOT NULL ,
        org_dn NVARCHAR2 (512)   NOT NULL ,
        environmentid NVARCHAR2 (50)   NOT NULL ,
        name NVARCHAR2 (512)   NOT NULL ,
        description NVARCHAR2 (2000)   NOT NULL ,
        acknowledged CHAR NOT NULL ,
        parent_of_wf_id NVARCHAR2 (50) ,
        action_type NUMBER(16,0) NOT NULL ,
        priority NUMBER(16,0),
        initiatorid NVARCHAR2 (50) ,
        nesting_type NUMBER(16,0),
        next_state NUMBER(16,0)
);

ALTER TABLE archive_event12_5 ADD 
        CONSTRAINT PK_arch_event12_5 PRIMARY KEY   
        (
                eventid
        )  ;

ALTER TABLE archive_event_object12_5 ADD 
        CONSTRAINT PK_arch_event_object12_5 PRIMARY KEY
        (
                eventid,
                object_type,
                object_uniquename
        );

ALTER TABLE  archive_object12_5 ADD 
        CONSTRAINT PK_arch_object12_5 PRIMARY KEY
        (
                objectid,
                objecttype
        );

ALTER TABLE archive_tasksession12_5 ADD 
        CONSTRAINT PK_arch_tasksession12_5 PRIMARY KEY
        (
                tasksessionid
        );

ALTER TABLE archive_event12_5 ADD 
        CONSTRAINT FK_arch_event_tasksession12_5 FOREIGN KEY 
        (
                tasksessionid
        ) REFERENCES archive_tasksession12_5 (
                tasksessionid
        );

ALTER TABLE archive_tasksession12_5 ADD 
        CONSTRAINT FK_arch_ts_ts12_5 FOREIGN KEY 
        (
                initiatorid
        ) REFERENCES archive_tasksession12_5 (
                tasksessionid
        );

ALTER TABLE archive_event_object12_5 ADD 
        CONSTRAINT FK_arch_eventobj_event12_5 FOREIGN KEY 
        (
                eventid
        ) REFERENCES archive_event12_5 (
                eventid
        );
