--
-- Runtime status detail related schema objects.
--

-- SEQUENCE For runtimeStatusDetail12.id generation

create sequence SEQ_rsd12 increment by 1  start with 1 ;


-- SEQUENCE For runtimeStatusDetailAttribute12.id generation

create sequence SEQ_rsdAttribute12 increment by 1  start with 1 ;

CREATE TABLE runtimeStatusDetail12 (
    id NUMBER(16,0) NOT NULL ,
    originationTime DATE NOT NULL ,
    eventID VARCHAR2 (255) NOT NULL ,
    parentID VARCHAR2 (255) ,
    sourceIdentifier VARCHAR2 (255) NOT NULL ,
    serverName VARCHAR2 (255) NOT NULL ,
    provDomainName VARCHAR2 (255) ,
    displayName VARCHAR2 (255) NOT NULL ,
    description VARCHAR2 (2000) ,
    descriptionType VARCHAR2 (255) ,
    descriptionParam VARCHAR2 (1024) NULL ,
    admindn VARCHAR2 (628) NOT NULL ,
    adminName VARCHAR2 (255) NOT NULL ,
    importance NUMBER(16,0)
) ;

ALTER TABLE runtimeStatusDetail12  ADD 
    CONSTRAINT PK_runtimeStatusDetail12 PRIMARY KEY   
    (
        id
    )  ;

CREATE TABLE runtimeStatusDetailAttribute12 (
    id NUMBER(16,0) NOT NULL ,
    rsdid NUMBER(16,0) NOT NULL ,
    profiletype NUMBER(16,0) NOT NULL ,
    profilename VARCHAR2 (255) NOT NULL ,
    attrname VARCHAR2 (255) NOT NULL ,
    attrvalue VARCHAR2 (1024) ,
    status VARCHAR2 (255) ,
    attrType VARCHAR2 (255) ,
    additionalInfo VARCHAR2 (255)  
) ;

ALTER TABLE runtimeStatusDetailAttribute12  ADD 
    CONSTRAINT PK_rsdAttribute12 PRIMARY KEY   
    (
        rsdid,
        id
    )  ;

CREATE OR REPLACE  PROCEDURE insertRuntimeStatusDetail(
                  i_originationTime DATE,
                  i_eventID VARCHAR2,
                  i_parentID VARCHAR2,
                  i_sourceIdentifier VARCHAR2,
                  i_serverName VARCHAR2,
                  i_provDomainName VARCHAR2,
                  i_displayName VARCHAR2,
                  i_description VARCHAR2,
                  i_descriptionType VARCHAR2,
                  i_descriptionParam VARCHAR2,
                  i_admindn VARCHAR2,
                  i_adminName VARCHAR2,
				  i_importance integer,
                  o_current_id out integer)
AS
BEGIN
SELECT SEQ_rsd12.NEXTVAL
    INTO   o_current_id
    FROM   Dual;    
insert into runtimeStatusDetail12 (
                     id,
                     originationTime,
                     eventID,
                     parentID,
                     sourceIdentifier,
                     serverName,
                     provDomainName,
                     displayName,
                     description,
                     descriptionType,
                     descriptionParam,
                     admindn,
                     adminName,
					importance)

            values (
                     o_current_id,
                     i_originationTime,
                     i_eventID,
                     i_parentID,
                     i_sourceIdentifier,
                     i_serverName,
                     i_provDomainName,
                     i_displayName,
                     i_description,
                     i_descriptionType,
                     i_descriptionParam,
                     i_admindn,
                     i_adminName,
					i_importance);
RETURN;    
END;
/

CREATE OR REPLACE  PROCEDURE insertRuntimeStatusDetailAttr(
        i_rsdid integer,
        i_profiletype integer,
        i_profilename VARCHAR2,
        i_attrname VARCHAR2,
        i_attrvalue VARCHAR2,
        i_status VARCHAR2,
        i_attrType VARCHAR2,
        i_additionalInfo VARCHAR2)
AS
current_id NUMBER;
BEGIN
SELECT SEQ_rsdAttribute12.NEXTVAL
    INTO   current_id
    FROM   Dual;    

 insert into runtimeStatusDetailAttribute12 (
            id,
            rsdid,
            profiletype,
            profilename,
            attrname,
            attrvalue,
            status,
            attrType,
            additionalInfo
            )

            values (
            current_id,
            i_rsdid,
            i_profiletype,
            i_profilename,
            i_attrname,
            i_attrvalue,
            i_status,
            i_attrType,
            i_additionalInfo);
RETURN;    
END;
/

-- End Runtime status detail related schema objects.

-- SEQUENCE For AuxData12.Id generation
create sequence SEQ_ad12 increment by 1  start with 1 ;

-- SEQUENCE For AuxDataProviders12.Id generation
create sequence SEQ_adp12 increment by 1  start with 1 ;

CREATE TABLE AuxData12 (
	Id integer NOT NULL,
	EnvOID VARCHAR2(64) NOT NULL,
	ParentId integer NULL,
	Precedence integer NULL,
	ProviderId integer NULL,
	Name VARCHAR2(255) NOT NULL,
	Type VARCHAR2(255) NOT NULL,
	DisplayName VARCHAR2(255) NULL
);

CREATE OR REPLACE  PROCEDURE insertAuxData (
    i_envOID VARCHAR2,
    i_parentID INTEGER,
    i_precedence INTEGER,
    i_providerID INTEGER,
    i_name VARCHAR2,
    i_type VARCHAR2,
    i_displayName VARCHAR2,
    o_currentID OUT INTEGER)
AS
BEGIN
SELECT SEQ_ad12.NEXTVAL
    INTO   o_currentID
    FROM   Dual;    
insert into AuxData12 (
    Id,
    EnvOID,
    ParentId,
    Precedence,
    ProviderId,
    Name,
    Type,
    DisplayName
)
values (
    o_currentID,
    i_envOID,
    i_parentID,
    i_precedence,
    i_providerID,
    i_name,
    i_type,
    i_displayName
);
RETURN;    
END;
/

CREATE TABLE AuxDataProviders12 (
	Id integer NOT NULL,
	EnvOID VARCHAR2(64) NOT NULL,
	Type integer NOT NULL,
	DisplayName VARCHAR2(255) NOT NULL,
	Precedence integer NOT NULL,
	Description VARCHAR2(255) NULL,
	NodeId integer NULL,
	FileName VARCHAR2(255) NULL,
	ClassName VARCHAR2(255) NULL
);

CREATE OR REPLACE  PROCEDURE insertAuxDataProvider (
    i_envOID VARCHAR2,
    i_type VARCHAR2,
    i_displayName VARCHAR2,
    i_precedence INTEGER,
    i_description VARCHAR2,
    i_nodeID INTEGER,
    i_fileName VARCHAR2,
    i_className VARCHAR2,
    o_currentID OUT INTEGER)
AS
BEGIN
SELECT SEQ_adp12.NEXTVAL
    INTO   o_currentID
    FROM   Dual;    
insert into AuxDataProviders12 (
    Id,
    EnvOID,
    Type,
    DisplayName,
    Precedence,
    Description,
    NodeId,
    FileName,
    ClassName
)
values (
    o_currentID,
    i_envOID,
    i_type,
    i_displayName,
    i_precedence,
    i_description,
    i_nodeID,
    i_fileName,
    i_className
);
RETURN;    
END;
/


CREATE TABLE event12_5 (
        eventid NVARCHAR2 (50)   NOT NULL ,
        state NUMBER(16,0) NOT NULL ,
        tasksessionid NVARCHAR2 (50)   NOT NULL ,
        created_on DATE NOT NULL ,
        last_access_time DATE NOT NULL ,
        name NVARCHAR2 (512)   NOT NULL ,
        description NVARCHAR2 (2000)   NOT NULL ,
        type NUMBER(16,0) NOT NULL ,
        next_state NUMBER(16,0)
); 

CREATE TABLE event_object12_5 (
        tasksessionid NVARCHAR2 (50)   NOT NULL ,
        eventid NVARCHAR2 (50)   NOT NULL ,
        object_type NVARCHAR2 (128) NOT NULL ,
        isprimary CHAR NOT NULL ,
        object_uniquename NVARCHAR2 (256) NOT NULL 
);

CREATE TABLE lock12_5 (
        lockid NVARCHAR2 (50)   NOT NULL ,
        lockinfo NVARCHAR2 (400)  NOT NULL
);

CREATE TABLE object12_5 (
        objectid NVARCHAR2 (50)   NOT NULL ,
        objecttype NUMBER(16,0) NOT NULL ,
        object BLOB
);

CREATE TABLE tasksession12_5 (
        tasksessionid NVARCHAR2 (50)   NOT NULL ,
        state NUMBER(16,0) NOT NULL ,
        created_time DATE NOT NULL ,
        last_access_time DATE NOT NULL ,
        user_dn NVARCHAR2 (512)   NOT NULL ,
        org_dn NVARCHAR2 (512)   NOT NULL ,
        environmentid NVARCHAR2 (50)   NOT NULL ,
        name NVARCHAR2 (512)   NOT NULL ,
        description NVARCHAR2 (2000)   NOT NULL ,
        acknowledged CHAR NOT NULL ,
        parent_of_wf_id NVARCHAR2 (50) ,
        action_type NUMBER(16,0) NOT NULL ,
        priority NUMBER(16,0),
        initiatorid NVARCHAR2 (50) ,
        nesting_type NUMBER(16,0),
        next_state NUMBER(16,0)
);

CREATE TABLE tp_version (
        tp_key NVARCHAR2(255) NOT NULL,
        tp_value NVARCHAR2(255) NOT NULL
);

ALTER TABLE event12_5 ADD 
        CONSTRAINT PK_event12_5 PRIMARY KEY   
        (
                eventid
        )  ;

ALTER TABLE event_object12_5 ADD 
        CONSTRAINT PK_event_object12_5 PRIMARY KEY
        (
                eventid,
                object_type,
                object_uniquename
        );

ALTER TABLE lock12_5 ADD 
        CONSTRAINT PK_lock12_5 PRIMARY KEY
        (
                lockid,
                lockinfo
        );

ALTER TABLE  object12_5 ADD 
        CONSTRAINT PK_object12_5 PRIMARY KEY
        (
                objectid,
                objecttype
        );

ALTER TABLE tasksession12_5 ADD 
        CONSTRAINT PK_tasksession12_5 PRIMARY KEY
        (
                tasksessionid
        );

ALTER TABLE event12_5 ADD 
        CONSTRAINT FK_event12_5_tasksession12_5 FOREIGN KEY 
        (
                tasksessionid
        ) REFERENCES tasksession12_5 (
                tasksessionid
        );

ALTER TABLE tasksession12_5 ADD 
        CONSTRAINT FK_tsession12_5_tsession12_5 FOREIGN KEY 
        (
                initiatorid
        ) REFERENCES tasksession12_5 (
                tasksessionid
        );

ALTER TABLE event_object12_5 ADD 
        CONSTRAINT FK_event_object12_5_event12_5 FOREIGN KEY 
        (
                eventid
        ) REFERENCES event12_5 (
                eventid
        );

ALTER TABLE tp_version ADD 
    CONSTRAINT PK_tp_version PRIMARY KEY 
    (
        tp_key
    );

insert into tp_version(tp_key,tp_value) values ('version','12.6.2.0.0');

ALTER TABLE AuxData12 ADD 
        CONSTRAINT PK_AuxData12 PRIMARY KEY
        (
                Id
        );
        
ALTER TABLE AuxDataProviders12 ADD 
        CONSTRAINT PK_AuxDataProviders12 PRIMARY KEY
        (
                Id
        );
        
ALTER TABLE AuxData12 ADD 
        CONSTRAINT FK_AuxData12_parent FOREIGN KEY 
        (
                ParentId
        ) REFERENCES AuxData12 (
                Id
        );
        
ALTER TABLE AuxData12 ADD 
        CONSTRAINT FK_AuxData12_provider FOREIGN KEY 
        (
                ProviderId
        ) REFERENCES AuxDataProviders12 (
                Id
        );
        
ALTER TABLE AuxDataProviders12 ADD 
        CONSTRAINT FK_AuxDataProviders12_rootNode FOREIGN KEY 
        (
                NodeId
        ) REFERENCES AuxData12 (
                Id
        );

--	Quartz 1.7.3 tables - begin
-- A hint submitted by a user: Oracle DB MUST be created as "shared" and the 
-- job_queue_processes parameter  must be greater than 2, otherwise a DB lock 
-- will happen.   However, these settings are pretty much standard after any
-- Oracle install, so most users need not worry about this.
--




CREATE TABLE qrtz_job_details
  (
    JOB_NAME  VARCHAR2(200) NOT NULL,
    JOB_GROUP VARCHAR2(200) NOT NULL,
    DESCRIPTION VARCHAR2(250) NULL,
    JOB_CLASS_NAME   VARCHAR2(250) NOT NULL, 
    IS_DURABLE VARCHAR2(1) NOT NULL,
    IS_VOLATILE VARCHAR2(1) NOT NULL,
    IS_STATEFUL VARCHAR2(1) NOT NULL,
    REQUESTS_RECOVERY VARCHAR2(1) NOT NULL,
    JOB_DATA BLOB NULL,
    PRIMARY KEY (JOB_NAME,JOB_GROUP)
);
CREATE TABLE qrtz_job_listeners
  (
    JOB_NAME  VARCHAR2(200) NOT NULL, 
    JOB_GROUP VARCHAR2(200) NOT NULL,
    JOB_LISTENER VARCHAR2(200) NOT NULL,
    PRIMARY KEY (JOB_NAME,JOB_GROUP,JOB_LISTENER),
    FOREIGN KEY (JOB_NAME,JOB_GROUP) 
	REFERENCES QRTZ_JOB_DETAILS(JOB_NAME,JOB_GROUP)
);
CREATE TABLE qrtz_triggers
  (
    TRIGGER_NAME VARCHAR2(200) NOT NULL,
    TRIGGER_GROUP VARCHAR2(200) NOT NULL,
    JOB_NAME  VARCHAR2(200) NOT NULL, 
    JOB_GROUP VARCHAR2(200) NOT NULL,
    IS_VOLATILE VARCHAR2(1) NOT NULL,
    DESCRIPTION VARCHAR2(250) NULL,
    NEXT_FIRE_TIME NUMBER(13) NULL,
    PREV_FIRE_TIME NUMBER(13) NULL,
    PRIORITY NUMBER(13) NULL,
    TRIGGER_STATE VARCHAR2(16) NOT NULL,
    TRIGGER_TYPE VARCHAR2(8) NOT NULL,
    START_TIME NUMBER(13) NOT NULL,
    END_TIME NUMBER(13) NULL,
    CALENDAR_NAME VARCHAR2(200) NULL,
    MISFIRE_INSTR NUMBER(2) NULL,
    JOB_DATA BLOB NULL,
    PRIMARY KEY (TRIGGER_NAME,TRIGGER_GROUP),
    FOREIGN KEY (JOB_NAME,JOB_GROUP) 
	REFERENCES QRTZ_JOB_DETAILS(JOB_NAME,JOB_GROUP) 
);
CREATE TABLE qrtz_simple_triggers
  (
    TRIGGER_NAME VARCHAR2(200) NOT NULL,
    TRIGGER_GROUP VARCHAR2(200) NOT NULL,
    REPEAT_COUNT NUMBER(7) NOT NULL,
    REPEAT_INTERVAL NUMBER(12) NOT NULL,
    TIMES_TRIGGERED NUMBER(10) NOT NULL,
    PRIMARY KEY (TRIGGER_NAME,TRIGGER_GROUP),
    FOREIGN KEY (TRIGGER_NAME,TRIGGER_GROUP) 
	REFERENCES QRTZ_TRIGGERS(TRIGGER_NAME,TRIGGER_GROUP)
);
CREATE TABLE qrtz_cron_triggers
  (
    TRIGGER_NAME VARCHAR2(200) NOT NULL,
    TRIGGER_GROUP VARCHAR2(200) NOT NULL,
    CRON_EXPRESSION VARCHAR2(120) NOT NULL,
    TIME_ZONE_ID VARCHAR2(80),
    PRIMARY KEY (TRIGGER_NAME,TRIGGER_GROUP),
    FOREIGN KEY (TRIGGER_NAME,TRIGGER_GROUP) 
	REFERENCES QRTZ_TRIGGERS(TRIGGER_NAME,TRIGGER_GROUP)
);
CREATE TABLE qrtz_blob_triggers
  (
    TRIGGER_NAME VARCHAR2(200) NOT NULL,
    TRIGGER_GROUP VARCHAR2(200) NOT NULL,
    BLOB_DATA BLOB NULL,
    PRIMARY KEY (TRIGGER_NAME,TRIGGER_GROUP),
    FOREIGN KEY (TRIGGER_NAME,TRIGGER_GROUP) 
        REFERENCES QRTZ_TRIGGERS(TRIGGER_NAME,TRIGGER_GROUP)
);
CREATE TABLE qrtz_trigger_listeners
  (
    TRIGGER_NAME  VARCHAR2(200) NOT NULL, 
    TRIGGER_GROUP VARCHAR2(200) NOT NULL,
    TRIGGER_LISTENER VARCHAR2(200) NOT NULL,
    PRIMARY KEY (TRIGGER_NAME,TRIGGER_GROUP,TRIGGER_LISTENER),
    FOREIGN KEY (TRIGGER_NAME,TRIGGER_GROUP) 
	REFERENCES QRTZ_TRIGGERS(TRIGGER_NAME,TRIGGER_GROUP)
);
CREATE TABLE qrtz_calendars
  (
    CALENDAR_NAME  VARCHAR2(200) NOT NULL, 
    CALENDAR BLOB NOT NULL,
    PRIMARY KEY (CALENDAR_NAME)
);
CREATE TABLE qrtz_paused_trigger_grps
  (
    TRIGGER_GROUP  VARCHAR2(200) NOT NULL, 
    PRIMARY KEY (TRIGGER_GROUP)
);
CREATE TABLE qrtz_fired_triggers 
  (
    ENTRY_ID VARCHAR2(95) NOT NULL,
    TRIGGER_NAME VARCHAR2(200) NOT NULL,
    TRIGGER_GROUP VARCHAR2(200) NOT NULL,
    IS_VOLATILE VARCHAR2(1) NOT NULL,
    INSTANCE_NAME VARCHAR2(200) NOT NULL,
    FIRED_TIME NUMBER(13) NOT NULL,
    PRIORITY NUMBER(13) NOT NULL,
    STATE VARCHAR2(16) NOT NULL,
    JOB_NAME VARCHAR2(200) NULL,
    JOB_GROUP VARCHAR2(200) NULL,
    IS_STATEFUL VARCHAR2(1) NULL,
    REQUESTS_RECOVERY VARCHAR2(1) NULL,
    PRIMARY KEY (ENTRY_ID)
);
CREATE TABLE qrtz_scheduler_state 
  (
    INSTANCE_NAME VARCHAR2(200) NOT NULL,
    LAST_CHECKIN_TIME NUMBER(13) NOT NULL,
    CHECKIN_INTERVAL NUMBER(13) NOT NULL,
    PRIMARY KEY (INSTANCE_NAME)
);
CREATE TABLE qrtz_locks
  (
    LOCK_NAME  VARCHAR2(40) NOT NULL, 
    PRIMARY KEY (LOCK_NAME)
);
INSERT INTO qrtz_locks values('TRIGGER_ACCESS');
INSERT INTO qrtz_locks values('JOB_ACCESS');
INSERT INTO qrtz_locks values('CALENDAR_ACCESS');
INSERT INTO qrtz_locks values('STATE_ACCESS');
INSERT INTO qrtz_locks values('MISFIRE_ACCESS');
create index idx_qrtz_j_req_recovery on qrtz_job_details(REQUESTS_RECOVERY);
create index idx_qrtz_t_next_fire_time on qrtz_triggers(NEXT_FIRE_TIME);
create index idx_qrtz_t_state on qrtz_triggers(TRIGGER_STATE);
create index idx_qrtz_t_nft_st on qrtz_triggers(NEXT_FIRE_TIME,TRIGGER_STATE);
create index idx_qrtz_t_volatile on qrtz_triggers(IS_VOLATILE);
create index idx_qrtz_ft_trig_name on qrtz_fired_triggers(TRIGGER_NAME);
create index idx_qrtz_ft_trig_group on qrtz_fired_triggers(TRIGGER_GROUP);
create index idx_qrtz_ft_trig_nm_gp on qrtz_fired_triggers(TRIGGER_NAME,TRIGGER_GROUP);
create index idx_qrtz_ft_trig_volatile on qrtz_fired_triggers(IS_VOLATILE);
create index idx_qrtz_ft_trig_inst_name on qrtz_fired_triggers(INSTANCE_NAME);
create index idx_qrtz_ft_job_name on qrtz_fired_triggers(JOB_NAME);
create index idx_qrtz_ft_job_group on qrtz_fired_triggers(JOB_GROUP);
create index idx_qrtz_ft_job_stateful on qrtz_fired_triggers(IS_STATEFUL);
create index idx_qrtz_ft_job_req_recovery on qrtz_fired_triggers(REQUESTS_RECOVERY);


--	Quartz 1.7.3 tables - end

create index idx_ts12_5_initiatorid on tasksession12_5(initiatorid);
create index idx_event12_5_tasksessionid on event12_5(tasksessionid);
create index idx_rtmstatusdetail12_eventid on runtimestatusdetail12(eventid);

commit;

--  
-- Garbage Collection - start
--
--
-- garbageCollectById
--
CREATE OR REPLACE PROCEDURE garbageCollectById
(workingId IN VARCHAR2)
IS
BEGIN
	dbms_output.put_line('GC ID ' || workingId);

	-- garbage collect locks
	DELETE FROM lock12_5
	WHERE lockid = workingId;

	-- garbage collect runtme status details attributes
	DELETE FROM runtimeStatusDetailAttribute12
	WHERE rsdid IN (SELECT runtimeStatusDetail12.id FROM runtimeStatusDetail12 WHERE eventID = workingId);

	-- garbage collect runtme status details 
	DELETE FROM runtimeStatusDetail12 
	WHERE eventID = workingId;

	-- garbage collect object12_5
	DELETE FROM object12_5
	WHERE objectid = workingId;

END garbageCollectById;
/

--
-- garbageCollectByEventId
--
CREATE OR REPLACE PROCEDURE garbageCollectByEventId
(event_id IN VARCHAR2)
IS
BEGIN
	dbms_output.put_line('GC event ID ' || event_id);

	garbageCollectById(event_id);
	
	-- garbage collect event_object12_5
	DELETE FROM event_object12_5 
	WHERE eventid = event_id;
	
	-- garbage colelct event_object12_5
	DELETE FROM event12_5 
	WHERE eventid = event_id;

END garbageCollectByEventId;
/

--
-- garbageCollectByTaskId
--
CREATE OR REPLACE PROCEDURE garbageCollectByTaskId
(task_id IN VARCHAR2)
IS
	workingId VARCHAR2(255);

	-- nested tasks for removal
	CURSOR tasksCoursor IS
		SELECT tasksessionid 
		FROM tasksession12_5 
		WHERE initiatorid = task_id AND tasksessionid != initiatorid;

	-- events for removal
	CURSOR eventCoursor IS
		SELECT eventid
		FROM event12_5
		WHERE tasksessionid = task_id;
BEGIN

	dbms_output.put_line('GC task ID ' || task_id);
	
	-- garbage collect nested tasks first
	OPEN tasksCoursor;
	LOOP 
		FETCH tasksCoursor INTO workingId;
		EXIT WHEN tasksCoursor%NOTFOUND;  -- exit loop if condition is true
		garbageCollectByTaskId(workingId);
	END LOOP;
	CLOSE tasksCoursor;
	
	OPEN eventCoursor;
	LOOP 
		FETCH eventCoursor INTO workingId;
		EXIT WHEN eventCoursor%NOTFOUND;  -- exit loop if condition is true
		garbageCollectByEventId(workingId);
	END LOOP;
	CLOSE eventCoursor;
	
	garbageCollectById(task_id);
	
	-- garbage collect from tasksession12_5;
	DELETE FROM tasksession12_5
	WHERE tasksessionid = task_id;
	

END garbageCollectByTaskId;
/
--
--	garbageCollectTaskPersistence
--
CREATE OR REPLACE PROCEDURE garbageCollectTaskPersistence
(ime_id IN VARCHAR2,
cutoff_time IN DATE,
audit_timeout_days IN FLOAT DEFAULT 1, chunk_rec_count IN number DEFAULT 500)
IS
	gcTaskId VARCHAR2(255);
	counter number;
	

	-- top level tasks for removal
	CURSOR gcTasksCoursor IS
		SELECT tasksessionid 
		FROM tasksession12_5 
		WHERE environmentid = ime_id 


			AND (
					-- final states cut off
					(
						(
						
							(tasksession12_5.state = 512) --   mark for deletion 
							OR (tasksession12_5.state = 128) --  completed  
							OR (tasksession12_5.state = 256) --  cancelled   
							OR (tasksession12_5.state = 32) -- rejected   
							OR (tasksession12_5.state = 2) -- invalid   
							OR (tasksession12_5.state = 1048576) --  task aborted 
						)
						AND last_access_time < cutoff_time 
					)
					-- audit state conditional cut-off
					OR
					(
						tasksession12_5.state = 16384 -- audit state
						AND last_access_time < 
							LEAST(cutoff_time, SYSDATE - audit_timeout_days)
					)
				)
			AND (initiatorid IS NULL OR initiatorid = tasksessionid);


BEGIN
	counter:=0;
	OPEN gcTasksCoursor;
LOOP
		FETCH gcTasksCoursor INTO gcTaskId;
		
		EXIT WHEN gcTasksCoursor%NOTFOUND;
		-- exit loop if condition is true
		counter:=counter+1;
		garbageCollectByTaskId(gcTaskId);
		if counter >= chunk_rec_count then
		   COMMIT;
		   counter := 0;
		   dbms_output.put_line('GC Commited ' || counter);
		end if;
		 
END LOOP;
CLOSE gcTasksCoursor;
COMMIT;
END garbageCollectTaskPersistence;
/
-- 
-- Garbage Collection - end
--
