DECLARE
	SEQ_ad12_exist PLS_INTEGER;
	SEQ_adp12_exist PLS_INTEGER;
	SEQ_rsd12_exist PLS_INTEGER;
	SEQ_rsdAttribute12_exist PLS_INTEGER;
	proc_rsd12_exist PLS_INTEGER;
	proc_rsdAttribute12_exist PLS_INTEGER;
	tp_index_exist PLS_INTEGER;
	runtimeStatusDetail12_exist PLS_INTEGER;
	rsda12_exist PLS_INTEGER;
	lock12_exist PLS_INTEGER;
	object12_exist PLS_INTEGER;
	event_object12_exist PLS_INTEGER;
	event12_exist PLS_INTEGER;
	tasksession12_exist PLS_INTEGER;
	proc_ad12_exist PLS_INTEGER;
	proc_adp12_exist PLS_INTEGER;
	auxdata12_exist PLS_INTEGER;
	auxdataproviders12_exist PLS_INTEGER;
	quartz_table_exist PLS_INTEGER;
	quartz_index_exist PLS_INTEGER;
	proc_gc_tp_exist PLS_INTEGER;
	proc_gc_task_exist PLS_INTEGER;
	proc_gc_event_exist PLS_INTEGER;
	proc_gc_id_exist PLS_INTEGER;
BEGIN
	select count(*)   into SEQ_rsd12_exist from user_sequences where sequence_name = 'SEQ_RSD12';
	if SEQ_rsd12_exist = 1 then
		execute immediate 'DROP SEQUENCE SEQ_rsd12';
	end if;
	select count(*)   into SEQ_rsdAttribute12_exist from user_sequences where sequence_name = 'SEQ_RSDATTRIBUTE12';
	if SEQ_rsdAttribute12_exist = 1 then
		execute immediate 'DROP SEQUENCE SEQ_rsdAttribute12';
	end if;
	select count(*)   into SEQ_ad12_exist from user_sequences where sequence_name = 'SEQ_AD12';
	if SEQ_ad12_exist = 1 then
		execute immediate 'DROP SEQUENCE SEQ_ad12';
	end if;
	select count(*)   into SEQ_adp12_exist from user_sequences where sequence_name = 'SEQ_ADP12';
	if SEQ_adp12_exist = 1 then
		execute immediate 'DROP SEQUENCE SEQ_adp12';
	end if;
	select count(*)   into proc_rsd12_exist from user_procedures where object_name = 'INSERTRUNTIMESTATUSDETAIL';
	if proc_rsd12_exist = 1 then
		execute immediate 'DROP PROCEDURE insertRuntimeStatusDetail';
	end if;
	select count(*)   into proc_rsdAttribute12_exist from user_procedures where object_name = 'INSERTRUNTIMESTATUSDETAILATTR';
	if proc_rsdAttribute12_exist = 1 then
		execute immediate 'DROP PROCEDURE insertRuntimeStatusDetailAttr';
	end if;
	select count(*)   into tp_index_exist from user_indexes where index_name = 'IDX_RTMSTATUSDETAIL12_EVENTID';
	if tp_index_exist = 1 then
		execute immediate 'DROP INDEX idx_rtmstatusdetail12_eventid';
	end if;
	select count(*)	into runtimeStatusDetail12_exist from user_tables where table_name = 'RUNTIMESTATUSDETAIL12';
	if runtimeStatusDetail12_exist = 1 then
		execute immediate 'DROP TABLE runtimeStatusDetail12 CASCADE CONSTRAINTS';
	end if;
	select count(*)	into rsda12_exist from user_tables where table_name = 'RUNTIMESTATUSDETAILATTRIBUTE12';
	if rsda12_exist = 1 then
		execute immediate 'DROP TABLE runtimeStatusDetailAttribute12 CASCADE CONSTRAINTS';
	end if;
	select count(*)	into lock12_exist from user_tables where table_name = 'LOCK12_5';
	if lock12_exist = 1 then
		execute immediate 'DROP TABLE lock12_5 CASCADE CONSTRAINTS';
	end if;
	select count(*)	into object12_exist from user_tables where table_name = 'OBJECT12_5';
	if object12_exist = 1 then
		execute immediate 'DROP TABLE object12_5 CASCADE CONSTRAINTS';
	end if;
	select count(*)	into event_object12_exist from user_tables where table_name = 'EVENT_OBJECT12_5';
	if event_object12_exist = 1 then
		execute immediate 'DROP TABLE event_object12_5 CASCADE CONSTRAINTS';
	end if;
	select count(*)   into tp_index_exist from user_indexes where index_name = 'IDX_EVENT12_5_TASKSESSIONID';
	if tp_index_exist = 1 then
		execute immediate 'DROP INDEX idx_event12_5_tasksessionid';
	end if;
	select count(*)	into event12_exist from user_tables where table_name = 'EVENT12_5';
	if event12_exist = 1 then
		execute immediate 'DROP TABLE event12_5 CASCADE CONSTRAINTS';
	end if;
	select count(*)   into tp_index_exist from user_indexes where index_name = 'IDX_TS12_5_INITIATORID';
	if tp_index_exist = 1 then
		execute immediate 'DROP INDEX idx_ts12_5_initiatorid';
	end if;
	select count(*)	into tasksession12_exist from user_tables where table_name = 'TASKSESSION12_5';
	if tasksession12_exist = 1 then
		execute immediate 'DROP TABLE tasksession12_5 CASCADE CONSTRAINTS';
	end if;
    select count(*) into tasksession12_exist from user_tables where table_name = 'TP_VERSION';
    if tasksession12_exist = 1 then
        execute immediate 'DROP TABLE tp_version CASCADE CONSTRAINTS';
    end if;
	select count(*)   into proc_ad12_exist from user_procedures where object_name = 'INSERTAUXDATA';
	if proc_ad12_exist = 1 then
		execute immediate 'DROP PROCEDURE insertAuxData';
	end if;
	select count(*)   into proc_adp12_exist from user_procedures where object_name = 'INSERTAUXDATAPROVIDER';
	if proc_adp12_exist = 1 then
		execute immediate 'DROP PROCEDURE insertAuxDataProvider';
	end if;
	select count(*)	into auxdata12_exist from user_tables where table_name = 'AUXDATA12';
	if auxdata12_exist = 1 then
		execute immediate 'DROP TABLE AuxData12 CASCADE CONSTRAINTS';
	end if;
	select count(*)	into auxdataproviders12_exist from user_tables where table_name = 'AUXDATAPROVIDERS12';
	if auxdataproviders12_exist = 1 then
		execute immediate 'DROP TABLE AuxDataProviders12 CASCADE CONSTRAINTS';
	end if;

	--	Quartz 1.5.2 tables and indexes - begin
	select count(*)   into quartz_index_exist from user_indexes where index_name = 'IDX_QRTZ_J_REQ_RECOVERY';
	if quartz_index_exist = 1 then
		execute immediate 'DROP INDEX idx_qrtz_j_req_recovery';
	end if;
	select count(*)   into quartz_index_exist from user_indexes where index_name = 'IDX_QRTZ_T_NEXT_FIRE_TIME';
	if quartz_index_exist = 1 then
		execute immediate 'DROP INDEX idx_qrtz_t_next_fire_time';
	end if;
	select count(*)   into quartz_index_exist from user_indexes where index_name = 'IDX_QRTZ_T_STATE';
	if quartz_index_exist = 1 then
		execute immediate 'DROP INDEX idx_qrtz_t_state';
	end if;
	select count(*)   into quartz_index_exist from user_indexes where index_name = 'IDX_QRTZ_T_NFT_ST';
	if quartz_index_exist = 1 then
		execute immediate 'DROP INDEX idx_qrtz_t_nft_st';
	end if;
	select count(*)   into quartz_index_exist from user_indexes where index_name = 'IDX_QRTZ_T_VOLATILE';
	if quartz_index_exist = 1 then
		execute immediate 'DROP INDEX idx_qrtz_t_volatile';
	end if;
	select count(*)   into quartz_index_exist from user_indexes where index_name = 'IDX_QRTZ_FT_TRIG_NAME';
	if quartz_index_exist = 1 then
		execute immediate 'DROP INDEX idx_qrtz_ft_trig_name';
	end if;
	select count(*)   into quartz_index_exist from user_indexes where index_name = 'IDX_QRTZ_FT_TRIG_GROUP';
	if quartz_index_exist = 1 then
		execute immediate 'DROP INDEX idx_qrtz_ft_trig_group';
	end if;
	select count(*)   into quartz_index_exist from user_indexes where index_name = 'IDX_QRTZ_FT_TRIG_NM_GP';
	if quartz_index_exist = 1 then
		execute immediate 'DROP INDEX idx_qrtz_ft_trig_nm_gp';
	end if;
	select count(*)   into quartz_index_exist from user_indexes where index_name = 'IDX_QRTZ_FT_TRIG_VOLATILE';
	if quartz_index_exist = 1 then
		execute immediate 'DROP INDEX idx_qrtz_ft_trig_volatile';
	end if;
	select count(*)   into quartz_index_exist from user_indexes where index_name = 'IDX_QRTZ_FT_TRIG_INST_NAME';
	if quartz_index_exist = 1 then
		execute immediate 'DROP INDEX idx_qrtz_ft_trig_inst_name';
	end if;
	select count(*)   into quartz_index_exist from user_indexes where index_name = 'IDX_QRTZ_FT_JOB_NAME';
	if quartz_index_exist = 1 then
		execute immediate 'DROP INDEX idx_qrtz_ft_job_name';
	end if;
	select count(*)   into quartz_index_exist from user_indexes where index_name = 'IDX_QRTZ_FT_JOB_GROUP';
	if quartz_index_exist = 1 then
		execute immediate 'DROP INDEX idx_qrtz_ft_job_group';
	end if;
	select count(*)   into quartz_index_exist from user_indexes where index_name = 'IDX_QRTZ_FT_JOB_STATEFUL';
	if quartz_index_exist = 1 then
		execute immediate 'DROP INDEX idx_qrtz_ft_job_stateful';
	end if;
	select count(*)   into quartz_index_exist from user_indexes where index_name = 'IDX_QRTZ_FT_JOB_REQ_RECOVERY';
	if quartz_index_exist = 1 then
		execute immediate 'DROP INDEX idx_qrtz_ft_job_req_recovery';
	end if;
	select count(*)	into quartz_table_exist from user_tables where table_name = 'QRTZ_CALENDARS';
	if quartz_table_exist = 1 then
		execute immediate 'DROP TABLE qrtz_calendars CASCADE CONSTRAINTS';
	end if;
	select count(*)	into quartz_table_exist from user_tables where table_name = 'QRTZ_FIRED_TRIGGERS';
	if quartz_table_exist = 1 then
		execute immediate 'DROP TABLE qrtz_fired_triggers CASCADE CONSTRAINTS';
	end if;
	select count(*)	into quartz_table_exist from user_tables where table_name = 'QRTZ_TRIGGER_LISTENERS';
	if quartz_table_exist = 1 then
		execute immediate 'DROP TABLE qrtz_trigger_listeners CASCADE CONSTRAINTS';
	end if;
	select count(*)	into quartz_table_exist from user_tables where table_name = 'QRTZ_BLOB_TRIGGERS';
	if quartz_table_exist = 1 then
		execute immediate 'DROP TABLE qrtz_blob_triggers CASCADE CONSTRAINTS';
	end if;
	select count(*)	into quartz_table_exist from user_tables where table_name = 'QRTZ_CRON_TRIGGERS';
	if quartz_table_exist = 1 then
		execute immediate 'DROP TABLE qrtz_cron_triggers CASCADE CONSTRAINTS';
	end if;
	select count(*)	into quartz_table_exist from user_tables where table_name = 'QRTZ_SIMPLE_TRIGGERS';
	if quartz_table_exist = 1 then
		execute immediate 'DROP TABLE qrtz_simple_triggers CASCADE CONSTRAINTS';
	end if;
	select count(*)	into quartz_table_exist from user_tables where table_name = 'QRTZ_TRIGGERS';
	if quartz_table_exist = 1 then
		execute immediate 'DROP TABLE qrtz_triggers CASCADE CONSTRAINTS';
	end if;
	select count(*)	into quartz_table_exist from user_tables where table_name = 'QRTZ_JOB_LISTENERS';
	if quartz_table_exist = 1 then
		execute immediate 'DROP TABLE qrtz_job_listeners CASCADE CONSTRAINTS';
	end if;
	select count(*)	into quartz_table_exist from user_tables where table_name = 'QRTZ_JOB_DETAILS';
	if quartz_table_exist = 1 then
		execute immediate 'DROP TABLE qrtz_job_details CASCADE CONSTRAINTS';
	end if;
	select count(*)	into quartz_table_exist from user_tables where table_name = 'QRTZ_PAUSED_TRIGGER_GRPS';
	if quartz_table_exist = 1 then
		execute immediate 'DROP TABLE qrtz_paused_trigger_grps CASCADE CONSTRAINTS';
	end if;
	select count(*)	into quartz_table_exist from user_tables where table_name = 'QRTZ_LOCKS';
	if quartz_table_exist = 1 then
		execute immediate 'DROP TABLE qrtz_locks CASCADE CONSTRAINTS';
	end if;
	select count(*)	into quartz_table_exist from user_tables where table_name = 'QRTZ_SCHEDULER_STATE';
	if quartz_table_exist = 1 then
		execute immediate 'DROP TABLE qrtz_scheduler_state CASCADE CONSTRAINTS';
	end if;

	-- GC Procedures drop
	select count(*)   into proc_gc_id_exist from user_procedures where object_name = 'GARBAGECOLLECTBYID';
	if proc_gc_id_exist = 1 then
		execute immediate 'DROP PROCEDURE garbageCollectById';
	end if;

	select count(*)   into proc_gc_event_exist from user_procedures where object_name = 'GARBAGECOLLECTBYEVENTID';
	if proc_gc_event_exist = 1 then
		execute immediate 'DROP PROCEDURE garbageCollectByEventId';
	end if;

	select count(*)   into proc_gc_task_exist from user_procedures where object_name = 'GARBAGECOLLECTBYTASKID';
	if proc_gc_task_exist = 1 then
		execute immediate 'DROP PROCEDURE garbageCollectByTaskId';
	end if;

	select count(*)   into proc_gc_tp_exist from user_procedures where object_name = 'GARBAGECOLLECTTASKPERSISTENCE';
	if proc_gc_tp_exist = 1 then
		execute immediate 'DROP PROCEDURE garbageCollectTaskPersistence';
	end if;

END;
/
