
CREATE TABLE [dbo].[archive_runtimeStatusDetail12] (
    [id] [int] NOT NULL ,
    [originationTime] [datetime] NOT NULL ,
    [eventID] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
    [parentID] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
    [sourceIdentifier] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
    [serverName] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
    [provDomainName] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
    [displayName] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
    [description] [nvarchar] (2000) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
    [descriptionType] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
    [descriptionParam] [nvarchar] (1024) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
    [admindn] [nvarchar] (628) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
    [adminName] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[importance] [int] NULL
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[archive_runtimeStatusDetail12] WITH NOCHECK ADD
    CONSTRAINT [PK_archive_runtimeStatusDetail12] PRIMARY KEY NONCLUSTERED
    (
        [id]
    )  ON [PRIMARY]
GO


CREATE TABLE [dbo].[archive_rsdAttribute12] (
    [id] [int] NOT NULL ,
    [rsdid] [int] NOT NULL ,
    [profiletype] [int] NOT NULL ,
    [profilename] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
    [attrname] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
    [attrvalue] [nvarchar] (1024) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
    [status] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
    [attrType] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
    [additionalInfo] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL 
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[archive_rsdAttribute12] WITH NOCHECK ADD
    CONSTRAINT [PK_archive_rsdAttribute12] PRIMARY KEY NONCLUSTERED
    (
        [rsdid],
        [id]
    )  ON [PRIMARY]
GO

CREATE TABLE [dbo].[archive_event12_5] (
	[eventid] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[state] [int] NOT NULL ,
	[tasksessionid] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[created_on] [datetime] NOT NULL ,
	[last_access_time] [datetime] NOT NULL ,
	[name] [nvarchar] (512) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[description] [nvarchar] (2000) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[type] [int] NOT NULL ,
	[next_state] [int] NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[archive_event_object12_5] (
	[tasksessionid] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[eventid] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
    [object_type] [nvarchar] (128) NOT NULL ,
	[isprimary] [char] NOT NULL ,
    [object_uniquename] [nvarchar] (256) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[archive_object12_5] (
    [objectid] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
    [objecttype] [int] NOT NULL ,
    [object] [varbinary](max) NULL
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[archive_tasksession12_5] (
	[tasksessionid] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[state] [int] NOT NULL ,
	[created_time] [datetime] NOT NULL ,
	[last_access_time] [datetime] NOT NULL ,
	[user_dn] [nvarchar] (512) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[org_dn] [nvarchar] (512) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[environmentid] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[name] [nvarchar] (512) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[description] [nvarchar] (2000) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[acknowledged] [char] NOT NULL ,
	[parent_of_wf_id] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[action_type] [int] NOT NULL ,
	[priority] [int] NULL ,
	[initiatorid] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[nesting_type] [int] NOT NULL ,
    [next_state] [int] NULL 
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[archive_event12_5] WITH NOCHECK ADD 
	CONSTRAINT [PK_archive_event12_5] PRIMARY KEY  CLUSTERED 
	(
		[eventid]
	)  ON [PRIMARY]
GO 

ALTER TABLE [dbo].[archive_event_object12_5] WITH NOCHECK ADD 
	CONSTRAINT [PK_archive_event_object12_5] PRIMARY KEY  CLUSTERED 
	(
		[eventid],
        [object_type],
		[object_uniquename]
	)  ON [PRIMARY]
GO

ALTER TABLE [dbo].[archive_object12_5] WITH NOCHECK ADD 
    CONSTRAINT [PK_archive_object12_5] PRIMARY KEY  CLUSTERED 
    (
        [objectid],
        [objecttype]
    )  ON [PRIMARY]
GO

ALTER TABLE [dbo].[archive_tasksession12_5] WITH NOCHECK ADD 
	CONSTRAINT [PK_archive_tasksession12_5] PRIMARY KEY  CLUSTERED 
	(
		[tasksessionid]
	)  ON [PRIMARY]
GO 

ALTER TABLE [dbo].[archive_event12_5] ADD 
	CONSTRAINT [FK_archive_event12_5_archive_tasksession12_5] FOREIGN KEY 
	(
		[tasksessionid]
	) REFERENCES [dbo].[archive_tasksession12_5] (
		[tasksessionid]
	)
GO

ALTER TABLE [dbo].[archive_tasksession12_5] ADD 
	CONSTRAINT [FK_archive_tasksession12_5_archive_tasksession12_5] FOREIGN KEY 
	(
		[initiatorid]
	) REFERENCES [dbo].[archive_tasksession12_5] (
		[tasksessionid]
	)
GO

ALTER TABLE [dbo].[archive_event_object12_5] ADD 
	CONSTRAINT [FK_archive_event_object12_5_archive_event12_5] FOREIGN KEY 
	(
		[eventid]
	) REFERENCES [dbo].[archive_event12_5] (
		[eventid]
	)
GO
