-- Runtime status detail related schema objects.

CREATE TABLE [dbo].[runtimeStatusDetail12] (
    [id] [int] IDENTITY (1, 1) NOT NULL ,
    [originationTime] [datetime] NOT NULL ,
    [eventID] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
    [parentID] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
    [sourceIdentifier] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
    [serverName] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
    [provDomainName] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
    [displayName] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
    [description] [nvarchar] (2000) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
    [descriptionType] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
    [descriptionParam] [nvarchar] (1024) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
    [admindn] [nvarchar] (628) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
    [adminName] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[importance] [int] NULL
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[runtimeStatusDetail12] WITH NOCHECK ADD
    CONSTRAINT [PK_runtimeStatusDetail12] PRIMARY KEY NONCLUSTERED
    (
        [id]
    )  ON [PRIMARY]
GO


CREATE TABLE [dbo].[runtimeStatusDetailAttribute12] (
    [id] [int] IDENTITY (1, 1) NOT NULL ,
    [rsdid] [int] NOT NULL ,
    [profiletype] [int] NOT NULL ,
    [profilename] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
    [attrname] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
    [attrvalue] [nvarchar] (1024) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
    [status] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
    [attrType] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
    [additionalInfo] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL 
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[runtimeStatusDetailAttribute12] WITH NOCHECK ADD
    CONSTRAINT [PK_runtimeStatusDetailAttribute12] PRIMARY KEY NONCLUSTERED
    (
        [rsdid],
        [id]
    )  ON [PRIMARY]
GO

CREATE PROCEDURE insertRuntimeStatusDetail(
        @originationTime datetime,
                  @eventID varchar(255),
                  @parentID varchar(255),
                  @sourceIdentifier nvarchar(255),
                  @serverName nvarchar(255),
                  @provDomainName nvarchar(255),
                  @displayName nvarchar(255),
                  @description nvarchar(2000),
                  @descriptionType varchar(255),
                  @descriptionParam nvarchar(1024),
                  @admindn nvarchar(628),
                  @adminName nvarchar(255),
		        @importance integer,
         @current_id INTEGER OUTPUT)
AS
BEGIN
 insert into runtimeStatusDetail12 (
           originationTime,
                     eventID,
                     parentID,
                     sourceIdentifier,
                     serverName,
                     provDomainName,
                     displayName,
                     description,
					 					 descriptionType,
					 					 descriptionParam,
                     admindn,
                     adminName,
					importance
			)

            values (
           @originationTime,
                     @eventID,
                     @parentID,
                     @sourceIdentifier,
                     @serverName,
                     @provDomainName,
                     @displayName,
                     @description,
                     @descriptionType,
					           @descriptionParam,
                     @admindn,
                     @adminName,
		            @importance
			);

    SELECT @current_id=IDENT_CURRENT('runtimeStatusDetail12');
END
GO


CREATE PROCEDURE insertRuntimeStatusDetailAttr(
        @rsdid integer,
        @profiletype integer,
        @profilename nvarchar(255),
        @attrname nvarchar(255),
        @attrvalue nvarchar(1024),
        @status nvarchar(255),
        @attrType varchar(255),
        @additionalInfo nvarchar(255))
AS
BEGIN
 insert into runtimeStatusDetailAttribute12 (
            rsdid,
            profiletype,
            profilename,
            attrname,
            attrvalue,
            status,
            attrType,
            additionalInfo
            )

            values (
            @rsdid,
            @profiletype,
            @profilename,
            @attrname,
            @attrvalue,
            @status,
            @attrType,
            @additionalInfo);
END
GO

CREATE TABLE [dbo].[event12_5] (
	[eventid] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[state] [int] NOT NULL ,
	[tasksessionid] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[created_on] [datetime] NOT NULL ,
	[last_access_time] [datetime] NOT NULL ,
	[name] [nvarchar] (512) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[description] [nvarchar] (2000) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[type] [int] NOT NULL ,
	[next_state] [int] NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[event_object12_5] (
	[tasksessionid] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[eventid] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
    [object_type] [nvarchar] (128) NOT NULL ,
	[isprimary] [char] NOT NULL ,
    [object_uniquename] [nvarchar] (256) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[lock12_5] (
	[lockid] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
    [lockinfo] [nvarchar] (400) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[object12_5] (
    [objectid] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
    [objecttype] [int] NOT NULL ,
    [object] [varbinary](max) NULL
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[tasksession12_5] (
	[tasksessionid] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[state] [int] NOT NULL ,
	[created_time] [datetime] NOT NULL ,
	[last_access_time] [datetime] NOT NULL ,
	[user_dn] [nvarchar] (512) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[org_dn] [nvarchar] (512) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[environmentid] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[name] [nvarchar] (512) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[description] [nvarchar] (2000) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[acknowledged] [char] NOT NULL ,
	[parent_of_wf_id] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[action_type] [int] NOT NULL ,
	[priority] [int] NULL ,
	[initiatorid] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[nesting_type] [int] NOT NULL ,
    [next_state] [int] NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[tp_version] (
    [tp_key] nvarchar(255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
    [tp_value] nvarchar(255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[AuxData12] (
	[Id] [int] IDENTITY(1,1) NOT NULL,
	[EnvOID] [nvarchar](64) NOT NULL,
	[ParentId] [int] NULL,
	[Precedence] [int] NULL,
	[ProviderId] [int] NULL,
	[Name] [nvarchar](255) NOT NULL,
	[Type] [nvarchar](255) NOT NULL,
	[DisplayName] [nvarchar](255) NULL
) ON [PRIMARY]
GO

create index [idx_ts12_5_initiatorid] on [dbo].[tasksession12_5] ([initiatorid])
GO
create index [idx_event12_5_tasksessionid] on [dbo].[event12_5] ([tasksessionid])
GO
create index [idx_rtmstatusdetail12_eventid] on [dbo].[runtimestatusdetail12] ([eventid])
GO

CREATE PROCEDURE insertAuxData(
        @envOID nvarchar(64),
        @parentID int,
        @precedence int,
        @providerID int,
        @name nvarchar(255),
        @type nvarchar(255),
        @displayName nvarchar(255),
        @current_id INTEGER OUTPUT)
AS
BEGIN
 insert into AuxData12 (
        EnvOID,
        ParentId,
        Precedence,
        ProviderId,
        Name,
        Type,
        DisplayName
  )
  values (
        @envOID,
        @parentID,
        @precedence,
        @providerID,
        @name,
        @type,
        @displayName
  );
  
  SELECT @current_id=IDENT_CURRENT('AuxData12');
END
GO

CREATE TABLE [dbo].[AuxDataProviders12](
	[Id] [int] IDENTITY(1,1) NOT NULL,
	[EnvOID] [nvarchar](64) NOT NULL,
	[Type] [int] NOT NULL,
	[DisplayName] [nvarchar](255) NOT NULL,
	[Precedence] [int] NOT NULL,
	[Description] [nvarchar](255) NULL,
	[NodeId] [int] NULL,
	[FileName] [nvarchar](255) NULL,
	[ClassName] [nvarchar](255) NULL
) ON [PRIMARY]
GO

CREATE PROCEDURE insertAuxDataProvider (
        @envOID nvarchar(64),
        @type int,
        @displayName nvarchar(255),
        @precedence int,
        @description nvarchar(255),
        @nodeID int,
        @fileName nvarchar(255),
        @className nvarchar(255),
        @current_id INTEGER OUTPUT)
AS
BEGIN
 insert into AuxDataProviders12 (
        EnvOID,
        Type,
        DisplayName,
        Precedence,
        Description,
        NodeId,
        FileName,
        ClassName
  )
  values (
        @envOID,
        @type,
        @displayName,
        @precedence,
        @description,
        @nodeID,
        @fileName,
        @className
  );

  SELECT @current_id=IDENT_CURRENT('AuxDataProviders12');
END
GO

ALTER TABLE [dbo].[event12_5] WITH NOCHECK ADD 
	CONSTRAINT [PK_event12_5] PRIMARY KEY  CLUSTERED 
	(
		[eventid]
	)  ON [PRIMARY]
GO 

ALTER TABLE [dbo].[event_object12_5] WITH NOCHECK ADD 
	CONSTRAINT [PK_event_object12_5] PRIMARY KEY  CLUSTERED 
	(
		[eventid],
        [object_type],
		[object_uniquename]
	)  ON [PRIMARY]
GO

ALTER TABLE [dbo].[lock12_5] WITH NOCHECK ADD 
	CONSTRAINT [PK_lock12_5] PRIMARY KEY  CLUSTERED 
	(
		[lockid],
		[lockinfo]
	)  ON [PRIMARY]
GO 

ALTER TABLE [dbo].[object12_5] WITH NOCHECK ADD 
    CONSTRAINT [PK_object12_5] PRIMARY KEY  CLUSTERED 
    (
        [objectid],
        [objecttype]
    )  ON [PRIMARY]
GO

ALTER TABLE [dbo].[tasksession12_5] WITH NOCHECK ADD 
	CONSTRAINT [PK_tasksession12_5] PRIMARY KEY  CLUSTERED 
	(
		[tasksessionid]
	)  ON [PRIMARY]
GO 

ALTER TABLE [dbo].[event12_5] ADD 
	CONSTRAINT [FK_event12_5_tasksession12_5] FOREIGN KEY 
	(
		[tasksessionid]
	) REFERENCES [dbo].[tasksession12_5] (
		[tasksessionid]
	)
GO

ALTER TABLE [dbo].[tasksession12_5] ADD 
	CONSTRAINT [FK_tasksession12_5_tasksession12_5] FOREIGN KEY 
	(
		[initiatorid]
	) REFERENCES [dbo].[tasksession12_5] (
		[tasksessionid]
	)
GO

ALTER TABLE [dbo].[event_object12_5] ADD 
	CONSTRAINT [FK_event_object12_5_event12_5] FOREIGN KEY 
	(
		[eventid]
	) REFERENCES [dbo].[event12_5] (
		[eventid]
	)
GO

ALTER TABLE [dbo].[tp_version] WITH NOCHECK ADD 
    CONSTRAINT [PK_tp_version] PRIMARY KEY  CLUSTERED 
    (
        [tp_key]
    )  ON [PRIMARY]
GO

insert into [dbo].[tp_version]([tp_key],[tp_value]) values ('version','12.6.2.0.0')
GO

ALTER TABLE [dbo].[AuxDataProviders12] WITH NOCHECK ADD 
	CONSTRAINT [PK_AuxDataProviders12] PRIMARY KEY  CLUSTERED 
	(
		[Id]
	)  ON [PRIMARY]
GO 

ALTER TABLE [dbo].[AuxData12] WITH NOCHECK ADD 
	CONSTRAINT [PK_AuxData12] PRIMARY KEY  CLUSTERED 
	(
		[Id]
	)  ON [PRIMARY]
GO

ALTER TABLE [dbo].[AuxData12] ADD 
	CONSTRAINT [FK_AuxData12_parent] FOREIGN KEY 
	(
		[ParentId]
	) REFERENCES [dbo].[AuxData12] (
		[Id]
	)
GO

ALTER TABLE [dbo].[AuxData12] ADD 
	CONSTRAINT [FK_AuxData12_provider] FOREIGN KEY 
	(
		[ProviderId]
	) REFERENCES [dbo].[AuxDataProviders12] (
		[Id]
	)
GO

ALTER TABLE [dbo].[AuxDataProviders12] ADD 
	CONSTRAINT [FK_AuxDataProviders12_rootNode] FOREIGN KEY 
	(
		[NodeId]
	) REFERENCES [dbo].[AuxData12] (
		[Id]
	)
GO

-- Quartz 1.7.3 db sql begin
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_QRTZ_JOB_LISTENERS_QRTZ_JOB_DETAILS]') AND OBJECTPROPERTY(id, N'ISFOREIGNKEY') = 1)
ALTER TABLE [dbo].[QRTZ_JOB_LISTENERS] DROP CONSTRAINT FK_QRTZ_JOB_LISTENERS_QRTZ_JOB_DETAILS
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_QRTZ_TRIGGERS_QRTZ_JOB_DETAILS]') AND OBJECTPROPERTY(id, N'ISFOREIGNKEY') = 1)
ALTER TABLE [dbo].[QRTZ_TRIGGERS] DROP CONSTRAINT FK_QRTZ_TRIGGERS_QRTZ_JOB_DETAILS
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_QRTZ_CRON_TRIGGERS_QRTZ_TRIGGERS]') AND OBJECTPROPERTY(id, N'ISFOREIGNKEY') = 1)
ALTER TABLE [dbo].[QRTZ_CRON_TRIGGERS] DROP CONSTRAINT FK_QRTZ_CRON_TRIGGERS_QRTZ_TRIGGERS
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_QRTZ_SIMPLE_TRIGGERS_QRTZ_TRIGGERS]') AND OBJECTPROPERTY(id, N'ISFOREIGNKEY') = 1)
ALTER TABLE [dbo].[QRTZ_SIMPLE_TRIGGERS] DROP CONSTRAINT FK_QRTZ_SIMPLE_TRIGGERS_QRTZ_TRIGGERS
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_QRTZ_TRIGGER_LISTENERS_QRTZ_TRIGGERS]') AND OBJECTPROPERTY(id, N'ISFOREIGNKEY') = 1)
ALTER TABLE [dbo].[QRTZ_TRIGGER_LISTENERS] DROP CONSTRAINT FK_QRTZ_TRIGGER_LISTENERS_QRTZ_TRIGGERS
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[QRTZ_CALENDARS]') AND OBJECTPROPERTY(id, N'ISUSERTABLE') = 1)
DROP TABLE [dbo].[QRTZ_CALENDARS]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[QRTZ_CRON_TRIGGERS]') AND OBJECTPROPERTY(id, N'ISUSERTABLE') = 1)
DROP TABLE [dbo].[QRTZ_CRON_TRIGGERS]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[QRTZ_BLOB_TRIGGERS]') AND OBJECTPROPERTY(id, N'ISUSERTABLE') = 1)
DROP TABLE [dbo].[QRTZ_BLOB_TRIGGERS]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[QRTZ_FIRED_TRIGGERS]') AND OBJECTPROPERTY(id, N'ISUSERTABLE') = 1)
DROP TABLE [dbo].[QRTZ_FIRED_TRIGGERS]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[QRTZ_PAUSED_TRIGGER_GRPS]') AND OBJECTPROPERTY(id, N'ISUSERTABLE') = 1)
DROP TABLE [dbo].[QRTZ_PAUSED_TRIGGER_GRPS]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[QRTZ_SCHEDULER_STATE]') AND OBJECTPROPERTY(id, N'ISUSERTABLE') = 1)
DROP TABLE [dbo].[QRTZ_SCHEDULER_STATE]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[QRTZ_LOCKS]') AND OBJECTPROPERTY(id, N'ISUSERTABLE') = 1)
DROP TABLE [dbo].[QRTZ_LOCKS]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[QRTZ_JOB_DETAILS]') AND OBJECTPROPERTY(id, N'ISUSERTABLE') = 1)
DROP TABLE [dbo].[QRTZ_JOB_DETAILS]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[QRTZ_JOB_LISTENERS]') AND OBJECTPROPERTY(id, N'ISUSERTABLE') = 1)
DROP TABLE [dbo].[QRTZ_JOB_LISTENERS]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[QRTZ_SIMPLE_TRIGGERS]') AND OBJECTPROPERTY(id, N'ISUSERTABLE') = 1)
DROP TABLE [dbo].[QRTZ_SIMPLE_TRIGGERS]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[QRTZ_TRIGGER_LISTENERS]') AND OBJECTPROPERTY(id, N'ISUSERTABLE') = 1)
DROP TABLE [dbo].[QRTZ_TRIGGER_LISTENERS]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[QRTZ_TRIGGERS]') AND OBJECTPROPERTY(id, N'ISUSERTABLE') = 1)
DROP TABLE [dbo].[QRTZ_TRIGGERS]
GO

CREATE TABLE [dbo].[QRTZ_CALENDARS] (
  [CALENDAR_NAME] [VARCHAR] (200)  NOT NULL ,
  [CALENDAR] [IMAGE] NOT NULL
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[QRTZ_CRON_TRIGGERS] (
  [TRIGGER_NAME] [VARCHAR] (200)  NOT NULL ,
  [TRIGGER_GROUP] [VARCHAR] (200)  NOT NULL ,
  [CRON_EXPRESSION] [VARCHAR] (120)  NOT NULL ,
  [TIME_ZONE_ID] [VARCHAR] (80) 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[QRTZ_FIRED_TRIGGERS] (
  [ENTRY_ID] [VARCHAR] (95)  NOT NULL ,
  [TRIGGER_NAME] [VARCHAR] (200)  NOT NULL ,
  [TRIGGER_GROUP] [VARCHAR] (200)  NOT NULL ,
  [IS_VOLATILE] [VARCHAR] (1)  NOT NULL ,
  [INSTANCE_NAME] [VARCHAR] (200)  NOT NULL ,
  [FIRED_TIME] [BIGINT] NOT NULL ,
  [PRIORITY] [INTEGER] NOT NULL ,
  [STATE] [VARCHAR] (16)  NOT NULL,
  [JOB_NAME] [VARCHAR] (200)  NULL ,
  [JOB_GROUP] [VARCHAR] (200)  NULL ,
  [IS_STATEFUL] [VARCHAR] (1)  NULL ,
  [REQUESTS_RECOVERY] [VARCHAR] (1)  NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[QRTZ_PAUSED_TRIGGER_GRPS] (
  [TRIGGER_GROUP] [VARCHAR] (200)  NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[QRTZ_SCHEDULER_STATE] (
  [INSTANCE_NAME] [VARCHAR] (200)  NOT NULL ,
  [LAST_CHECKIN_TIME] [BIGINT] NOT NULL ,
  [CHECKIN_INTERVAL] [BIGINT] NOT NULL
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[QRTZ_LOCKS] (
  [LOCK_NAME] [VARCHAR] (40)  NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[QRTZ_JOB_DETAILS] (
  [JOB_NAME] [VARCHAR] (200)  NOT NULL ,
  [JOB_GROUP] [VARCHAR] (200)  NOT NULL ,
  [DESCRIPTION] [VARCHAR] (250) NULL ,
  [JOB_CLASS_NAME] [VARCHAR] (250)  NOT NULL ,
  [IS_DURABLE] [VARCHAR] (1)  NOT NULL ,
  [IS_VOLATILE] [VARCHAR] (1)  NOT NULL ,
  [IS_STATEFUL] [VARCHAR] (1)  NOT NULL ,
  [REQUESTS_RECOVERY] [VARCHAR] (1)  NOT NULL ,
  [JOB_DATA] [IMAGE] NULL
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[QRTZ_JOB_LISTENERS] (
  [JOB_NAME] [VARCHAR] (200)  NOT NULL ,
  [JOB_GROUP] [VARCHAR] (200)  NOT NULL ,
  [JOB_LISTENER] [VARCHAR] (200)  NOT NULL
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[QRTZ_SIMPLE_TRIGGERS] (
  [TRIGGER_NAME] [VARCHAR] (200)  NOT NULL ,
  [TRIGGER_GROUP] [VARCHAR] (200)  NOT NULL ,
  [REPEAT_COUNT] [BIGINT] NOT NULL ,
  [REPEAT_INTERVAL] [BIGINT] NOT NULL ,
  [TIMES_TRIGGERED] [BIGINT] NOT NULL
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[QRTZ_BLOB_TRIGGERS] (
  [TRIGGER_NAME] [VARCHAR] (200)  NOT NULL ,
  [TRIGGER_GROUP] [VARCHAR] (200)  NOT NULL ,
  [BLOB_DATA] [IMAGE] NULL
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[QRTZ_TRIGGER_LISTENERS] (
  [TRIGGER_NAME] [VARCHAR] (200)  NOT NULL ,
  [TRIGGER_GROUP] [VARCHAR] (200)  NOT NULL ,
  [TRIGGER_LISTENER] [VARCHAR] (200)  NOT NULL
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[QRTZ_TRIGGERS] (
  [TRIGGER_NAME] [VARCHAR] (200)  NOT NULL ,
  [TRIGGER_GROUP] [VARCHAR] (200)  NOT NULL ,
  [JOB_NAME] [VARCHAR] (200)  NOT NULL ,
  [JOB_GROUP] [VARCHAR] (200)  NOT NULL ,
  [IS_VOLATILE] [VARCHAR] (1)  NOT NULL ,
  [DESCRIPTION] [VARCHAR] (250) NULL ,
  [NEXT_FIRE_TIME] [BIGINT] NULL ,
  [PREV_FIRE_TIME] [BIGINT] NULL ,
  [PRIORITY] [INTEGER] NULL ,
  [TRIGGER_STATE] [VARCHAR] (16)  NOT NULL ,
  [TRIGGER_TYPE] [VARCHAR] (8)  NOT NULL ,
  [START_TIME] [BIGINT] NOT NULL ,
  [END_TIME] [BIGINT] NULL ,
  [CALENDAR_NAME] [VARCHAR] (200)  NULL ,
  [MISFIRE_INSTR] [SMALLINT] NULL ,
  [JOB_DATA] [IMAGE] NULL
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[QRTZ_CALENDARS] WITH NOCHECK ADD
  CONSTRAINT [PK_QRTZ_CALENDARS] PRIMARY KEY  CLUSTERED
  (
    [CALENDAR_NAME]
  )  ON [PRIMARY]
GO

ALTER TABLE [dbo].[QRTZ_CRON_TRIGGERS] WITH NOCHECK ADD
  CONSTRAINT [PK_QRTZ_CRON_TRIGGERS] PRIMARY KEY  CLUSTERED
  (
    [TRIGGER_NAME],
    [TRIGGER_GROUP]
  )  ON [PRIMARY]
GO

ALTER TABLE [dbo].[QRTZ_FIRED_TRIGGERS] WITH NOCHECK ADD
  CONSTRAINT [PK_QRTZ_FIRED_TRIGGERS] PRIMARY KEY  CLUSTERED
  (
    [ENTRY_ID]
  )  ON [PRIMARY]
GO

ALTER TABLE [dbo].[QRTZ_PAUSED_TRIGGER_GRPS] WITH NOCHECK ADD
  CONSTRAINT [PK_QRTZ_PAUSED_TRIGGER_GRPS] PRIMARY KEY  CLUSTERED
  (
    [TRIGGER_GROUP]
  )  ON [PRIMARY]
GO

ALTER TABLE [dbo].[QRTZ_SCHEDULER_STATE] WITH NOCHECK ADD
  CONSTRAINT [PK_QRTZ_SCHEDULER_STATE] PRIMARY KEY  CLUSTERED
  (
    [INSTANCE_NAME]
  )  ON [PRIMARY]
GO

ALTER TABLE [dbo].[QRTZ_LOCKS] WITH NOCHECK ADD
  CONSTRAINT [PK_QRTZ_LOCKS] PRIMARY KEY  CLUSTERED
  (
    [LOCK_NAME]
  )  ON [PRIMARY]
GO

ALTER TABLE [dbo].[QRTZ_JOB_DETAILS] WITH NOCHECK ADD
  CONSTRAINT [PK_QRTZ_JOB_DETAILS] PRIMARY KEY  CLUSTERED
  (
    [JOB_NAME],
    [JOB_GROUP]
  )  ON [PRIMARY]
GO

ALTER TABLE [dbo].[QRTZ_JOB_LISTENERS] WITH NOCHECK ADD
  CONSTRAINT [PK_QRTZ_JOB_LISTENERS] PRIMARY KEY  CLUSTERED
  (
    [JOB_NAME],
    [JOB_GROUP],
    [JOB_LISTENER]
  )  ON [PRIMARY]
GO

ALTER TABLE [dbo].[QRTZ_SIMPLE_TRIGGERS] WITH NOCHECK ADD
  CONSTRAINT [PK_QRTZ_SIMPLE_TRIGGERS] PRIMARY KEY  CLUSTERED
  (
    [TRIGGER_NAME],
    [TRIGGER_GROUP]
  )  ON [PRIMARY]
GO

ALTER TABLE [dbo].[QRTZ_TRIGGER_LISTENERS] WITH NOCHECK ADD
  CONSTRAINT [PK_QRTZ_TRIGGER_LISTENERS] PRIMARY KEY  CLUSTERED
  (
    [TRIGGER_NAME],
    [TRIGGER_GROUP],
    [TRIGGER_LISTENER]
  )  ON [PRIMARY]
GO

ALTER TABLE [dbo].[QRTZ_TRIGGERS] WITH NOCHECK ADD
  CONSTRAINT [PK_QRTZ_TRIGGERS] PRIMARY KEY  CLUSTERED
  (
    [TRIGGER_NAME],
    [TRIGGER_GROUP]
  )  ON [PRIMARY]
GO

ALTER TABLE [dbo].[QRTZ_CRON_TRIGGERS] ADD
  CONSTRAINT [FK_QRTZ_CRON_TRIGGERS_QRTZ_TRIGGERS] FOREIGN KEY
  (
    [TRIGGER_NAME],
    [TRIGGER_GROUP]
  ) REFERENCES [dbo].[QRTZ_TRIGGERS] (
    [TRIGGER_NAME],
    [TRIGGER_GROUP]
  ) ON DELETE CASCADE
GO

ALTER TABLE [dbo].[QRTZ_JOB_LISTENERS] ADD
  CONSTRAINT [FK_QRTZ_JOB_LISTENERS_QRTZ_JOB_DETAILS] FOREIGN KEY
  (
    [JOB_NAME],
    [JOB_GROUP]
  ) REFERENCES [dbo].[QRTZ_JOB_DETAILS] (
    [JOB_NAME],
    [JOB_GROUP]
  ) ON DELETE CASCADE
GO

ALTER TABLE [dbo].[QRTZ_SIMPLE_TRIGGERS] ADD
  CONSTRAINT [FK_QRTZ_SIMPLE_TRIGGERS_QRTZ_TRIGGERS] FOREIGN KEY
  (
    [TRIGGER_NAME],
    [TRIGGER_GROUP]
  ) REFERENCES [dbo].[QRTZ_TRIGGERS] (
    [TRIGGER_NAME],
    [TRIGGER_GROUP]
  ) ON DELETE CASCADE
GO

ALTER TABLE [dbo].[QRTZ_TRIGGER_LISTENERS] ADD
  CONSTRAINT [FK_QRTZ_TRIGGER_LISTENERS_QRTZ_TRIGGERS] FOREIGN KEY
  (
    [TRIGGER_NAME],
    [TRIGGER_GROUP]
  ) REFERENCES [dbo].[QRTZ_TRIGGERS] (
    [TRIGGER_NAME],
    [TRIGGER_GROUP]
  ) ON DELETE CASCADE
GO

ALTER TABLE [dbo].[QRTZ_TRIGGERS] ADD
  CONSTRAINT [FK_QRTZ_TRIGGERS_QRTZ_JOB_DETAILS] FOREIGN KEY
  (
    [JOB_NAME],
    [JOB_GROUP]
  ) REFERENCES [dbo].[QRTZ_JOB_DETAILS] (
    [JOB_NAME],
    [JOB_GROUP]
  )
GO

INSERT INTO [dbo].[QRTZ_LOCKS] VALUES('TRIGGER_ACCESS');
INSERT INTO [dbo].[QRTZ_LOCKS] VALUES('JOB_ACCESS');
INSERT INTO [dbo].[QRTZ_LOCKS] VALUES('CALENDAR_ACCESS');
INSERT INTO [dbo].[QRTZ_LOCKS] VALUES('STATE_ACCESS');
INSERT INTO [dbo].[QRTZ_LOCKS] VALUES('MISFIRE_ACCESS');
GO

-- Quartz 1.7.3 db sql end
--  


-- Garbage Collection - start
--

--
-- garbageCollectById
--

IF EXISTS (SELECT name FROM sysobjects
      WHERE name = 'garbageCollectById' AND type = 'P')
   DROP PROCEDURE garbageCollectById
GO

CREATE PROCEDURE
garbageCollectById 
	@workingId VARCHAR(255)
AS
BEGIN
	PRINT 'GC ID ' + @workingId;

	-- garbage collect locks
	DELETE FROM lock12_5 
	WHERE lockid = @workingId;

	-- garbage collect runtme status details attributes
	DELETE FROM runtimeStatusDetailAttribute12
	WHERE rsdid IN (SELECT runtimeStatusDetail12.id FROM runtimeStatusDetail12 WHERE eventID = @workingId);

	-- garbage collect runtme status details 
	DELETE FROM runtimeStatusDetail12 
	WHERE eventID = @workingId;

	-- garbage collect object12_5
	DELETE FROM object12_5
	WHERE objectid = @workingId;

END --garbageCollectById
GO

--
-- garbageCollectByEventId
--
IF EXISTS (SELECT name FROM sysobjects
      WHERE name = 'garbageCollectByEventId' AND type = 'P')
   DROP PROCEDURE garbageCollectByEventId
GO

CREATE PROCEDURE
garbageCollectByEventId 
@event_id VARCHAR(255)
AS
BEGIN
	PRINT 'GC event ID ' + @event_id;

	EXEC garbageCollectById @event_id;
	
	-- garbage collect event_object12_5
	DELETE FROM event_object12_5 
	WHERE eventid = @event_id;
	
	-- garbage colelct event_object12_5
	DELETE FROM event12_5 
	WHERE eventid = @event_id;

END --garbageCollectByEventId
GO

--
-- garbageCollectByTaskId
--
IF EXISTS (SELECT name FROM sysobjects
      WHERE name = 'garbageCollectByTaskId' AND type = 'P')
   DROP PROCEDURE garbageCollectByTaskId
GO

CREATE PROCEDURE
garbageCollectByTaskId 
@task_id VARCHAR(255)
AS
	DECLARE @workingId VARCHAR(255);

	-- nested tasks for removal
	DECLARE tasksCoursor CURSOR LOCAL FOR
		SELECT tasksessionid 
		FROM tasksession12_5 
		WHERE initiatorid = @task_id AND tasksessionid != initiatorid;

	-- events for removal
	DECLARE eventCoursor CURSOR LOCAL FOR
		SELECT eventid
		FROM event12_5
		WHERE tasksessionid = @task_id;
BEGIN

	PRINT 'GC task ID ' + @task_id;
	
	-- garbage collect nested tasks first
	OPEN tasksCoursor;
	WHILE 1 = 1 
	BEGIN
		FETCH NEXT FROM tasksCoursor INTO @workingId;
		IF @@FETCH_STATUS <> 0 BREAK;  -- exit loop if condition is true
		EXEC garbageCollectByTaskId @workingId;
	END
	CLOSE tasksCoursor;
	DEALLOCATE tasksCoursor;

	OPEN eventCoursor;
	WHILE 1 = 1 
	BEGIN 
		FETCH NEXT FROM eventCoursor INTO @workingId;
		IF @@FETCH_STATUS <> 0 BREAK;  -- exit loop if condition is true
		EXEC garbageCollectByEventId @workingId;
	END
	CLOSE eventCoursor;
	DEALLOCATE eventCoursor;
	
	EXEC garbageCollectById @task_id;
	
	-- garbage collect from tasksession12_5;
	DELETE FROM tasksession12_5
	WHERE tasksessionid = @task_id;
	

END --garbageCollectByTaskId
GO
--
--	garbageCollectTaskPersistence
--
IF EXISTS (SELECT name FROM sysobjects
      WHERE name = 'garbageCollectTaskPersistence' AND type = 'P')
   DROP PROCEDURE garbageCollectTaskPersistence
GO

CREATE PROCEDURE garbageCollectTaskPersistence
@ime_id VARCHAR(50),
@cutoff_time DATETIME,
@audit_timeout_days FLOAT = 1,
@chunk_rec_count int =500
AS
	DECLARE @gcTaskId VARCHAR(255);
	DECLARE @counter int;
	DECLARE @transactionsCount int;
	declare @Error int

	DECLARE gcTasksCoursor CURSOR LOCAL FOR
			SELECT tasksessionid 
		FROM tasksession12_5 
		WHERE environmentid = @ime_id 
			AND (
					(
						(
						
							(tasksession12_5.state = 512) --   mark for deletion 
							OR (tasksession12_5.state = 128) --  completed  
							OR (tasksession12_5.state = 256) --  cancelled   
							OR (tasksession12_5.state = 32) -- rejected   
							OR (tasksession12_5.state = 2) -- invalid   
							OR (tasksession12_5.state = 1048576) --  task aborted 
						)
						AND last_access_time < @cutoff_time 
					)
					OR
					(
						tasksession12_5.state = 16384 -- audit state
						AND last_access_time < 
							CASE WHEN @cutoff_time < (GETDATE() - @audit_timeout_days) THEN @cutoff_time ELSE GETDATE() -@audit_timeout_days END
					)
				)
			AND (initiatorid IS NULL OR initiatorid = tasksessionid);

BEGIN
	set @counter = 0;
	OPEN gcTasksCoursor;
	begin transaction;
	WHILE 1 = 1 
	BEGIN
		FETCH NEXT FROM gcTasksCoursor INTO @gcTaskId;
		IF @@FETCH_STATUS <> 0 BREAK;  -- exit loop if condition is true
		set @counter = @counter +1;
		EXEC garbageCollectByTaskId @gcTaskId;
	    set @Error = @@ERROR
	    if @Error <> 0 --if error is raised
  		  goto LogError

		IF (@counter = @chunk_rec_count)
		BEGIN
			commit;
			set @counter = 0;
			begin transaction;
		END
	END

	if (@counter > 0)
		commit;
	set @transactionsCount = @@trancount;
	if (@transactionsCount >0)
		commit;
	CLOSE gcTasksCoursor;
	DEALLOCATE gcTasksCoursor;
	goto ProcEnd
LogError:
	set @transactionsCount = @@trancount;
	if (@transactionsCount >0)
		rollback transaction

ProcEnd:


END --garbageCollectTaskPersistence
GO
-- 
-- Garbage Collection - end
--
